<?php

$SQL[] = "CREATE TABLE ibf_awards_upgrade_history (
  awards_upgrade_id int(10) NOT NULL auto_increment,
  awards_version_id int(10) NOT NULL default '0',
  awards_version_human varchar(200) NOT NULL default '',
  awards_upgrade_date int(10) NOT NULL default '0',
  awards_upgrade_mid int(10) NOT NULL default '0',
  awards_upgrade_notes text NOT NULL,
  PRIMARY KEY  (awards_upgrade_id)
) TYPE=MyISAM AUTO_INCREMENT=1 ;";

$SQL[] = "CREATE TABLE `ibf_awards` (
  `aid` smallint(6) NOT NULL auto_increment,
  `mid` bigint(10) NOT NULL default '0',
  `cid` varchar(50) NOT NULL default '0',
  `awards_id` int(10) NOT NULL default '0',
  `mname` varchar(255) NOT NULL default '',
  `reason` text NOT NULL,
  `edit_time` int(10) NOT NULL default '0',
  `edit_mid` int(10) NOT NULL default '0',
  `add_mem_award_time` int(10) NOT NULL default '0',
  `comments` int(10) NOT NULL default '0',
  `comments_mail_last_send` int(10) NOT NULL default '0',
  PRIMARY KEY  (`aid`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;";

$SQL[] = "CREATE TABLE ibf_awards_info (
  id smallint(6) NOT NULL auto_increment,
  title varchar(100) NOT NULL default '',
  img varchar(100) NOT NULL default '',
  img_h int(10) NOT NULL default '0',
  img_w int(10) NOT NULL default '0',
  img_thumbnail varchar(100) NOT NULL default '',
  thumbnail_h int(10) NOT NULL default '0',
  thumbnail_w int(10) NOT NULL default '0',
  awards_status TINYINT( 1 ) NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM AUTO_INCREMENT=1 ;";

$SQL[] = "CREATE TABLE `ibf_awards_comments` (
  `pid` int(10) NOT NULL auto_increment,
  `append_edit` tinyint(1) default '0',
  `edit_time` int(10) default NULL,
  `author_id` mediumint(8) NOT NULL default '0',
  `author_name` varchar(32) default NULL,
  `use_sig` tinyint(1) NOT NULL default '0',
  `use_emo` tinyint(1) NOT NULL default '0',
  `ip_address` varchar(16) NOT NULL default '',
  `post_date` int(10) default NULL,
  `comment` text,
  `approved` tinyint(1) default NULL,
  `award_id` int(10) NOT NULL default '0',
  `award_info_id` int(10) NOT NULL default '0',
  `edit_name` varchar(255) default NULL,
  PRIMARY KEY  (`pid`),
  KEY `award_id` (`award_id`,`author_id`),
  KEY `author_id` (`author_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;";


$SQL[] = "ALTER TABLE ibf_members ADD awards_dig INT(10) NOT NULL DEFAULT '0'";
$SQL[] = "ALTER TABLE ibf_members ADD awards_tracker TINYINT( 1 ) DEFAULT '1'";
$SQL[] = "ALTER TABLE ibf_members ADD awards_cache mediumtext not null default ''";
$SQL[] = "ALTER TABLE ibf_members ADD awards_notice_type VARCHAR(10) DEFAULT 'pm'";

$SQL[] = "ALTER TABLE ibf_members ADD awards_comments tinyint(1) default '1'";
$SQL[] = "ALTER TABLE ibf_members ADD awards_comments_notice tinyint(1) default '1'";

$SQL[] = "ALTER TABLE ibf_groups ADD can_access_awcp TINYINT( 1 ) DEFAULT '0'";
$SQL[] = "ALTER TABLE ibf_groups ADD g_awards_edit TINYINT( 1 ) DEFAULT '0'";
$SQL[] = "ALTER TABLE ibf_groups ADD g_awards_delete TINYINT( 1 ) DEFAULT '0'";

$SQL[] = "ALTER TABLE ibf_groups ADD g_awards_add_comments tinyint(1) NOT NULL default '0'";
$SQL[] = "ALTER TABLE ibf_groups ADD g_awards_has_comments tinyint(1) default '0'";
$SQL[] = "ALTER TABLE ibf_groups ADD g_awards_mod_comments tinyint(1) default '0'";
$SQL[] = "ALTER TABLE ibf_groups ADD g_awards_mod_own_comments tinyint(1) default '0'";


?>
