<?php

/*
+--------------------------------------------------------------------------
|   Awards System INSTALLER
|   =============================================
|   (c) 2005 - 2006 Game-Play.ru Team
|   =============================================
+--------------------------------------------------------------------------
*/



if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
        exit();
}

class version_upgrade
{
        var $this_version = '30000';
        var $upgrade_from = '20000';
        var $ipsclass;
        var $std;
        var $first_step   = 'create the necessary tables, indexes and updates your database to include the new schematic modifications.';
        var $md5_check    = '';
        var $base_url     = '';
        var $mod_to_run   = '';
        var $mod_name     = '';
        var $module       = '';

        /*-------------------------------------------------------------------------*/
        // CONSTRUCTOR
        /*-------------------------------------------------------------------------*/

        function version_upgrade( &$ipsclass, &$std )
        {
                $this->ipsclass = &$ipsclass;
                $this->ipsclass->std = &$std;
                $this->md5_check = $this->ipsclass->return_md5_check();

                $this->base_url  = "act=work&workact=sql&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}";

        }

        /*-------------------------------------------------------------------------*/
        // Auto run..
        /*-------------------------------------------------------------------------*/

        function auto_run()
        {
                //--------------------------------
                // What are we doing?
                //--------------------------------

                switch( $this->ipsclass->input['workact'] )
                {
                        case 'sql':
                                $this->upgrade_sql();
                                break;
                        default:
                                $this->upgrade_intro();
                                break;
                }
        }


        /*-------------------------------------------------------------------------*/
        // SQL
        /*-------------------------------------------------------------------------*/

        function upgrade_sql()
        {
                $cnt = 0;

                // Delete old skin group
                $this->ipsclass->DB->simple_exec_query( array( 'delete' => 'skin_templates', 'where' => "group_name='skin_awards'") );

                // Create/Alter tables
                $SQL = array();
                if ( file_exists( THIS_PATH.'update/'.$this->ipsclass->std->current_upgrade.'/'.strtolower($this->ipsclass->vars['sql_driver']).'_updates.php' ) )
                {
                        require_once( THIS_PATH.'update/'.$this->ipsclass->std->current_upgrade.'/'.strtolower($this->ipsclass->vars['sql_driver']).'_updates.php' );

                        foreach( $SQL as $q )
                        {
                                $this->ipsclass->DB->query( $q );

                                $cnt++;
                        }
                }

                $this->ipsclass->DB->do_insert( $this->module.'_upgrade_history', array(        $this->module.'_version_id'    => $this->upgrade_from,
                                                                                                                  $this->module.'_version_human' => "2.x.x",
                                                                                                                  $this->module.'_upgrade_date'  => time(),
                                                                                                                  $this->module.'_upgrade_mid'   => $this->ipsclass->input['mid']
                                      )                                  );

                $cnt++;

                //--------------------------------
                // Next page...
                //--------------------------------

                $this->ipsclass->std->redirect( "act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}", "$cnt queries run...." );

        }

        /*-------------------------------------------------------------------------*/
        // INTRO
        /*-------------------------------------------------------------------------*/

        function upgrade_intro()
        {

                $this->ipsclass->template->script_act = $this->base_url;
                $this->ipsclass->template->inf .= "
                         <div class='maintitle'>Welcome to {$this->mod_name}!</div>
                         <div class='text-row' style='padding:6px'>This module will upgrade you from <b>{$this->ipsclass->std->versions[$this->upgrade_from]}</b> to <b>{$this->ipsclass->std->versions[$this->this_version]}</b>
                         <br /><br />This first step will {$this->first_step}
                         </div>
                        ";

                $this->ipsclass->template->output("First Step Processed...");

        }

}


?>