//------------------------------------------
// Awards System Module v3.1.0
// (c) 2006 Game-Play.ru TEAM
//
// http://www.game-play.ru
//------------------------------------------

/*-------------------------------------------------------------------------*/
// XML Delete Award
/*-------------------------------------------------------------------------*/

function xml_delete_awards( awards_id )
{

	//----------------------------------
	// INIT
	//----------------------------------
	
	var url = ipb_var_base_url+'automodule=awards&inc=memawards&CODE=deleteawards&auth_key=' + ipb_md5_check + '&xml=1&aid=' + awards_id;
	

	/*--------------------------------------------*/
	// Main function to do on request
	// Must be defined first!!
	/*--------------------------------------------*/

	do_request_function = function()
	{
		//----------------------------------
		// Ignore unless we're ready to go
		//----------------------------------
		
		if ( ! xmlobj.readystate_ready_and_ok() )
		{
			// Could do a little loading graphic here?
			return;
		}
		
		var text_req = xmlobj.xmlhandler.responseText;
		
		if ( text_req.match( /^ERROR:/ ) )
		{
			text_req = text_req.replace( /^ERROR:/, '' );
			alert( text_req );			
		}
		else if( text_req == 'SUCCESS' )
		{
			my_hide_div( my_getbyid( 'awards-' + awards_id ) );
		}
		else
		{
			my_hide_div( my_getbyid( 'awards-' + awards_id ) );
			document.getElementById( 'nocontentewrapper' ).innerHTML = text_req;
		}
		
	}

	//----------------------------------
	// LOAD XML
	//----------------------------------
	
	xmlobj = new ajax_request();
	xmlobj.onreadystatechange( do_request_function );
	
	xmlobj.process( url );
	
	return false;

}


/*-------------------------------------------------------------------------*/
// Delete Award
/*-------------------------------------------------------------------------*/

function delete_awards( aid )
{

	if (confirm( awards_delete_js_1 ))
	{
		var not_loaded_yet = 0;

		if ( use_enhanced_js )
		{
			try
			{
				xml_delete_awards( aid );
				not_loaded_yet = 1;
			}
			catch( e )
			{
				not_loaded_yet = 0;
			}
		}

		if ( ! not_loaded_yet )
		{
			ipb_var_base_url = ipb_var_base_url.replace( '&amp;', '&' );
			window.location  = ipb_var_base_url + 'automodule=awards&inc=awardscp&CODE=delet&auth_key=' + ipb_md5_check + '&aid=' + aid;
		}
	}
	else
	{
		alert ( awards_delete_js_2 );
	} 

}