<?php

/*
+--------------------------------------------------------------------------
|   Awards System v3.1.0
|   =============================================
|   by SAT
|   (c) 2008 Game-Play.ru Team
|   http://www.game-play.ru
|   =============================================
|   Web: http://www.game-play.ru
+--------------------------------------------------------------------------
|
|   > MODULE INIT FILE
|   > Module written by SAT
|
+--------------------------------------------------------------------------
*/


if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
        exit();
}

/*
+--------------------------------------------------------------------------
|   This module has one function:
|   run_init: Do any work you want to do before the caches are loaded and
|             processed
+--------------------------------------------------------------------------
*/

//-----------------------------------------
// This must always be 'component_init'
//-----------------------------------------

class component_init
{
        var $ipsclass;

        /*-------------------------------------------------------------------------*/
        // run_init
        // Find out if we need to load a cache for the Awards System
        /*-------------------------------------------------------------------------*/

        function run_init()
        {

                // Cachelist                file                        list of cache functions
                $cachelist = array (
                                           'awardscp'        =>        array('awards_img_cache','bbcode','emoticons','badwords'),
                                           'idx'             =>        array('awards_img_cache'),
                                           'comments'        =>        array('awards_img_cache','bbcode','emoticons','badwords','multimod','ranks','profilefields' ),
                                   );

                $includes = ( isset( $cachelist[ $this->ipsclass->input['inc'] ] ) ? strtolower($this->ipsclass->input['inc']) : 'idx' );

                if ( isset( $cachelist[$includes] ) )
                {
                        $this->ipsclass->cache_array = array_merge( $this->ipsclass->cache_array, $cachelist[$includes]);
                }
        }
}

?>