<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/


/**
* Admin/Overview
*
* Main page for Awards ACP
*
* @package          Awards System
* @subpackage       Admin
* @author           SAT
* @since            2.1.0
*/

//---------------------------------------
// Security check
//---------------------------------------

if ( ! defined( 'IN_ACP' ) )
{
        print "<h1> </h1>        .    , ,     'admin.php'.";
        exit();

}

//---------------------------------------
// Carry on!
//---------------------------------------

class ad_overview
{
        var $ipsclass;
        var $awards_lib;

        function auto_run()
        {
                $this->ipsclass->awards_root = './modules/awards/';


                switch( $this->ipsclass->input['navi'] )
                {
                        case 'settings':
                                $this->awards_settings();
                                break;
                        case 'stat':
                                $this->index_screen();
                                break;
                        case 'show_stat':
                                $this->show_me_member();
                                break;
                        case 'viewnote':
                                $this->view_note();
                                break;
                        case 'delaward':
                                $this->award_member_delet();
                                break;
                        default:
                                $this->index_screen();

                                break;
                }
        }

        /*-------------------------------------------------------------------------*/
        // Delet Award
        /*-------------------------------------------------------------------------*/

        function award_member_delet()
        {

                $aid = intval($this->ipsclass->input['aid']);

                //-----------------------------------------
                // Got anyfink?
                //-----------------------------------------

                if ( ! $aid )
                {
                        $this->ipsclass->main_msg = "  ,  ID!";
                        $this->show_me_member( );
                }


                //--------------------------------------
                // rebuild member award
                //--------------------------------------
                $this->ipsclass->DB->cache_add_query( 'get_delete_award' , array( 'aid' => $aid ), 'awards_admin_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                $member = $this->ipsclass->DB->fetch_row();

                if( !$member['id'] )
                {
                        $this->ipsclass->main_msg = "  !";
                        $this->index_screen();
                }

                $member['members_cache'] = $this->ipsclass->unpack_member_cache( $member['members_cache'] );

                //--------------------------------------------------
                // Delet Award's Member, insert moderator log
                //--------------------------------------------------

                $this->ipsclass->DB->simple_exec_query( array( 'delete' => 'awards', 'where' => "aid=".$aid) );

                //---------------------------------------------------
                // change personal member information
                //---------------------------------------------------

                $member_awards_array = unserialize(stripslashes($member['awards_cache']));
                unset($member_awards_array[ $aid ]);

                $this->ipsclass->DB->do_update( 'members', array( 'awards_cache' => serialize($member_awards_array),
                                                                  'awards_dig'   => ($member['awards_dig'] - 1),
                                                                  ), 'id='.$member['id'] );
                /*
                $this->ipsclass->pack_and_update_member_cache( $member['id'],
                                							   array( 'awards_cache' => $member_awards_array,
                                									  'awards_dig'   => ($member['awards_dig'] - 1),
                                									),
                                							   $member['members_cache'] );
                */

                //$this->ipsclass->admin->save_log( "Delete Member's Awards: '{$member['members_display_name']}'" );
                $this->ipsclass->admin->save_log( "  : - '{$member['members_display_name']}'" );

                $this->ipsclass->main_msg = "  !";
                $this->show_me_member();
        }


        /*-------------------------------------------------------------------------*/
        // show reaward
        /*-------------------------------------------------------------------------*/

        function view_note()
        {
                $macros = array();
                $id = intval($this->ipsclass->input['id']);

                if ( !$id )
                {
                        $this->ipsclass->admin->error("  ID ,  ");
                }

                $this->ipsclass->DB->cache_add_query( 'show_member_reawarding' , array( 'aid' => $id, ), 'awards_admin_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                if ( ! $row = $this->ipsclass->DB->fetch_row() )
                {
                        $this->ipsclass->admin->error("   ID     ");
                }

                $this->ipsclass->adskin->td_header[] = array( "&nbsp;" , "100%" );


                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( "  " );


                //-----------------------------------------
                // Get the macros and replace them
                //-----------------------------------------

                $macros = unserialize( stripslashes($this->ipsclass->skin['_macro']) );

                if ( is_array( $macros ) )
                {
                        foreach( $macros as $i => $macro_parse )
                        {
                                if ( $macro_parse['macro_value'] != "" )
                                {
                                    $row['reason'] = str_replace( "<{".$macro_parse['macro_value']."}>", $macro_parse['macro_replace'], $row['reason'] );
                                }
                        }
                }

                $row['reason'] = str_replace( "<#IMG_DIR#>", $this->ipsclass->skin['_imagedir'], $row['reason'] );
                $row['reason'] = str_replace( "<#EMO_DIR#>", $this->ipsclass->skin['_emodir']  , $row['reason'] );


                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array(
                                                                                                        "<strong>:</strong> {$row['p_name']}
                                                                                                        <br /><strong>:</strong> {$row['a_name']}
                                                                                                        <br /><strong> :</strong> {$row['title']}
                                                                                                        <hr>
                                                                                                        <br /><strong>:</strong> {$row['reason']}
                                                                                                    "
                                                                                 )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                $this->ipsclass->admin->print_popup();


        }


        /*-------------------------------------------------------------------------*/
        // show member statistics
        /*-------------------------------------------------------------------------*/

        function show_me_member()
        {
                $id = intval($this->ipsclass->input['id']);

                if ( !$id )
                {
                        $this->ipsclass->main_msg = "  ,  ID!";
                        $this->index_screen();
                }

                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'stat' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'overview' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     )      );

                $this->ipsclass->adskin->td_header[] = array( "" , "20%" );
                $this->ipsclass->adskin->td_header[] = array( " " , "20%" );
                $this->ipsclass->adskin->td_header[] = array( "" , "20%" );
                $this->ipsclass->adskin->td_header[] = array( " " , "10%" );
                $this->ipsclass->adskin->td_header[] = array( "" , "30%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( " " );

                $this->ipsclass->DB->cache_add_query( 'show_member_awards' , array( 'mid' => $id, ), 'awards_admin_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                if($this->ipsclass->DB->get_num_rows())
                {
                        while($awards_info = $this->ipsclass->DB->fetch_row())
                        {

                                if( $awards_info['img_thumbnail'] )
                                {
                                        $awards_info['img']   = $awards_info['img_thumbnail'];
                                        $awards_info['img_h'] = $awards_info['thumbnail_h'];
                                        $awards_info['img_w'] = $awards_info['thumbnail_w'];
                                }

                                $awards_info['awards_status'] = $awards_info['awards_status'] ? "<b></b>" : "<i> </i>";

                                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>".$awards_info['title']."</b>",
                                                                                                     "<b>".$awards_info['members_display_name']."</b>",
                                                                                                     "<img src='{$this->ipsclass->vars['board_url']}/{$this->ipsclass->vars['awrads_upload']}/{$awards_info['img']}' width='{$awards_info['img_w']}' height='{$awards_info['img_h']}' />",
                                                                                                     $awards_info['awards_status'],
                                                                                                     "<center><img id=\"menu{$awards_info['aid']}\" src='{$this->ipsclass->skin_acp_url}/images/filebrowser_action.gif' border='0' alt='Options' class='ipd' /></center>",
                                                                                                     ) );

                                $this->ipsclass->html .= "<script type=\"text/javascript\">
                                                           menu_build_menu(
                                                                           \"menu{$awards_info['aid']}\",
                                                                           new Array(
                                                                                     img_item   + \" <a onclick='menu_action_close()' href='javascript:pop_win(\\\"&{$this->ipsclass->form_code}&code=overview&navi=viewnote&id={$awards_info['aid']}\\\",\\\"Log\\\",400,400)'></a>\",
                                                                                     img_delete + \" <a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=awards&code=overvie&navi=delaward&aid={$awards_info['aid']}&id={$id}'></a>\"
                                                                               ) );
                                                           </script>";
                        }
                }
                else
                {
                        //--------------------------------
                        // if query return NULL
                        //--------------------------------
                        $this->ipsclass->html .= "<tr><td width='40%' class='tdrow1' colspan='5' align='center'><i>    </i></td></tr>";
                }

                $this->ipsclass->html .= $this->ipsclass->adskin->end_form("");//button
                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();
                $this->ipsclass->admin->output();
        }

        /*-------------------------------------------------------------------------*/
        // Show Awards Settings
        /*-------------------------------------------------------------------------*/

        function awards_settings()
        {
                require_once( ROOT_PATH.'sources/action_admin/settings.php' );
                $settings             =  new ad_settings();
                $settings->ipsclass   =& $this->ipsclass;

                $settings->get_by_key        = 'awardsys';
                $settings->return_after_save = $this->ipsclass->form_code.'&code=overview&navi=settings';

                $settings->setting_view();
        }

        /*-------------------------------------------------------------------------*/
        // Statistics Screen
        /*-------------------------------------------------------------------------*/

        function index_screen()
        {
                //-------------------------------
                // INIT
                //-------------------------------

                $query = array();
                $q_extra = '';
                $page_query = '';
                $st = intval($this->ipsclass->input['st']);

                //$this->ipsclass->admin->page_title   = "Awards System Overview";
                $this->ipsclass->admin->page_title   = "  ";
                $this->ipsclass->admin->page_detail  = "";

                /* Check for unapproved images */

                $this->ipsclass->html .= "<table width='100%' cellspacing='2' cellpadding='0' border='0'>
                                                 <tr>
                                                     <td width='50%' align='left' valign='top'>";

                $this->ipsclass->html .= $this->get_stats( );

                $this->ipsclass->html .= "</td>
                                            <td width='50%' align='left' valign='top'>";

                $this->ipsclass->html .= $this->get_upgrade_history();

                $this->ipsclass->html .= "     </td>
                                          </tr>
                                          <tr>
                                               <td width='100%' colspan='2' align='left' valign='top'>";


                //$this->ipsclass->adskin->td_header[] = array( "Member" , "40%" );
                //$this->ipsclass->adskin->td_header[] = array( "Awards Count" , "20%" );
                //$this->ipsclass->adskin->td_header[] = array( "Options" , "40%" );


                $this->ipsclass->adskin->td_header[] = array( "" , "40%" );
                $this->ipsclass->adskin->td_header[] = array( " " , "20%" );
                $this->ipsclass->adskin->td_header[] = array( "" , "40%" );


                //-----------------------------------------
                // Loopy loo
                //-----------------------------------------

                foreach( array('name', 'members_display_name') as $bit )
                {
                        $this->ipsclass->input[ $bit ] = urldecode(trim($this->ipsclass->input[ $bit ]));

                        $page_query .= '&'.$bit.'='.urlencode($this->ipsclass->input[ $bit ]);

                        //-----------------------------------------
                        // Table?
                        //-----------------------------------------

                        if ($bit == 'name' and $this->ipsclass->input[$bit] != '')
                        {
                                $start_bit = '%';
                                $end_bit   = '%';

                                if ( $this->ipsclass->input['namewhere'] == 'begin' )
                                {
                                        $start_bit = '';
                                }
                                else if ( $this->ipsclass->input['namewhere'] == 'ends' )
                                {
                                        $end_bit   = '';
                                }
                                else if ( $this->ipsclass->input['namewhere'] == 'is' )
                                {
                                        $end_bit   = '';
                                        $start_bit = '';
                                }

                                $query[] = $bit." LIKE '".$start_bit.$this->ipsclass->input[$bit].$end_bit."'";
                        }
                        else if ($bit == 'members_display_name' and $this->ipsclass->input[$bit] != '')
                        {
                                $start_bit = '%';
                                $end_bit   = '%';

                                if ( $this->ipsclass->input['dnamewhere'] == 'begin' )
                                {
                                        $start_bit = '';
                                }
                                else if ( $this->ipsclass->input['dnamewhere'] == 'ends' )
                                {
                                        $end_bit   = '';
                                }
                                else if ( $this->ipsclass->input['dnamewhere'] == 'is' )
                                {
                                        $end_bit   = '';
                                        $start_bit = '';
                                }

                                $query[] = $bit." LIKE '".$start_bit.$this->ipsclass->input[$bit].$end_bit."'";
                        }

                }

                //-----------------------------------------
                // get 'owt?
                //-----------------------------------------

                if ( count($query) )
                {
                        $q_extra = ' AND '.implode( " AND ", $query );
                }


                //---------------------------------
                // build navi
                //---------------------------------
                $this->ipsclass->DB->simple_construct( array( 'select' => 'COUNT(*) as mcount', 'from' => 'members', 'where' => "awards_dig > 0".$q_extra  ) );
                $this->ipsclass->DB->simple_exec();

                $row = $this->ipsclass->DB->fetch_row();

                //-----------------------------------------
                // Pages...
                //-----------------------------------------

                $pages = $this->ipsclass->adskin->build_pagelinks( array( 'TOTAL_POSS'  => $row['mcount'],
                                                                          'PER_PAGE'    => 20,
                                                                          'CUR_ST_VAL'  => $st,
                                                                          'L_SINGLE'    => " ",
                                                                          'L_MULTI'     => " ",
                                                                          'BASE_URL'    => $this->ipsclass->base_url."&section=".$this->ipsclass->section_code."&act=awards&code=overview&navi=stat".$page_query,
                                                                          )      );


                //$this->ipsclass->html .= $this->ipsclass->adskin->start_table( "List reawardings" );
                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( " " );
                //$this->ipsclass->html .= "<div class='pformstrip' align='right'>{$pages}</div>";

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_basic($pages, 'center', 'tablesubheader');


                $this->ipsclass->DB->simple_construct( array( 'select' => 'members_display_name, awards_dig, id', 'from' => 'members', 'where' => 'awards_dig > 0'.$q_extra , 'order' => "awards_dig DESC", 'limit' => array($st, 20)) );
                $this->ipsclass->DB->simple_exec();

                if($this->ipsclass->DB->get_num_rows())
                {
                        while($awards_info = $this->ipsclass->DB->fetch_row())
                        {
                                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<a href='index.{$this->ipsclass->vars['php_ext']}?showuser={$awards_info['id']}'>".$awards_info['members_display_name']."</a>",
                                                                                                     "<center><b>".$awards_info['awards_dig']."</b></center>",
                                                                                                     "<center>".$this->ipsclass->adskin->js_make_button(""       , $this->ipsclass->base_url."&section=".$this->ipsclass->section_code."&act=awards&code=overview&navi=show_stat&id=".$awards_info['id'])."</center>",
                                                                                                     ) );

                        }
                }
                else
                {
                        //--------------------------------
                        // if query return NULL
                        //--------------------------------
                        //$this->ipsclass->html .= "<tr><td width='40%' class='tdrow1' colspan='3' align='center'><i>No resault</i></td></tr>";
                        $this->ipsclass->html .= "<tr><td width='40%' class='tdrow1' colspan='3' align='center'><i>   </i></td></tr>";
                }


                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'stat' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'overview' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     )      );


                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( " " );


                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>  ...</b>",
                                                                                     $this->ipsclass->adskin->form_dropdown( 'namewhere', array( 0 => array( 'begin'   , ' ' ),
                                                                                                                                                 1 => array( 'is'      , ' '          ),
                                                                                                                                                 2 => array( 'contains', ''    ),
                                                                                                                                                 3 => array( 'ends'    , ' '   )
                                                                                                                                          ), $_POST['namewhere'] ) .'&nbsp;'. $this->ipsclass->adskin->form_input( "name", $_POST['name'] )
                                                                                                                                        )      );

                if ( $this->ipsclass->vars['auth_allow_dnames'] )
                {
                        $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b><u></u>  </b>",
                                                                                             $this->ipsclass->adskin->form_dropdown( 'dnamewhere', array( 0 => array( 'begin'   , ' ' ),
                                                                                                                                                      1 => array( 'is'      , ' '          ),
                                                                                                                                                      2 => array( 'contains', ''    ),
                                                                                                                                                      3 => array( 'ends'    , ' '   )
                                                                                                                                               ), $_POST['dnamewhere'] ).'&nbsp;'. $this->ipsclass->adskin->form_input( "members_display_name", $_POST['members_display_name'] )
                                                                                                                                        )      );
                }


                $this->ipsclass->html .= $this->ipsclass->adskin->end_form("");//button
                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();


                $this->ipsclass->html .= "     </td>
                               </tr>
                            </table>";

                $this->ipsclass->admin->output();
        }


        function get_stats(  )
        {
                // Get Total Images
                $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'awards_upgrade_history', 'order' => 'awards_upgrade_id DESC', 'limit' => array(0,1) ) );
                $this->ipsclass->DB->simple_exec();
                $t = $this->ipsclass->DB->fetch_row();
                $version_awards = $t['awards_version_human'];

                // Get Total Diskspace
                $total_diskspace = $this->awards_lib->_get_uploads_size(  );

                // Get Total Reawards
                $this->ipsclass->DB->simple_construct( array( 'select' => 'count(*) AS total', 'from' => 'awards' ) );
                $this->ipsclass->DB->simple_exec();
                $t = $this->ipsclass->DB->fetch_row();
                $total_rewards = ( $t['total'] ) ? $t['total'] : 0;

                // Get Total Comments
                $this->ipsclass->DB->simple_construct( array( 'select' => 'count(*) AS total', 'from' => 'awards_info' ) );
                $this->ipsclass->DB->simple_exec();
                $t = $this->ipsclass->DB->fetch_row();
                $total_awards = ( $t['total'] ) ? $t['total'] : 0;

                // Get Total Comments
                $this->ipsclass->DB->simple_construct( array( 'select' => 'count(*) AS total', 'from' => 'awards_comments' ) );
                $this->ipsclass->DB->simple_exec();
                $t = $this->ipsclass->DB->fetch_row();
                $total_comments = ( $t['total'] ) ? $t['total'] : 0;

                // Set widths
                $this->ipsclass->adskin->td_header   = array();
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "40%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "60%" );

                // Build table
                $stats  = $this->ipsclass->adskin->start_table( "Awards System  " );
                //$stats  = $this->ipsclass->adskin->start_table( "Awards System Quick Stats" );
                //$stats .= $this->ipsclass->adskin->add_td_row( array( '<b>Awards Syetem Version</b>', "<b>$version_awards</b>"         ) );
                $stats .= $this->ipsclass->adskin->add_td_row( array( '<b>Awards System </b>', "<b>$version_awards</b>"         ) );
                //$stats .= $this->ipsclass->adskin->add_td_row( array( 'Total Awards'   , $total_awards ) );
                //$stats .= $this->ipsclass->adskin->add_td_row( array( 'Total Diskspace', $total_diskspace ) );
                //$stats .= $this->ipsclass->adskin->add_td_row( array( 'Total rewards'  , $total_rewards ) );
                //$stats .= $this->ipsclass->adskin->add_td_row( array( 'Total comments'  , $total_comments ) );
                $stats .= $this->ipsclass->adskin->add_td_row( array( ' '        , $total_awards ) );
                $stats .= $this->ipsclass->adskin->add_td_row( array( '  '         , $total_diskspace ) );
                $stats .= $this->ipsclass->adskin->add_td_row( array( ' '   , $total_rewards ) );
                $stats .= $this->ipsclass->adskin->add_td_row( array( ' '  , $total_comments ) );
                $stats .= $this->ipsclass->adskin->end_table();

                return $stats;
        }

        function get_upgrade_history()
        {
                // Get the info
                $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'awards_upgrade_history', 'order' => 'awards_upgrade_id ASC' ) );
                $this->ipsclass->DB->simple_exec();

                // Set widths
                $this->ipsclass->adskin->td_header   = array();
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "40%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "60%" );

                //$upgrade = $this->ipsclass->adskin->start_table( "Awards System Upgrade History" );
                $upgrade = $this->ipsclass->adskin->start_table( "  Awards System" );

                while( $i = $this->ipsclass->DB->fetch_row() )
                {
                        $upgrade .= $this->ipsclass->adskin->add_td_row( array( $i['awards_version_human'] , $this->ipsclass->get_date( $i['awards_upgrade_date'], 'LONG' ) ) );
                }

                $upgrade .= $this->ipsclass->adskin->end_table();

                return $upgrade;
        }

}
?>
