<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/


/**
* Library/Comment View
*
*
* @package          Awards System
* @subpackage       Library
* @author           SAT
* @version          1.0.0
* @since            3.1.0
*/


class comment_view
{
	# Objects
	var $ipsclass;
	var $awards_lib;
	var $parser;
	var $custom_fields;
	var $lib_profile;
	var $first = 0;
	var $limit = 10;

	var $output;

	var $qpids			= array();
	var $pids			= array();
	var $buttons		= array();
	var $award          = array();
	var $info			= array();
	var $cached_members = array();

	var $is_moderator	= false;
	var $no_comments 	= false;

	var $post_count		= 0;

 	/*-------------------------------------------------------------------------*/
 	// Init library
 	/*-------------------------------------------------------------------------*/

	function init_lib( $buttons = array() )
	{

		//-----------------------------------------
		// get skin
		//-----------------------------------------

		$this->ipsclass->load_template( 'skin_topic' );

		// get buttons
		$this->buttons = $buttons;

		//-----------------------------------------
		// get moderate pids
		//-----------------------------------------

		$this->qpids = $this->ipsclass->my_getcookie( 'award_pids' );

		$this->ipsclass->input['selectedpids'] = $this->ipsclass->my_getcookie( 'awardsmodpids' );

		$this->ipsclass->input['selectedpidcount'] = intval( count( preg_split( "/,/", $this->ipsclass->input['awardsmodpids'], -1, PREG_SPLIT_NO_EMPTY ) ) );

		$this->ipsclass->my_setcookie('awardsmodpids', '', 0);
	}

 	/*-------------------------------------------------------------------------*/
 	// Build HTML output comments
 	/*-------------------------------------------------------------------------*/

	function get_comments()
	{
		//-----------------------------------------
		// Grab the posts we'll need
		//-----------------------------------------

		$this->first = intval( $this->ipsclass->input['st'] ) > 0 ? intval( $this->ipsclass->input['st'] ) : 0;


		//-----------------------------------------
		// Moderator?
		//-----------------------------------------

		if ( !$this->awards_lib->comments_mod )
		{
			$queued_query_bit = ' AND c.approved=1';
		}


		$count = $this->ipsclass->DB->build_and_exec_query( array( 'select' => 'COUNT(c.pid) as total', 'from' => 'awards_comments c', 'where' => 'c.award_id='.$this->award['aid']. $queued_query_bit ) );

		$this->awards_lib->comments_count = $comments_count = $count['total'];

		if( !$this->awards_lib->comments_count )
		{
			return "";
		}

		//-----------------------------------------
		// Get posts
		//-----------------------------------------

		if( $this->ipsclass->vars['custom_profile_topic'] == 1 )
		{
			$this->ipsclass->DB->build_query( array(	'select'	=> 'c.*',
														'from'		=> array( 'awards_comments' => 'c' ),
														'where'		=> 'c.award_id='.$this->award['aid']. $queued_query_bit,
														'order'		=> 'c.pid',
														'add_join'	=> array(
																			array(
																					'type'		=> 'left',
																					'select'	=> 'm.id,m.members_display_name,m.mgroup,m.email,m.joined,m.posts, m.last_visit, m.last_activity,m.login_anonymous,m.title,m.hide_email, m.warn_level, m.warn_lastwarn, m.awards_dig, m.awards_cache, m.members_cache',
																					'where'		=> 'm.id=c.author_id',
																					'from'		=> array( 'members' => 'm' )
																				),
																			array(
																					'type'		=> 'left',
																					'select'	=> 'me.signature, me.website,me.location, me.avatar_location, me.avatar_type, me.avatar_size',
																					'where'		=> 'me.id=m.id',
																					'from'		=> array( 'member_extra' => 'me' )
																				),
																			array(
																					'type'		=> 'left',
																					'select'	=> 'pc.*',
																					'where'		=> 'pc.member_id=m.id',
																					'from'		=> array( 'pfields_content' => 'pc' )
																				),
																			array(
																					'type'		=> 'left',
																					'select'	=> 'pp.*',
																					'where'		=> 'pp.pp_member_id=m.id',
																					'from'		=> array( 'profile_portal' => 'pp' )
																				),
																			)
											)		);
		}
		else
		{
			$this->ipsclass->DB->build_query( array(	'select'	=> 'c.*',
														'from'		=> array( 'awards_comments' => 'c' ),
														'where'		=> 'c.award_id='.$this->award['aid']. $queued_query_bit,
														'order'		=> 'c.pid',
														'add_join'	=> array(
																			array(
																					'type'		=> 'left',
																					'select'	=> 'm.id,m.members_display_name,m.mgroup,m.email,m.joined,m.posts, m.last_visit, m.last_activity,m.login_anonymous,m.title,m.hide_email, m.warn_level, m.warn_lastwarn, m.awards_dig, m.awards_cache, m.members_cache',
																					'where'		=> 'm.id=c.author_id',
																					'from'		=> array( 'members' => 'm' )
																				),
																			array(
																					'type'		=> 'left',
																					'select'	=> 'me.signature, me.website,me.location, me.avatar_location, me.avatar_type, me.avatar_size',
																					'where'		=> 'me.id=m.id',
																					'from'		=> array( 'member_extra' => 'me' )
																				),
																			array(
																					'type'		=> 'left',
																					'select'	=> 'pp.*',
																					'where'		=> 'pp.pp_member_id=m.id',
																					'from'		=> array( 'profile_portal' => 'pp' )
																				),
																			)
											)		);
		}

		$oq = $this->ipsclass->DB->exec_query();

		//-----------------------------------------
		// Render the page top
		//-----------------------------------------

		$show_pages = $this->ipsclass->build_pagelinks( array( 'TOTAL_POSS' 	=> $comments_count,
												 				'PER_PAGE'		=> $this->limit,
												 				'CUR_ST_VAL' 	=> $this->first,
												 				'BASE_URL'		=> $this->base_url."?automodule=awards&inc=comments&aid={$this->awards['aid']}"
														)		);

		$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->CommentTop( array( 'SHOW_PAGES' => $show_pages, 'button_add' => $this->buttons['comment_button'] ) );

		//-----------------------------------------
		// Format and print out the topic list
		//-----------------------------------------

		while ( $row = $this->ipsclass->DB->fetch_row( $oq ) )
		{
			$return = $this->parse_row( $row );

			$poster = $return['poster'];
			$row	= $return['row'];

			$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->CommentRow( $row, $poster, $this->comments_mod );

			//-----------------------------------------
			// Are we giving this bloke a good ignoring?
			//-----------------------------------------

			if ( $this->ipsclass->member['ignored_users'] )
			{
				if ( strstr( $this->ipsclass->member['ignored_users'], ','.$poster['id'].',' ) and $this->ipsclass->input['p'] != $row['pid'] )
				{
					if ( ! strstr( $this->ipsclass->vars['cannot_ignore_groups'], ','.$poster['mgroup'].',' ) )
					{
						$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->render_row_hidden( $row, $poster );
						continue;
					}
				}
			}
		}

		//-----------------------------------------
		// Print the footer
		//-----------------------------------------

		$this->output .= $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->CommentFooter( array( 'SHOW_PAGES' => $show_pages ) );

		return $this->output;

	}

	/*-------------------------------------------------------------------------*/
	// Parse post
	/*-------------------------------------------------------------------------*/

	function parse_row( $row = array() )
	{
		$poster = array();

		//-----------------------------------------
		// Cache member
		//-----------------------------------------

		if ($row['author_id'] != 0)
		{
			//-----------------------------------------
			// Is it in the hash?
			//-----------------------------------------

			if ( isset($this->cached_members[ $row['author_id'] ]) )
			{
				//-----------------------------------------
				// Ok, it's already cached, read from it
				//-----------------------------------------

				$poster = $this->cached_members[ $row['author_id'] ];
				$row['name_css'] = 'normalname';
			}
			else
			{
				$row['name_css'] = 'normalname';
				$poster = $this->ipsclass->parse_member( $row );

				//-----------------------------------------
				// Add it to the cached list
				//-----------------------------------------

				$this->cached_members[ $row['author_id'] ] = $poster;
			}
		}
		else
		{
			//-----------------------------------------
			// It's definitely a guest...
			//-----------------------------------------

			$poster = $this->ipsclass->set_up_guest( $this->ipsclass->lang['global_guestname'] );
			$row['name_css'] = 'unreg';
		}

		//-----------------------------------------

		if ( ! $row['approved'] )
		{
			$row['post_css'] = $this->post_count % 2 ? 'post1shaded' : 'post2shaded';
			$row['altrow']	= 'row4shaded';
		}
		else
		{
			$row['post_css'] = $this->post_count % 2 ? 'post1' : 'post2';
			$row['altrow']	= 'row4';
		}

		//-----------------------------------------

		if ( ($row['append_edit'] == 1) && ($row['edit_time'] != "") && ($row['edit_name'] != "") )
		{
			$e_time = $this->ipsclass->get_date( $row['edit_time'] , 'LONG' );

			$row['comment'] .= "<br /><br /><span class='edit'>".sprintf($this->ipsclass->lang['edited_by'], $row['edit_name'], $e_time)."</span>";
		}

		//-----------------------------------------

		if (!$this->ipsclass->member['view_img'])
		{
			//-----------------------------------------
			// unconvert smilies first, or it looks a bit crap.
			//-----------------------------------------

			$row['comment'] = preg_replace( "#<!--emo&(.+?)-->.+?<!--endemo-->#", "\\1" , $row['post'] );

			$row['comment'] = preg_replace( "/<img src=[\"'](.+?)[\"'].+?".">/", "(IMG:<a href='\\1' target='_blank'>\\1</a>)", $row['post'] );
		}

		//-----------------------------------------
		// Online, offline?
		//-----------------------------------------

		if ( $row['author_id'] )
		{
			$time_limit = time() - $this->ipsclass->vars['au_cutoff'] * 60;

			$poster['online_status_indicator'] = '<{PB_USER_OFFLINE}>';

			list( $be_anon, $loggedin ) = explode( '&', $row['login_anonymous'] );

			if ( ( $row['last_visit'] > $time_limit or $row['last_activity'] > $time_limit ) AND $be_anon != 1 AND $loggedin == 1 )
			{
				$poster['online_status_indicator'] = '<{PB_USER_ONLINE}>';
			}
		}
		else
		{
			$poster['online_status_indicator'] = '';
		}

		//-----------------------------------------
		// Multi Quoting?
		//-----------------------------------------

		$row['mq_start_image'] = $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->mq_image_add($row['pid']);

		if ( $this->qpids )
		{
			if ( strstr( ','.$this->qpids.',', ','.$row['pid'].',' ) )
			{
				$row['mq_start_image'] = $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->mq_image_remove($row['pid']);
			}
		}

		//-----------------------------------------
		// Multi PIDS?
		//-----------------------------------------

		if ( $this->comments_mod or $this->ipsclass->member['g_is_supmod'])
		{
			$row['pid_start_image'] = $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->pid_image_unselected($row['pid']);

			if ( $this->ipsclass->input['awardsmodpids'] )
			{
				if ( strstr( ','.$this->ipsclass->input['awardsmodpids'].',', ','.$row['pid'].',' ) )
				{
					$row['pid_start_image'] = $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->pid_image_selected($row['pid']);
				}
			}
		}

		//-----------------------------------------
		// Delete button..
		//-----------------------------------------

		if ( $row['pid'] != $this->topic['topic_firstpost'] )
		{
			$row['delete_button'] = $this->delete_button($row['pid'], $poster);
		}

		$row['edit_button']	= $this->edit_button($row['pid'], $poster, $row['post_date']);

		$row['post_date']	= $this->ipsclass->get_date( $row['post_date'], 'LONG' );

		$row['ip_address']	= $this->view_ip($row, $poster);

		$row['report_link']	= ( ( $this->ipsclass->vars['disable_reportpost'] != 1 ) and ( $this->ipsclass->member['id'] OR $this->ipsclass->vars['gallery_guest_report'] ) )
								? $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->report_link($row['pid'])
								: "";

		//-----------------------------------------
		// Siggie stuff
		//-----------------------------------------

		$row['signature'] = "";

		if (isset($poster['signature']) AND $poster['signature'] AND  $this->ipsclass->member['view_sigs'])
		{
			if ($row['use_sig'] == 1)
			{
				$row['signature'] = $this->ipsclass->compiled_templates['skin_global']->signature_separator( $poster['signature'] );
			}
		}

		//-----------------------------------------
		// Fix up the membername so it links to the members profile
		//-----------------------------------------

		if ($poster['id'])
		{
			$poster['members_display_name'] = "<a href='{$this->ipsclass->base_url}showuser={$poster['id']}'>{$poster['members_display_name']}</a>";
		}

		//-----------------------------------------
		// Parse HTML tag on the fly
		//-----------------------------------------

		$this->parser->parse_html =  0;
		$this->parser->parse_wordwrap = $this->ipsclass->vars['post_wordwrap'];
		$this->parser->parse_nl2br	= 1;

		$row['post'] = $this->parser->pre_display_parse( $row['post'] );

		//-----------------------------------------
		// Post number
		//-----------------------------------------

		$this->post_count++;

		$row['post_count'] 	= $this->first + $this->post_count;

		return array( 'row' => $row, 'poster' => $poster );
	}


	/*-------------------------------------------------------------------------*/
	// Render the delete button
	/*-------------------------------------------------------------------------*/

	function delete_button($post_id, $poster)
	{
		if ($this->ipsclass->member['id'] == "" or $this->ipsclass->member['id'] == 0)
		{
			return "";
		}

		$button = $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->button_delete( $post_id, $this->award['aid'] );

		if( $this->awards_lib->comments_mod ) return $button;
		if( $this->ipsclass->member['g_is_supmod'] ) return $button;
		if( $poster['author_id'] == $this->ipsclass->member['id'] and ($this->ipsclass->member['g_delete_own_posts'])) return $button;

		return "";
	}

	/*-------------------------------------------------------------------------*/
	// Render the edit button
	/*-------------------------------------------------------------------------*/

	function edit_button($post_id, $poster, $post_date)
	{
		if ($this->ipsclass->member['id'] == "" or $this->ipsclass->member['id'] == 0)
		{
			return "";
		}

		$button = $this->ipsclass->compiled_templates[ 'skin_awards_comments' ]->button_edit( $this->award['aid'], $post_id );

		if ($this->ipsclass->member['g_is_supmod']) return $button;

		if( $this->awards_lib->comments_mod ) return $button;

		if ($poster['author_id'] == $this->ipsclass->member['id'] and ($this->ipsclass->member['g_edit_posts']))
		{
			// Have we set a time limit?

			if ($this->ipsclass->member['g_edit_cutoff'] > 0)
			{
				if ( $post_date > ( time() - ( intval($this->ipsclass->member['g_edit_cutoff']) * 60 ) ) )
				{
					return $button;
				}
				else
				{
					return "";
				}
			}
			else
			{
				return $button;
			}
		}

		return "";
	}


	function view_ip($row, $poster)
	{
		if ($this->ipsclass->member['g_is_supmod'] != 1)
		{
			return "";
		}
		else
		{
			$row['ip_address'] = $poster['mgroup'] == $this->ipsclass->vars['admin_group']
						  ? $this->ipsclass->compiled_templates['skin_topic']->ip_admin_hide()
						  : $this->ipsclass->compiled_templates['skin_topic']->ip_admin_show( $row['ip_address'] );
			return $this->ipsclass->compiled_templates['skin_topic']->ip_show($row['ip_address']);
		}
	}

}
?>