<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   =============================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   =============================================
|   Web: http://www.game-play.ru
+--------------------------------------------------------------------------
|
|   > Reports module
|   > Module written by SAT
|
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

class reports
{
        var $nav       = array();
        var $page_title= "";
        var $email     = "";
        var $lib       = "";

        var $ipsclass;
        var $rep_lib;
        var $output    = "";


        /*-------------------------------------------------------------------------*/
        // First manual called function
        /*-------------------------------------------------------------------------*/

        function auto_run_module( )
        {
                // What to do?

                //-----------------------------------------

                if (empty($this->ipsclass->member['id']))
                {
                        $this->awards_lib->award_error( array( 'LEVEL' => 1, 'MSG' => 'no_guests' ) );
                }

                if( $this->ipsclass->vars['disable_reportpost'] == 1 )
                {
                        $this->awards_lib->award_error( array( 'LEVEL' => 1, 'MSG' => 'invalid_use' ) );
                }

                switch($this->ipsclass->input['send'])
                {
                        // file report
                        case 1:
                                $this->send_report( );
                                break;
                        default:
                                $this->report_form( );
                                break;
                }

                $this->ipsclass->print->add_output("$this->output");
                $this->ipsclass->print->do_output( array( 'TITLE' => $this->page_title, 'JS' => 0, NAV => $this->nav ) );

        }



        /*-------------------------------------------------------------------------*/
        // REPORT POST FORM
        /*-------------------------------------------------------------------------*/

        function report_form(  )
        {
                $this->ipsclass->load_template('skin_awards_report');

                $com   = intval($this->ipsclass->input['com']);
                $st    = intval($this->ipsclass->input['st']);


				$this->ipsclass->DB->build_query( array(	'select'	=> 'c.*',
															'from'		=> array( 'awards_comments' => 'c' ),
															'where'		=> "c.pid={$com}",
															'add_join'	=> array(
																				 0 =>array(
																					'type'		=> 'left',
																					'select'	=> 'a.aid',
																					'where'		=> 'a.aid=c.award_id',
																					'from'		=> array( 'awards' => 'a' )
																				 ),
																				 1 =>array(
																					'type'		=> 'left',
																					'select'	=> 'ai.title',
																					'where'		=> 'ai.id=a.awards_id',
																					'from'		=> array( 'awards_info' => 'ai' )
																				 ),
															)		));


				$oq = $this->ipsclass->DB->exec_query();

                $comment = $this->ipsclass->DB->fetch_row();

                if ( (!$comment['aid']) or (!$comment['pid']) )
                {
                        $this->awards_lib->award_error( array( 'LEVEL' => 1, 'MSG' => 'missing_files') );
                }

                $this->output .= $this->ipsclass->compiled_templates['skin_awards_report']->report_form( $com, $st, $comment['aid'], $comment['title']);

                $this->nav = array( 0 => "<a href='{$this->ipsclass->base_url}automodule=awards'>".$this->ipsclass->lang['page_title_aw']."</a>",
                                    1 => $this->ipsclass->lang['aw_report_page_title']);

                $this->page_title = $this->ipsclass->lang['aw_report_page_title'];
        }

        /*-------------------------------------------------------------------------*/
        // SEND REPOST TO MODERATORS
        /*-------------------------------------------------------------------------*/

        function send_report(   )
        {
                $com   = intval($this->ipsclass->input['com']);
                $st    = intval($this->ipsclass->input['st']);

				$this->ipsclass->DB->build_query( array(	'select'	=> 'c.*',
															'from'		=> array( 'awards_comments' => 'c' ),
															'where'		=> "c.pid={$com}",
															'add_join'	=> array(
																				 0 =>array(
																					'type'		=> 'left',
																					'select'	=> 'a.aid,a.mid',
																					'where'		=> 'a.aid=c.award_id',
																					'from'		=> array( 'awards' => 'a' )
																				 ),
																				 1 =>array(
																					'type'		=> 'left',
																					'select'	=> 'ai.title',
																					'where'		=> 'ai.id=a.awards_id',
																					'from'		=> array( 'awards_info' => 'ai' )
																				 ),
															)		));


				$oq = $this->ipsclass->DB->exec_query();

                $comment = $this->ipsclass->DB->fetch_row();

                if ( (!$comment['aid']) or (!$comment['pid']) )
                {
                        $this->awards_lib->award_error( array( 'LEVEL' => 1, 'MSG' => 'missing_files') );
                }

                //-----------------------------------------
                // Make sure we came in via a form.
                //-----------------------------------------

                if ( $this->ipsclass->input['message'] == "" )
                {
                        $this->awards_lib->award_error('complete_form');
                }

                $mods = array();

                //-----------------------------------------
                // get award own
                //-----------------------------------------

                $this->ipsclass->DB->cache_add_query( 'awards_contact_member_report_get_own_awards_mod', array( 'mid' => $comment['mid'] ), 'awards_sql_queries' );
                $this->ipsclass->DB->cache_exec_query();

                while( $r = $this->ipsclass->DB->fetch_row() )
                {
                	if( $r['id'] )
                 	{
                 		$mods[ $r['id'] ] = $r;
                  	}
                }


				if( !count( $mods ) )
				{
						//-----------------------------------------
                		// Get awards moderators
                		//-----------------------------------------

                		$this->ipsclass->DB->cache_add_query( 'awards_contact_member_report_get_awards_mod', array(), 'awards_sql_queries' );
                		$this->ipsclass->DB->cache_exec_query();

                		if ( $this->ipsclass->DB->get_num_rows() )
                		{
                        		while( $r = $this->ipsclass->DB->fetch_row() )
                        		{
                                		if( $r['id'] )
                                		{
                                        		$mods[ $r['id'] ] = $r;
                                		}
                        		}
                		}
                		else
                		{
								//-----------------------------------------
                				// Get super moderators
                				//-----------------------------------------

                				$this->ipsclass->DB->cache_add_query( 'awards_contact_member_report_get_supmod', array(), 'awards_sql_queries' );
                				$this->ipsclass->DB->cache_exec_query();

                				if ( $this->ipsclass->DB->get_num_rows() )
                				{
                        				while( $r = $this->ipsclass->DB->fetch_row() )
                        				{
                                				if( $r['id'] )
                                				{
			                                        	$mods[ $r['id'] ] = $r;
                                				}
                        				}
                				}
                				else
                				{
                        				//-----------------------------------------
                        				// No supmods? Get those with control panel access
                        				//-----------------------------------------

                        				$this->ipsclass->DB->cache_add_query( 'awards_contact_member_report_get_cpaccess', array(), 'awards_sql_queries' );
                        				$this->ipsclass->DB->cache_exec_query();

                        				while( $r = $this->ipsclass->DB->fetch_row() )
                        				{
                                				$mods[ $r['id'] ] = $r;
                        				}
                				}
                		}
                }

                //-----------------------------------------
                // Get the emailer module
                //-----------------------------------------

				require_once( ROOT_PATH."modules/awards/lib/notice.php" );
                $this->email   = new notice_lib( &$this );
                $this->email->ipsclass   =& $this->ipsclass;
                $this->email->awards_lib =& $this->awards_lib;

                //-----------------------------------------
                // Load the email lib
                //-----------------------------------------

                require_once( ROOT_PATH."sources/classes/class_email.php" );
                $this->email->email_lib = new emailer();
                $this->email->email_lib->ipsclass =& $this->ipsclass;
                $this->email->email_lib->email_init();

                require_once( ROOT_PATH.'sources/lib/func_msg.php' );
                $this->lib = new func_msg();
                $this->lib->ipsclass =& $this->ipsclass;

                $this->lib->init();

                //-----------------------------------------
                // Loop and send the mail
                //-----------------------------------------

                $report = trim( stripslashes($this->ipsclass->input['message']) );

                $report = htmlspecialchars($report, ENT_QUOTES);

                //-----------------------------------------
                // send reports
                //-----------------------------------------

                foreach( $mods as $idx => $data )
                {
                        $message_array =  array(  'MOD_NAME'     => $data['name'],
                                                  'USERNAME'     => $this->ipsclass->member['members_display_name'],
                                                  'AWARD'        => $comment['title'],
                                                  'LINK_TO_AWARD'=>"{$this->ipsclass->vars['board_url']}/index.{$this->ipsclass->vars['php_ext']}"."?automodule=awards&inc=findcomment&com=".$comment['pid'],
                                                  'REPORT'       => $report,
                                                  );

                        //-----------------------------------------
                        // Email?
                        //-----------------------------------------

                        if ( $this->ipsclass->vars['reportpost_method'] == 'email' OR $data['members_disable_pm'] )
                        {
                        		$this->email->get_email_template("comments_report", $data['language']);
                				$this->email->email_lib->build_message( $message_array );

                				$this->email->email_lib->to      = $data['email'];
                				$this->email->email_lib->send_mail();
                        }

                        //-----------------------------------------
                        // PM?
                        //-----------------------------------------

                        else
                        {
                                $this->email->get_email_template("comments_report", $data['language']);
                                $this->email->email_lib->build_message( $message_array );

                                $this->lib->to_by_id    = $data['id'];
                                $this->lib->from_member = $this->ipsclass->member;
                                $this->lib->msg_title   = $this->ipsclass->lang['rep_report'];
                                $this->lib->msg_post    = $this->email->email_lib->message;
                                $this->lib->force_pm    = 1;

                                $this->lib->send_pm();

                                if ( $this->lib->error )
                                {
                                        print $this->error;
                                        exit();
                                }
                        }
                }

                $this->ipsclass->print->redirect_screen( $this->ipsclass->lang['aw_report_redirect'], "automodule=awards&inc=comments&aid=".$comment['aid']."&st=".$st."#com".$com);
        }

}

?>
