<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   =============================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   =============================================
|   Web: http://www.game-play.ru
+--------------------------------------------------------------------------
|
|   > Awards System UCP script
|   > Script written by SAT
|
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
        exit();
}

class ucp
{
        var $ipsclass;
        var $awards_lib;
        var $lib;

        var $output="";
        var $nav = "";
        var $page_title = "";
        var $md5_check  = "";

        /*-------------------------------------------------------------------------*/
        // Autorun....
        /*-------------------------------------------------------------------------*/

        function auto_run_module( )
        {
                // Guests don't have access here
                if ( !$this->ipsclass->member['id'] )
                {
                        $this->awards_lib->award_error('no_guests');
                }

                //-----------------------------------------
                // Prep form check
                //-----------------------------------------

                $this->md5_check = $this->ipsclass->return_md5_check();

                $this->ipsclass->load_language( 'lang_ucp' );
                $this->ipsclass->load_language( 'lang_awards_ucp' );
                $this->ipsclass->load_template( 'skin_awards_ucp' );


                $this->nav[] = "<a href='".$this->ipsclass->base_url."act=UserCP&amp;CODE=00'>".$this->ipsclass->lang['t_title']."</a>";

                //--------------------------------------------
                // Prep form check
                //--------------------------------------------

                switch($this->ipsclass->input['CODE'])
                {
                        case 'main':
                                $this->settings_awards();
                                break;
                        case 'savesettings':
                                $this->save_settings_awards();
                                break;
                        default:
                                $this->settings_awards();
                                break;
                }

                //--------------------------------------------
                // UserCP functions
                //--------------------------------------------

                require_once( ROOT_PATH."sources/lib/func_usercp.php" );
                $this->lib   = new func_usercp(&$this);
                $this->lib->ipsclass =& $this->ipsclass;

                $this->ipsclass->load_template( 'skin_ucp' );

                $this->output = $this->lib->ucp_generate_menu().$this->output;

                //-----------------------------------------
                // Let's finish it up and print the output
                //-----------------------------------------
                $fj = $this->ipsclass->build_forum_jump();
                $fj = preg_replace( "!#Forum Jump#!", $this->ipsclass->lang['forum_jump'], $fj);

                $this->output .= $this->ipsclass->compiled_templates['skin_ucp']->CP_end();
                $this->output .= $this->ipsclass->compiled_templates['skin_ucp']->forum_jump($fj, $links);

                $this->ipsclass->print->add_output("$this->output");

                $this->ipsclass->print->do_output( array( 'TITLE' => $this->page_title, 'JS' => 1, NAV => $this->nav ) );

        }

        /*-------------------------------------------------------------------------*/
        // Settings awards form
        /*-------------------------------------------------------------------------*/

        function settings_awards()
        {
                 //------------------------------------------
                 // select information aboun this member
                 //------------------------------------------

                 $this->ipsclass->DB->simple_construct( array( 'select' => 'mgroup, awards_tracker, awards_notice_type, awards_comments, awards_comments_notice',
                 											   'from' => 'members',
                 											   'where' => "id=".$this->ipsclass->member['id'] ) );
                 $this->ipsclass->DB->simple_exec();

                 $meminfo = $this->ipsclass->DB->fetch_row();

                 //-----------------------------------------
                 // get form header
                 //-----------------------------------------
                 $this->output .= $this->awards_lib->html_start_form( array( 1 => array( 'inc'   , 'ucp_main'),
                                                                             2 => array( 'CODE'  , 'savesettings'),
                                                                    )      );


				 //-----------------------------------------
				 // init comments
				 //-----------------------------------------
                 $comments_enable = 1;
    			 if( !$this->ipsclass->vars['awards_comments'] )
    			 {
    				 $comments_enable = 0;
    			 }

    			 if( !$this->ipsclass->member['g_awards_has_comments'] )
    			 {
    			 	 $comments_enable = 0;
    			 }

                 //-----------------------------------------
                 // Need notification or not?
                 //-----------------------------------------

                 $awards_notice = $meminfo['awards_tracker'] ? "<option value='1' selected='selected'>".$this->ipsclass->lang['yes']."</option>\n<option value='0'>".$this->ipsclass->lang['no']."</option>"
                                                                                            : "<option value='1'>".$this->ipsclass->lang['yes']."</option>\n<option value='0' selected='selected'>".$this->ipsclass->lang['no']."</option>";

                 $awards_comments = $meminfo['awards_comments'] ? "<option value='1' selected='selected'>".$this->ipsclass->lang['yes']."</option>\n<option value='0'>".$this->ipsclass->lang['no']."</option>"
                                                                                            : "<option value='1'>".$this->ipsclass->lang['yes']."</option>\n<option value='0' selected='selected'>".$this->ipsclass->lang['no']."</option>";

                 $awards_comments_notice = $meminfo['awards_comments_notice'] ? "<option value='1' selected='selected'>".$this->ipsclass->lang['yes']."</option>\n<option value='0'>".$this->ipsclass->lang['no']."</option>"
                                                                                            : "<option value='1'>".$this->ipsclass->lang['yes']."</option>\n<option value='0' selected='selected'>".$this->ipsclass->lang['no']."</option>";
                 $awards_notice_type = "<select name='awards_notice_type' class='forminput'>";

                 $awards_notice_type .= ($meminfo['awards_notice_type'] == 'pm') ? "<option value='pm' selected='selected'>".$this->ipsclass->lang['m_awards_notice_pm']."</option>\n<option value='email'>".$this->ipsclass->lang['m_awards_notice_email']."</option>"
                                                                                            : "<option value='pm'>".$this->ipsclass->lang['m_awards_notice_pm']."</option>\n<option value='email' selected='selected'>".$this->ipsclass->lang['m_awards_notice_email']."</option>";

				 if( $comments_enable )
				 {
				 	$comments = $this->ipsclass->compiled_templates['skin_awards_ucp']->awards_commets( array ( 'AWARDS_COMMENTS'        => $awards_comments."</select>",
                 																							    'AWARDS_COMMENTS_NOTICE' => $awards_comments_notice."</select>" )  );
      			 }
      			 else
      			 {
      			 	$comments = "";
      	         }

                 $this->output .= $this->ipsclass->compiled_templates['skin_awards_ucp']->awards_settings( array ( 'AWARDS_NOTICE'  => $awards_notice."</select>",
                                                                                                                   'NOTICE_TYPE'    => $awards_notice_type."</select>",
                                                                                                                   'COMMENTS'       => $comments, )  );

                 $this->page_title = $this->ipsclass->lang['t_welcome'];
                 $this->nav[] = "<a href='".$this->ipsclass->base_url."automodule=awards&amp;inc=ucp_main'>".$this->ipsclass->lang['awards_system_settings']."</a>";

        }

        /*-------------------------------------------------------------------------*/
        // Save settings
        /*-------------------------------------------------------------------------*/

        function save_settings_awards()
        {
                //-----------------------------------------
                // Nawty, Nawty!
                //-----------------------------------------

                if ($this->ipsclass->input['auth_key'] != $this->md5_check )
                {
                        $this->awards_lib->award_error('del_post');
                }

				//-----------------------------------------
				// init comments
				//-----------------------------------------
    			$comments_enable = 1;
    			if( !$this->ipsclass->vars['awards_comments'] )
    			{
    				 $comments_enable = 0;
    			}

    			if( !$this->ipsclass->member['g_awards_has_comments'] )
    			{
    			 	 $comments_enable = 0;
    			}

    			$save_data = array (  'awards_tracker'           => intval($this->ipsclass->input['awards_notice']) ? 1 : 0,
       						          'awards_notice_type'       => ($this->ipsclass->input['awards_notice_type'] == 'email') ? 'email' : 'pm',
       						          );

       			//---------------------------------
       			// comments enabled?
       			//---------------------------------
       			if( $comments_enable )
       			{
       				//---------------------------------
       				// Member can enamble comments system?
       				//---------------------------------
       				if( $this->ipsclass->vars['awards_comments_need_own'] )
       				{
       					$save_data['awards_comments'] = intval($this->ipsclass->input['awards_comments']) ? 1 : 0;
       				}

       				$save_data['awards_comments_notice'] = intval($this->ipsclass->input['awards_comments_notice']) ? 1 : 0;
       			}

                //-----------------------------------------
                // Save settings
                //-----------------------------------------

                $this->ipsclass->DB->do_update( 'members', $save_data, 'id='.$this->ipsclass->member['id']  );

                //-----------------------------------------
                // Redirect..
                //-----------------------------------------

                $this->ipsclass->print->redirect_screen( $this->ipsclass->lang['awards_save_settings'], "automodule=awards&inc=ucp_main" );

        }

}
?>