<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/

class awards_admin_sql_queries extends db_driver_mysql
{

     var $db  = "";
     var $tbl = "";

    /*========================================================================*/
    // Set up...
    /*========================================================================*/

    function sql_queries( $obj )
    {
            $this->db = $obj;

            if ( ! $this->db->obj['sql_tbl_prefix'] )
            {
                    $this->db->obj['sql_tbl_prefix'] = '".SQL_PREFIX."';
            }

            $this->tbl = $this->db->obj['sql_tbl_prefix'];
    }

    /*========================================================================*/



    /* SQL Queries for ad_groups.php */

    function get_groups( $a )
    {
            return "SELECT g.*, COUNT(m.id) as count
                           FROM ".SQL_PREFIX."groups g
                             LEFT JOIN ".SQL_PREFIX."members m ON (m.mgroup = g.g_id)
                             GROUP BY g.g_id ORDER BY g.g_title";
    }

    /* SQL Queries for ad_awtools.php */

    function recount_awards( $a )
    {
            return "SELECT COUNT(a.aid) as count, m.id as mid, m.members_cache
                           FROM ".SQL_PREFIX."members m
                           	 LEFT JOIN ".SQL_PREFIX."awards a ON(a.mid=m.id)
                           GROUP BY a.mid
                           LIMIT {$a['limit_a']},{$a['limit_b']}";
    }

    function rebuild_awards_get_members( $a )
    {
            return "SELECT id as mid, members_cache
                           FROM ".SQL_PREFIX."members m
                           LIMIT {$a['limit_a']},{$a['limit_b']}";
    }

    function clean_db_awards( $a )
    {
            return "SELECT a.aid,m.id
                           FROM ".SQL_PREFIX."awards a
                            LEFT JOIN ".SQL_PREFIX."members m ON (m.id = a.mid)
                           LIMIT {$a['limit_a']},{$a['limit_b']}";
    }


    function show_member_awards( $a )
    {
            return "SELECT a.aid, ai.*,
                           m.id, m.name, m.members_display_name
                           FROM ".SQL_PREFIX."awards a
                             LEFT JOIN ".SQL_PREFIX."awards_info ai ON (a.awards_id=ai.id)
                             LEFT JOIN ".SQL_PREFIX."members m ON(a.cid=m.id)
                           WHERE a.mid={$a['mid']}";
    }


    function show_member_reawarding( $a )
    {
            return "SELECT a.*,
                           ai.title,
                           m.id as a_id, m.members_display_name as a_name,
                           p.id as p_id, p.members_display_name as p_name
                           FROM ".SQL_PREFIX."awards a
                             LEFT JOIN ".SQL_PREFIX."members m ON (m.id=a.mid)
                             LEFT JOIN ".SQL_PREFIX."members p ON (p.id=a.cid)
                             LEFT JOIN ".SQL_PREFIX."awards_info ai ON (a.awards_id=ai.id)
                           WHERE a.aid={$a['aid']}";
    }


    function get_delete_award( $a )
    {
            return "SELECT a.aid, m.id, m.members_display_name, m.awards_cache, m.awards_dig, m.members_cache
                                FROM ".SQL_PREFIX."awards a
                                 LEFT JOIN ".SQL_PREFIX."members m ON (m.id=a.mid)
                                WHERE a.aid='{$a['aid']}'";
    }


} // end class


?>