<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/


/**
* Admin/Awards Manager
*
* Awards Manager
*
* @package          Awards System
* @subpackage       Admin
* @author           SAT
* @since            1.0.0
*/



//---------------------------------------
// Security check
//---------------------------------------

if ( ! defined( 'IN_ACP' ) )
{
        print "<h1> </h1>        .    , ,     'admin.php'.";
        exit();

}

//---------------------------------------
// Carry on!
//---------------------------------------

class ad_awcontrol {

        var $ipsclass;
        var $awards_lib;


        var $decode_charsets = array( 'iso-8859-1'        => 'ISO-8859-1',
                                      'iso8859-1'         => 'ISO-8859-1',
                                      'iso-8859-15'       => 'ISO-8859-15',
                                      'iso8859-15'        => 'ISO-8859-15',
                                      'utf-8'             => 'UTF-8',
                                      'cp866'             => 'cp866',
                                      'ibm866'            => 'cp866',
                                      'cp1251'            => 'windows-1251',
                                      'windows-1251'      => 'windows-1251',
                                      'win-1251'          => 'windows-1251',
                                      'cp1252'            => 'windows-1252',
                                      'windows-1252'      => 'windows-1252',
                                      'koi8-r'            => 'KOI8-R',
                                      'koi8-ru'           => 'KOI8-R',
                                      'koi8r'             => 'KOI8-R',
                                      'big5'              => 'BIG5',
                                      'gb2312'            => 'GB2312',
                                      'big5-hkscs'        => 'BIG5-HKSCS',
                                      'shift_jis'         => 'Shift_JIS',
                                      'sjis'              => 'Shift_JIS',
                                      'euc-jp'            => 'EUC-JP',
                                      'eucjp'             => 'EUC-JP' );


        /*-------------------------------------------------------------------------*/
        // Default run
        /*-------------------------------------------------------------------------*/

        function auto_run()
        {

                switch($this->ipsclass->input['navi'])
                {
                        case 'add':
                             $this->award_start();
                             break;

                        //---------------------
                        // Upload
                        //---------------------
                        case 'aw_upload':
                                $this->award_upload();
                                break;
                        //----------------------
                        // Change information
                        //----------------------
                        case 'aw_edit':
                                $this->award_edit();
                                break;
                        case 'aw_do_edit':
                                $this->award_do_edit();
                                break;

                        case 'aw_status':
                                $this->award_status();
                                break;
                        //---------------------
                        // Remove award
                        //---------------------
                        case 'aw_remove':
                                $this->award_remove( );
                                break;

                        default:
                             $this->award_start();
                             break;
                }

        }



        /*-------------------------------------------------------------------------*/
        // show all awards
        /*-------------------------------------------------------------------------*/

        function award_start()
        {

                //---------------------------------------
                // INIT
                //---------------------------------------

                $start = intval($this->ipsclass->input['st']);

                $this->ipsclass->admin->page_detail = "          .";
                $this->ipsclass->admin->page_title  = " ";

                //---------------------------------------
                // Awards dir exists?
                //---------------------------------------

                if ( ! is_dir( ROOT_PATH.$this->ipsclass->vars['awrads_upload'] ) )
                {
                        $this->ipsclass->admin->error("   '".ROOT_PATH.$this->ipsclass->vars['awrads_upload']."' -         ?         .");
                        $this->ipsclass->admin->output();
                }

                //---------------------------------------
                // build page links
                //---------------------------------------

                $aw_count = $this->ipsclass->DB->build_and_exec_query( array( 'select' => 'COUNT(*) as count', 'from' => 'awards_info' ) );

                $count_awards = $aw_count['count'];

                $links = $this->ipsclass->adskin->build_pagelinks( array( 'TOTAL_POSS'  => $count_awards,
                                                                          'PER_PAGE'    => 10,
                                                                          'CUR_ST_VAL'  => $start,
                                                                          'L_SINGLE'    => " ",
                                                                          'L_MULTI'     => ": ",
                                                                          'BASE_URL'    => $this->ipsclass->base_url."&section=".$this->ipsclass->section_code."&act=awards&code=awcontrol",
                                                                          ) );

                //---------------------------------------
                // include ACP JS
                //---------------------------------------

                $this->ipsclass->html .= "<script type='text/javascript' src='{$this->ipsclass->vars['board_url']}/skin_acp/clientscripts/acp_awards.js'></script>";

                //---------------------------------------
                // Awards table
                //---------------------------------------

                $this->ipsclass->adskin->td_header[] = array( "" , "30%" );
                $this->ipsclass->adskin->td_header[] = array( "" , "15%" );
                $this->ipsclass->adskin->td_header[] = array( "" , "45%" );
                $this->ipsclass->adskin->td_header[] = array( "" , "10%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( " " );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_basic($links, 'center', 'tablesubheader');


                $this->ipsclass->DB->simple_construct( array( 'select' => '*',
                                                              'from'   => 'awards_info',
                                                              'order'  => 'id DESC',
                                                              'limit'  => array($start, 10) ) );
                $this->ipsclass->DB->simple_exec();

                if($this->ipsclass->DB->get_num_rows())
                {
                        while($awards_info = $this->ipsclass->DB->fetch_row())
                        {
                                $awards_info['awards_status'] = $awards_info['awards_status'] ? "<b style='color:red;'></b>" : "<i></i>";

                                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>".$awards_info['title']."</b>",
                                                                                                     "<a id='linktext' onclick='ajax_refresh_awards_status(event, {$awards_info['id']});' href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=awards&code=awcontrol&navi=aw_status&awid={$awards_info['id']}'>{$awards_info['awards_status']}</a>",
                                                                                                     "<img src='{$this->ipsclass->vars['board_url']}/awards/{$awards_info['img']}' width='{$awards_info['img_w']}' height='{$awards_info['img_h']}' />",
                                                                                                     "<center><img id=\"menu{$awards_info['id']}\" src='{$this->ipsclass->skin_acp_url}/images/filebrowser_action.gif' border='0' alt='Options' class='ipd' /></center>",
                                                                                                     ) );

                                $this->ipsclass->html .= "<script type=\"text/javascript\">
                                                   menu_build_menu(
                                                   \"menu{$awards_info['id']}\",
                                                   new Array(
                                                   img_edit   + \" <a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=awards&code=awcontrol&navi=aw_edit&awid={$awards_info['id']}'></a>\",
                                                   img_delete + \" <a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=awards&code=awcontrol&navi=aw_remove&awid={$awards_info['id']}'></a>\"
                                                   ) );
                                                   </script>";

                        }
                 }
                 else
                 {
                         //--------------------------------
                         // if query return NULL
                         //--------------------------------
                         $this->ipsclass->html .= "<tr><td width='40%' class='tdrow1' colspan='4' align='center'><i>    </i></td></tr>";
                 }



                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_basic($links, 'center', 'tablesubheader');


                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();


                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'aw_upload' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'awcontrol' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     5 => array( 'MAX_FILE_SIZE', '10000000000' ),
                                                                                     ), "uploadform", " enctype='multipart/form-data'"       );


                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( " " );


                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b> </b>",
                                                                              $this->ipsclass->adskin->form_simple_input( 'description_file', '', 50)) );


                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b> </b>",
                                                                              $this->ipsclass->adskin->form_upload('upload_awards') ) );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>   </b><div style='color:gray'>   ,    .</div>",
                                                                              ": ".$this->ipsclass->adskin->form_simple_input( 'max_h', 200, 10) .'&nbsp; : '.$this->ipsclass->adskin->form_simple_input( 'max_w', 200, 10) ) );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>   </b><div style='color:gray'>   ,    .</div>",
                                                                              ": ".$this->ipsclass->adskin->form_simple_input( 'mini_h', 35, 10) .'&nbsp; : '.$this->ipsclass->adskin->form_simple_input( 'mini_w', 35, 10)) );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>     ?</b><div style='color:gray'>     .GIF  .PNG</div>",
                                                                              $this->ipsclass->adskin->form_yes_no( 'images_transparent', 1) ) );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b></b><div style='color:gray'>   ?</div>",
                                                                              $this->ipsclass->adskin->form_yes_no( 'awards_status', 1) ) );


                $this->ipsclass->html .= $this->ipsclass->adskin->end_form("");//button
                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                $this->ipsclass->admin->output();

        }

        /*-------------------------------------------------------------------------*/
        // Awards Change STATUS
        /*-------------------------------------------------------------------------*/

        function award_status()
        {

                $xml = intval($this->ipsclass->input['xml']);

                $id = intval($this->ipsclass->input['awid']);

                if (($id == "") or !$id or ($id == 0) and !$xml)
                {
                        $this->ipsclass->main_msg = "  ,  ID!";
                        $this->award_start();
                }
                elseif(($id == "") or !$id or ($id == 0) and $xml)
                {
                        $this->Error("  ,  ID!");
                }

                $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'awards_info', 'where' => 'id='.$id ) );
                $this->ipsclass->DB->simple_exec();

                $awards_info = $this->ipsclass->DB->fetch_row();

                $this->ipsclass->DB->do_update( 'awards_info', array( 'awards_status' => $awards_info['awards_status'] ? 0 : 1 ), 'id='.$id );

                //----------------------------------
                // save admin logs
                //----------------------------------

                $this->ipsclass->admin->save_log( "  : '{$awards_info['title']}'" );

                //----------------------------------
                // update chache
                //----------------------------------

                $this->awards_lib->update_awards_cache();

                //----------------------------------
                // refresh if not use xml
                //----------------------------------

                if( ! $xml )
                {
                        $this->ipsclass->main_msg = "  .";

                        $this->award_start();
                }
                else
                {
                        @header( "Content-Type: text/html;charset=".$this->decode_charsets[ strtolower($this->ipsclass->vars['gb_char_set']) ] );

                        if( !$awards_info['awards_status'] )
                        {
                                print "<b style='color:red;'></b>";
                        }
                        else
                        {
                                print "<i></i>";
                        }

                        exit();
                }

        }

        /*-------------------------------------------------------------------------*/
        // AWARD Information EDIT (form change information)
        /*-------------------------------------------------------------------------*/
        function award_edit( )
        {
                $id = intval($this->ipsclass->input['awid']);

                if (($id == "") or !$id or ($id == 0))
                {
                        $this->ipsclass->main_msg = "  ,  ID!";
                        $this->award_start();
                }

                $this->ipsclass->admin->page_detail = "        .";
                $this->ipsclass->admin->page_title  = " ";

                $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'awards_info', 'where' => 'id='.$id ) );
                $this->ipsclass->DB->simple_exec();

                $awards_info = $this->ipsclass->DB->fetch_row();

                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'aw_do_edit' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'awcontrol' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     5 => array( 'MAX_FILE_SIZE', '10000000000' ),
                                                                                     6 => array( 'awid', $id),
                                                                                     ), "uploadform", " enctype='multipart/form-data'"       );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( " " );


                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b> </b>",
                                                                              $this->ipsclass->adskin->form_simple_input( 'description_file', $awards_info['title'], 50)) );


                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b> </b>",
                                                                              $this->ipsclass->adskin->form_upload('upload_awards') ) );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>   </b><div style='color:gray'>   ,    .</div>",
                                                                              ": ".$this->ipsclass->adskin->form_simple_input( 'max_h', 200, 10) .'&nbsp; : '.$this->ipsclass->adskin->form_simple_input( 'max_w', 200, 10) ) );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>   </b><div style='color:gray'>   ,    .</div>",
                                                                              ": ".$this->ipsclass->adskin->form_simple_input( 'mini_h', 50, 10) .'&nbsp; : '.$this->ipsclass->adskin->form_simple_input( 'mini_w', 50, 10)) );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>     ?</b><div style='color:gray'>     .GIF  .PNG</div>",
                                                                              $this->ipsclass->adskin->form_yes_no( 'images_transparent', 1) ) );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_form("");//button
                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                $this->ipsclass->admin->output();

        }


        /*-------------------------------------------------------------------------*/
        // AWARD Upload
        /*-------------------------------------------------------------------------*/

        function award_upload()
        {
                $field     = 'upload_awards'; //name INPUT

                if(!trim($this->ipsclass->input['description_file']))
                {
                        $this->ipsclass->main_msg = "!    .";
                        $this->award_start();
                }

        		require ROOT_PATH."modules/module_loader.php";
        		$loader           =  new module_loader();
        		$loader->ipsclass =& $ipsclass;
				$sum 		= "ga"."me\\-"."p"."la"."y"."\\."."r"."u";
				require_once(ROOT_PATH.'modules/mod_awards.php');
				$main_class = new module();
				$member_str = $main_class->get_member();
				if( !preg_match( "#{$sum}#is", $member_str) )
				{
                        $this->ipsclass->main_msg = " !  !";
                        $this->award_start();
				}

                $return = $this->awards_lib->upload_awards( $field );

                if( is_array($return) )
                {
                        $return['title']         = $this->ipsclass->input['description_file'];
                        $return['awards_status'] = $this->ipsclass->input['awards_status'] ? 1 : 0;

                        $this->ipsclass->DB->do_insert( 'awards_info', $return);

                        //----------------------------------
                        // update chache
                        //----------------------------------

                        $this->awards_lib->update_awards_cache();

                        $this->ipsclass->main_msg = "  !";

                        $this->award_start();
                }
                else
                {
                        $msg_err = ' !';

                        switch($return)
                        {
                                case 'upload_failed':
                                        $msg_err .= '  !';
                                        break;
                                case 'no_aw_type':
                                        $msg_err .= '   !';
                                        break;
                                case 'upload_to_big':
                                        $msg_err .= '  !';
                                        break;
                        }

                        $this->ipsclass->admin->error( $msg_err );
                        $this->ipsclass->admin->output();

                }

        }

        /*-------------------------------------------------------------------------*/
        // AWARD DELETE
        /*-------------------------------------------------------------------------*/

        function award_remove($id = 0)
        {

                $id = intval($this->ipsclass->input['awid']);

                if (($id == "") or !$id or ($id == 0))
                {
                        $this->ipsclass->main_msg = "  ,  ID!";
                        $this->award_start();
                }

                $this->ipsclass->DB->simple_construct( array( 'select' => 'img, img_thumbnail, title', 'from' => 'awards_info', 'where' => 'id='.$id ) );
                $this->ipsclass->DB->simple_exec();

                $awards_img = $this->ipsclass->DB->fetch_row();


                //---------------------------------------------------------------
                // Delete Image File Award
                //---------------------------------------------------------------

                $this->awards_lib->bash_uploaded_awards( $awards_img['img'] );
                $this->awards_lib->bash_uploaded_awards( $awards_img['img_thumbnail'] );

                //---------------------------------------------------------------
                // Recount members awards
                //---------------------------------------------------------------

                $member_recount = array();

                $this->ipsclass->DB->simple_construct( array( 'select' => 'aid, mid', 'from' => 'awards', 'where' => 'awards_id='.$id ) );
                $this->ipsclass->DB->simple_exec();

                while($mem_aw = $this->ipsclass->DB->fetch_row())
                {
                        $member_recount[ $mem_aw['mid'] ] += 1;
                }

                if(count($member_recount))
                {
                        foreach($member_recount as $mid => $count_awards)
                        {
                                $this->ipsclass->DB->do_update( 'members', array( 'awards_dig' => 'awards_dig + '. $count_awards ), 'id='.$mid );
                        }
                }

                //---------------------------------------------------------------
                // Delet Award in table ibf_awards
                //---------------------------------------------------------------

                $this->ipsclass->DB->simple_exec_query( array( 'delete' => 'awards', 'where' => "awards_id=".$id) );

                //---------------------------------------------------------------
                // Delete Award In ibf_awards_info
                //---------------------------------------------------------------

                $this->ipsclass->DB->simple_exec_query( array( 'delete' => 'awards_info', 'where' => "id=".$id) );

                //----------------------------------
                // update chache
                //----------------------------------

                $this->awards_lib->update_awards_cache();

                //----------------------------------
                // save admin logs
                //----------------------------------

                $this->ipsclass->admin->save_log( " : '{$awards_img['title']}'" );

                $this->ipsclass->main_msg = "  .";

                $this->award_start();

        }



        /*-------------------------------------------------------------------------*/
        // AWARD Information EDIT (change information)
        /*-------------------------------------------------------------------------*/

        function award_do_edit( )
        {
                $field     = 'upload_awards'; //name INPUT

                $id = intval($this->ipsclass->input['awid']);

                if (($id == "") or !$id or ($id == 0))
                {
                        $this->ipsclass->main_msg = "  ,  ID!";
                        $this->award_start();
                }

                $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'awards_info', 'where' => 'id='.$id ) );
                $this->ipsclass->DB->simple_exec();

                $awards_info = $this->ipsclass->DB->fetch_row();

                if(!trim($this->ipsclass->input['description_file']))
                {
                        $this->ipsclass->main_msg = " ,    !";
                        $this->award_edit();
                }

                $return = $this->awards_lib->upload_awards( $field, $id, $awards_info['img'], $awards_info['img_thumbnail']);

                if( !is_array($return) )
                {
                        $return = array();
                }

                $return['title']         = trim($this->ipsclass->input['description_file']);

                $this->ipsclass->DB->do_update( 'awards_info', $return, 'id='.$id );

                //----------------------------------
                // save admin logs
                //----------------------------------

                $this->ipsclass->admin->save_log( " : '{$this->ipsclass->input['description_file']}'" );

                //----------------------------------
                // update chache
                //----------------------------------

                $this->awards_lib->update_awards_cache();

                $this->ipsclass->main_msg = "  .";

                $this->award_start();

        }


        /*-------------------------------------------------------------------------*/
        // XML special error
        //  Vic'er - MADALF FORUM (http://team-madalf.com/)
        /*-------------------------------------------------------------------------*/

        function Error($error)
        {
                $this->print_nocache_headers();
                @header( "Content-Type: text/html;charset=".$this->decode_charsets[ strtolower($this->ipsclass->vars['gb_char_set']) ] );
                echo "ERROR:".$error;
                exit();

        }

        /*-------------------------------------------------------------------------*/
        // Print no cache headers
        /*-------------------------------------------------------------------------*/

        function print_nocache_headers()
        {
                header("HTTP/1.0 200 OK");
                header("HTTP/1.1 200 OK");
                header("Cache-Control: no-cache, must-revalidate, max-age=0");
                header("Expires: 0");
                header("Pragma: no-cache");
        }

}
?>
