<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/


/**
* Admin/Tools Manager
*
* Recout and Rebuild tools
*
* @package          Awards System
* @subpackage       Admin
* @author           SAT
* @since            1.0.0
*/



//---------------------------------------
// Security check
//---------------------------------------

if ( ! defined( 'IN_ACP' ) )
{
        print "<h1> </h1>        .    , ,     'admin.php'.";
        exit();

}

//---------------------------------------
// Carry on!
//---------------------------------------

class ad_awtools {

        var $ipsclass;
        var $awards_lib;


        /*-------------------------------------------------------------------------*/
        // Default run
        /*-------------------------------------------------------------------------*/

        function auto_run()
        {


                switch($this->ipsclass->input['navi'])
                {
                        case 'recount_awards':
                               $this->recount_awards();
                               break;
                        case 'rebuild_awards':
                                $this->rebuild_awards();
                                break;
                        case 'rebuild_awards_cache':
                                $this->rebuild_awards_cache();
                                break;
                        case 'cleanawards':
                                $this->clean_awards();
                                break;
                        case 'cleanawardsdb':
                                $this->clean_awards_db();
                                break;
                        case 'rebuild_images':
                                $this->rebuild_images();
                                break;
                        case 'rebuild_img_awards':
                                $this->rebuild_img_awards();
                                break;
                        default:
                             $this->show_tools();
                             break;
                }

        }

        /*-------------------------------------------------------------------------*/
        // Group Permission Stuff
        /*-------------------------------------------------------------------------*/

        function show_tools()
        {
                // Page Information
                $this->ipsclass->admin->page_title   = "Awards Tools";
                //$this->ipsclass->admin->page_detail  = "Here you will find a some tools for rebuild and recount awards information";
                $this->ipsclass->admin->page_detail  = "        ";

                //-----------------------------------------
                // Recount awards numeric statics
                //-----------------------------------------

                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'recount_awards' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'awtools' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     )      );

                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "60%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "40%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( "  (Recount Member's Awards)" );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b> </b><div style='color:gray'>     .<br />
                                                                                           ,      ,    .</div>",
                                                                                                                       " ".      $this->ipsclass->adskin->form_simple_input( 'pergo', '500', 5 ). "&nbsp;   "
                                                                                                           )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_form('  ');

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                //-----------------------------------------
                // Rebuild awards images(Convert image AS 2.1.0 -> 3.0.0)
                // Syncronysed image id and awards id
                //-----------------------------------------

                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'rebuild_images' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'awtools' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     )      );

                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "60%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "40%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( " " );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b> </b><div style='color:gray'>            </div>
                                                                                       :           2.1.0   3.0.0<br />
                                                                                          10   .",
                                                                                                                       " ".      $this->ipsclass->adskin->form_simple_input( 'pergo', '10', 5 ). "&nbsp; "
                                                                                                           )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_form(' ');

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                //-----------------------------------------
                // Rebuild awards images statics
                //-----------------------------------------

                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'rebuild_awards' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'awtools' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     )      );

                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "60%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "40%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( "   (Rebuild Member's Image Awards)" );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>   </b><div style='color:gray'>
                                                                                                 ,           .</div>
                                                                                       :      .<br />
                                                                                           100   .",
                                                                                                                       " ".      $this->ipsclass->adskin->form_simple_input( 'pergo', '100', 5 ). "&nbsp; "
                                                                                                           )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_form('  ');

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();



                //-----------------------------------------
                // Clean up uploaded awards
                //-----------------------------------------


                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'cleanawards' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'awtools' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     )      );

                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "60%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "40%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( "   (Clean out awards images)" );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>   </b><div style='color:gray'>        ,    .</div>:      .",
                                                                                                                           " ".
                                                                                                                           $this->ipsclass->adskin->form_simple_input( 'pergo', '50', 5 ). "&nbsp; "
                                                                                                                )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_form('   ');

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();


                //-----------------------------------------
                // Rebuild bigest awards images
                //-----------------------------------------


                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'rebuild_img_awards' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'awtools' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     )      );

                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "60%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "40%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( "  (Rebuild Image Awards)" );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>  </b><div style='color:gray'>        .</div>:      .",
                                                                                                                           " ".
                                                                                                                           $this->ipsclass->adskin->form_simple_input( 'pergo', '10', 5 ). "&nbsp; <br /><hr />".
                                                                                                                           "<br /><b> :</b><br />".
                                                                                                                           ": ".$this->ipsclass->adskin->form_simple_input( 'max_h', 200, 10) .'&nbsp; : '.$this->ipsclass->adskin->form_simple_input( 'max_w', 200, 10).
                                                                                                                           "<hr /><br /><b> :</b><br />".
                                                                                                                           ": ".$this->ipsclass->adskin->form_simple_input( 'mini_h', 35, 10) .'&nbsp; : '.$this->ipsclass->adskin->form_simple_input( 'mini_w', 35, 10).
                                                                                                                           "<hr /><br /><b> ?</b><br />     .GIF  .PNG<br />".
                                                                                                                           $this->ipsclass->adskin->form_yes_no( 'transp', 1)
                                                                                                                )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_form('');

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();


                //-----------------------------------------
                // Clean up DB awards
                //-----------------------------------------


                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'cleanawardsdb' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'awtools' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     )      );

                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "60%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "40%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( "   (Clean out awards in DB)" );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>      </b><div style='color:gray'>      ,            .</div>",
                                                                                                                           " ".
                                                                                                                           $this->ipsclass->adskin->form_simple_input( 'pergo', '500', 5 ). "&nbsp; "
                                                                                                                )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_form('  ');

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                //-----------------------------------------
                // Rebuild awards cache
                //-----------------------------------------

                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'rebuild_awards_cache' ),
                                                                                     2 => array( 'act'   , 'awards' ),
                                                                                     3 => array( 'code'  , 'awtools' ),
                                                                                     4 => array( 'section', $this->ipsclass->section_code ),
                                                                                     )      );

                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "100%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( "  (Rebuild Awards Cache)" );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>  </b><div style='color:gray'>
                                                                                            .<br />
                                                                                         ,               SQL Tools.</div>"
                                                                                                           )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_form(' ');

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                $this->ipsclass->admin->output();
        }

        /*-------------------------------------------------------------------------*/
        // Rebuild images
        /*-------------------------------------------------------------------------*/

        function rebuild_img_awards()
        {

                //-----------------------------------------
                // Set up
                //-----------------------------------------

                $done   = 0;
                $start  = intval( $this->ipsclass->input['st'] );
                $end    = intval( $this->ipsclass->input['pergo'] ) ? intval( $this->ipsclass->input['pergo'] ) : 10;
                $end   += $start;

                $awards_to_rebuild = array();

                $this->ipsclass->input['max_w'] = intval($this->ipsclass->input['max_w']);
                $this->ipsclass->input['max_w']  = $this->ipsclass->input['max_w'] > 0 ? $this->ipsclass->input['max_w'] : 200;

                $this->ipsclass->input['max_h'] = intval($this->ipsclass->input['max_h']);
                $this->ipsclass->input['max_h'] = $this->ipsclass->input['max_h'] > 0 ? $this->ipsclass->input['max_h'] : 200;

                $this->ipsclass->input['mini_w'] = intval($this->ipsclass->input['mini_w']);
                $this->ipsclass->input['mini_w']  = $this->ipsclass->input['mini_w'] > 0 ? $this->ipsclass->input['mini_w'] : 35;

                $this->ipsclass->input['mini_h'] = intval($this->ipsclass->input['mini_h']);
                $this->ipsclass->input['mini_h'] = $this->ipsclass->input['mini_h'] > 0 ? $this->ipsclass->input['mini_h'] : 35;

                $this->ipsclass->input['transp'] = intval($this->ipsclass->input['transp']) ? 1 : 0;

                //-----------------------------------------
                // Init lib...
                //-----------------------------------------

                require_once( KERNEL_PATH.'class_image.php' );
                $image = new class_image();

                require_once( ROOT_PATH.'modules/awards/lib/image_lib.php' );

                $image_save_transparent_lib                = new image__transparent_lib( $this );
                $image_save_transparent_lib->ipsclass      = &$this->ipsclass;
                $image_save_transparent_lib->ips_image_lib = &$image;
                $image_save_transparent_lib->init_lib();

                //-----------------------------------------
                // save forum file if uploards dir not exists
                //-----------------------------------------

                if( !is_dir(ROOT_PATH.$this->ipsclass->vars['awrads_upload']) )
                {
                        $text = "<b>     </b>";
                        $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                        $time = 5;

                        //-----------------------------------------
                        // Bye....
                        //-----------------------------------------

                        $this->ipsclass->admin->redirect( $url, $text, 0, $time );
                }


                //-----------------------------------------
                // Avoid limit...
                //-----------------------------------------

                 $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'awards_info', 'limit' => array($start, $end), 'order' => 'id ASC' ) );
                 $this->ipsclass->DB->simple_exec();

                 while( $aw = $this->ipsclass->DB->fetch_row( ) )
                 {
                         $parse_on_standart_lib = false;

                         $img_attributes = @GetImageSize(ROOT_PATH.$this->ipsclass->vars['awrads_upload'].'/'.$aw['img']);

                         //--------------------------
                         // has image?
                         //--------------------------

                         if( (intval($img_attributes[1]) <= 0) or (intval($img_attributes[0]) <= 0) )
                         {
                                 continue;
                         }

                         // has image, allright :) process...

                         $im['img']                                 = $aw['img'];
                         $awards_to_rebuild[ $aw['id'] ]['img']     = $aw['img'];
                         $awards_to_rebuild[ $aw['id'] ]['img_h']   = $img_attributes[1];
                         $awards_to_rebuild[ $aw['id'] ]['img_w']   = $img_attributes[0];

                         //------------------------------
                         // delete extesion
                         //------------------------------

                         $aw['img']     = preg_replace("#\..+?$#is", "", $aw['img']);

                         //------------------------------
                         // rebuild bigest images
                         //------------------------------

                         if( ($img_attributes[2] == 1 or $img_attributes[2] == 3)
                              and !$image_save_transparent_lib->non_gd_201
                              and $this->ipsclass->input['transp'] )
                         {
                                 $image_save_transparent_lib->newwidth  = $this->ipsclass->input['max_w'];
                                 $image_save_transparent_lib->newheight = $this->ipsclass->input['max_h'];

                                 $image_save_transparent_lib->dir_filename_in = ROOT_PATH.$this->ipsclass->vars['awrads_upload'];
                                 $image_save_transparent_lib->filename_in     = $im['img'];
                                 $image_save_transparent_lib->filename_out    = $aw['img'];

                                 $return_max = $image_save_transparent_lib->resize_transparent();

                                 if( $return_max === FALSE)
                                 {
                                         $parse_on_standart_lib = true;
                                 }
                                 elseif( $return_max['thumb_location'] )
                                 {
                                         $awards_to_rebuild[ $aw['id'] ]['img']     = $return_max['thumb_location'];
                                         $awards_to_rebuild[ $aw['id'] ]['img_w']   = $return_max['thumb_width'];
                                         $awards_to_rebuild[ $aw['id'] ]['img_h']   = $return_max['thumb_height'];

                                         //-----------------------------------------
                                         // unlink old files
                                         //-----------------------------------------

                                         if( ($im['img'] != $awards_to_rebuild[ $aw['id'] ]['img']) and $im['img'] )
                                         {
                                                 $this->awards_lib->bash_uploaded_awards( $im['img'] );
                                         }

                                 }
                         }
                         else
                         {
                                 $parse_on_standart_lib = true;
                         }

                         if( $parse_on_standart_lib )
                         {
                                 $image->in_type        = 'file';
                                 $image->out_type       = 'file';
                                 $image->in_file_dir    = ROOT_PATH.$this->ipsclass->vars['awrads_upload'];
                                 $image->in_file_name   = $im['img'];
                                 $image->out_file_name  = $aw['img'];

                                 $image->desired_width  = $this->ipsclass->input['max_w'];
                                 $image->desired_height = $this->ipsclass->input['max_h'];

                                 $return_max = $image->generate_thumbnail();

                                 if($return_max['thumb_location'])
                                 {
                                         $awards_to_rebuild[ $aw['id'] ]['img']     = $return_max['thumb_location'];
                                         $awards_to_rebuild[ $aw['id'] ]['img_w']   = $return_max['thumb_width'];
                                         $awards_to_rebuild[ $aw['id'] ]['img_h']   = $return_max['thumb_height'];

                                         //-----------------------------------------
                                         // unlink old files
                                         //-----------------------------------------

                                         if( ($im['img'] != $return_max['thumb_location']) and $im['img'] )
                                         {
                                                 $this->awards_lib->bash_uploaded_awards( $im['img'] );
                                         }
                                 }

                         }


                         if( !$parse_on_standart_lib )
                         {
                                 $image_save_transparent_lib->newwidth  = $this->ipsclass->input['mini_w'];
                                 $image_save_transparent_lib->newheight = $this->ipsclass->input['mini_h'];

                                 $image_save_transparent_lib->dir_filename_in = ROOT_PATH.$this->ipsclass->vars['awrads_upload'];
                                 $image_save_transparent_lib->filename_in     = $im['img'];
                                 $image_save_transparent_lib->filename_out    = $aw['img'].'_thumbnail';

                                 $return_mini = $image_save_transparent_lib->resize_transparent();

                                 if( $return_mini['thumb_location'] )
                                 {
                                         $awards_to_rebuild[ $aw['id'] ]['img_thumbnail'] = $return_mini['thumb_location'];
                                         $awards_to_rebuild[ $aw['id'] ]['thumbnail_w']   = $return_mini['thumb_width'];
                                         $awards_to_rebuild[ $aw['id'] ]['thumbnail_h']   = $return_mini['thumb_height'];

                                         //-----------------------------------------
                                         // unlink old files
                                         //-----------------------------------------

                                         if( ($aw['img_thumbnail'] != $return_mini['thumb_location']) and $aw['img_thumbnail'] )
                                         {
                                                 $this->awards_lib->bash_uploaded_awards( $aw['img_thumbnail'] );
                                         }

                                 }
                                 elseif( !$return_mini['thumb_location'] and $aw['img_thumbnail'] )
                                 {
                                         $this->awards_lib->bash_uploaded_awards( $aw['img_thumbnail'] );
                                         $awards_to_rebuild[ $aw['id'] ]['img_thumbnail'] = '';
                                         $awards_to_rebuild[ $aw['id'] ]['thumbnail_w']   = 0;
                                         $awards_to_rebuild[ $aw['id'] ]['thumbnail_h']   = 0;
                                 }
                         }
                         else
                         {
                                 $image->in_type        = 'file';
                                 $image->out_type       = 'file';
                                 $image->in_file_dir    = ROOT_PATH.$this->ipsclass->vars['awrads_upload'];
                                 $image->in_file_name   = $im['img'];
                                 $image->out_file_name  = $aw['img'].'_thumbnail';

                                 $image->desired_width  = $this->ipsclass->input['mini_w'];
                                 $image->desired_height = $this->ipsclass->input['mini_h'];

                                 $return_mini = $image->generate_thumbnail();

                                 if($return_mini['thumb_location'])
                                 {
                                         $awards_to_rebuild[ $aw['id'] ]['img_thumbnail'] = $return_mini['thumb_location'];
                                         $awards_to_rebuild[ $aw['id'] ]['thumbnail_w']   = $return_mini['thumb_width'];
                                         $awards_to_rebuild[ $aw['id'] ]['thumbnail_h']   = $return_mini['thumb_height'];

                                         //-----------------------------------------
                                         // unlink old files
                                         //-----------------------------------------

                                         if( ($aw['img_thumbnail'] != $return_mini['thumb_location']) and $aw['img_thumbnail'] )
                                         {
                                                 $this->awards_lib->bash_uploaded_awards( $aw['img_thumbnail'] );
                                         }

                                 }
                                 elseif( !$return_mini['thumb_location'] and $aw['img_thumbnail'] )
                                 {
                                         $this->awards_lib->bash_uploaded_awards( $aw['img_thumbnail'] );
                                         $awards_to_rebuild[ $aw['id'] ]['img_thumbnail'] = '';
                                         $awards_to_rebuild[ $aw['id'] ]['thumbnail_w']   = 0;
                                         $awards_to_rebuild[ $aw['id'] ]['thumbnail_h']   = 0;
                                 }
                         }

                 }


                //-----------------------------------------
                // Process save changes...
                //-----------------------------------------

                if( count($awards_to_rebuild) )
                {
                        foreach($awards_to_rebuild as $_id => $data)
                        {
                                $this->ipsclass->DB->do_update( 'awards_info', $data, 'id='.$_id );
                        }

                        $done++;
                }

                //-----------------------------------------
                // Finish - or more?...
                //-----------------------------------------

                if ( ! $done  )
                {
                         //-----------------------------------------
                        // Done..
                        //-----------------------------------------

                        $text = "<b>   </b>";
                        $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                        $time = 2;

                        //-------------------------
                        // update cache
                        //-------------------------

                        $this->awards_lib->update_awards_cache();
                }
                else
                {
                        //-----------------------------------------
                        // More..
                        //-----------------------------------------

                        $text = "<b> : $end, ...</b>";

                        $url  = "{$this->ipsclass->form_code}&navi=".$this->ipsclass->input['navi'].
                                                            '&code='.$this->ipsclass->input['code'].
                                                            '&pergo='.$this->ipsclass->input['pergo'].
                                                            '&max_w='.$this->ipsclass->input['max_w'].
                                                            '&max_h='.$this->ipsclass->input['max_h'].
                                                            '&mini_w='.$this->ipsclass->input['mini_w'].
                                                            '&mini_h='.$this->ipsclass->input['mini_h'].
                                                            '&transp='.$this->ipsclass->input['transp'].
                                                            '&st='.$end;
                        $time = 0;
                }

                //-----------------------------------------
                // Bye....
                //-----------------------------------------

                $this->ipsclass->admin->redirect( $url, $text, 0, $time );

        }

        /*-------------------------------------------------------------------------*/
        // Rebuild images
        // ~~~~~~~~~~~~~~~~~~~~~~~
        // Convert format images from 2.1.0 to 3.0.0
        /*-------------------------------------------------------------------------*/

        function rebuild_images()
        {
                //-----------------------------------------
                // Set up
                //-----------------------------------------

                $done   = 0;
                $start  = intval( $this->ipsclass->input['st'] );
                $end    = intval( $this->ipsclass->input['pergo'] ) ? intval( $this->ipsclass->input['pergo'] ) : 10;
                $end   += $start;

                $awards_to_rebuild = array();

                //-----------------------------------------
                // Init lib...
                //-----------------------------------------

                require_once( KERNEL_PATH.'class_upload.php' );

                $upload = new class_upload();

                //-----------------------------------------
                // save forum file if uploards dir not exists
                //-----------------------------------------

                if( !is_dir(ROOT_PATH.$this->ipsclass->vars['awrads_upload']) )
                {
                        $text = "<b>     </b>";
                        $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                        $time = 5;

                        //-----------------------------------------
                        // Bye....
                        //-----------------------------------------

                        $this->ipsclass->admin->redirect( $url, $text, 0, $time );
                }


                //-----------------------------------------
                // Avoid limit...
                //-----------------------------------------

                 $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'awards_info', 'limit' => array($start, $end), 'order' => 'id ASC' ) );
                 $this->ipsclass->DB->simple_exec();

                 while( $aw = $this->ipsclass->DB->fetch_row( ) )
                 {
                         if( $aw['img'] != '' and @file_exists(ROOT_PATH.$this->ipsclass->vars['awrads_upload']."/".$aw['img']) )
                         {
                                 $img_ext = $upload->_get_file_extension( $aw['img'] );

                                 $new_name = "aw-{$aw['id']}.{$img_ext}";

                                 if( @rename( ROOT_PATH.$this->ipsclass->vars['awrads_upload']."/".$aw['img'] , ROOT_PATH.$this->ipsclass->vars['awrads_upload']."/".$new_name) )
                                 {
                                         $awards_to_rebuild[ $aw['id'] ]['img'] = $new_name;

                                         if( $aw['img_thumbnail'] != '' and @file_exists(ROOT_PATH.$this->ipsclass->vars['awrads_upload']."/".$aw['img_thumbnail']) )
                                         {
                                                 $img_ext = $upload->_get_file_extension( $aw['img_thumbnail'] );

                                                 $new_name_thumbnail = "aw-{$aw['id']}_thumbnail.{$img_ext}";

                                                 if( @rename( ROOT_PATH.$this->ipsclass->vars['awrads_upload']."/".$aw['img_thumbnail'] , ROOT_PATH.$this->ipsclass->vars['awrads_upload']."/".$new_name_thumbnail) )
                                                 {
                                                         $awards_to_rebuild[ $aw['id'] ]['img_thumbnail'] = $new_name_thumbnail;
                                                 }
                                         }
                                 }

                         }

                 }



                //-----------------------------------------
                // Process...
                //-----------------------------------------

                if( count($awards_to_rebuild) )
                {
                        foreach($awards_to_rebuild as $_id => $data)
                        {
                                $this->ipsclass->DB->do_update( 'awards_info', $data, 'id='.$_id );
                        }

                        $done++;
                }


                //-----------------------------------------
                // Finish - or more?...
                //-----------------------------------------

                if ( ! $done  )
                {
                         //-----------------------------------------
                        // Done..
                        //-----------------------------------------

                        $text = "<b>   </b>";
                        $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                        $time = 2;

                        //-------------------------
                        // update cache
                        //-------------------------

                        $this->awards_lib->update_awards_cache();
                }
                else
                {
                        //-----------------------------------------
                        // More..
                        //-----------------------------------------

                        $text = "<b> : $end, ...</b>";
                        $url  = "{$this->ipsclass->form_code}&navi=".$this->ipsclass->input['navi'].'&code='.$this->ipsclass->input['code'].'&pergo='.$this->ipsclass->input['pergo'].'&st='.$end;
                        $time = 0;
                }

                //-----------------------------------------
                // Bye....
                //-----------------------------------------

                $this->ipsclass->admin->redirect( $url, $text, 0, $time );
        }


        /*-------------------------------------------------------------------------*/
        // Clean out awards in DB
        /*-------------------------------------------------------------------------*/

        function clean_awards_db()
        {

                //-----------------------------------------
                // Set up
                //-----------------------------------------

                $done   = 0;
                $start  = intval( $this->ipsclass->input['st'] );
                $end    = intval( $this->ipsclass->input['pergo'] ) ? intval( $this->ipsclass->input['pergo'] ) : 500;
                $end   += $start;
                $awards_to_delete = array();

                //-----------------------------------------
                // Avoid limit...
                //-----------------------------------------

                $this->ipsclass->DB->cache_add_query( 'clean_db_awards' , array( 'limit_a' => $start,
                                                                                 'limit_b' => $end ), 'awards_admin_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                //-----------------------------------------
                // Process...
                //-----------------------------------------

                while( $r = $this->ipsclass->DB->fetch_row( $outer ) )
                {
                        if( !intval($r['id']) )
                        {
                                $awards_to_delete[] = $r['aid'];
                        }

                        $done++;
                }

                if( count($awards_to_delete) )
                {
                        $this->ipsclass->DB->simple_exec_query( array( 'delete' => 'awards', 'where' => "aid IN(".implode(',',$awards_to_delete).")" ) );
                }


                //-----------------------------------------
                // Finish - or more?...
                //-----------------------------------------

                if ( ! $done  )
                {
                         //-----------------------------------------
                        // Done..
                        //-----------------------------------------

                        $text = "<b> </b>";
                        $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                        $time = 2;
                }
                else
                {
                        //-----------------------------------------
                        // More..
                        //-----------------------------------------

                        $text = "<b> : $end, ...</b>";
                        $url  = "{$this->ipsclass->form_code}&navi=".$this->ipsclass->input['navi'].'&code='.$this->ipsclass->input['code'].'&pergo='.$this->ipsclass->input['pergo'].'&st='.$end;
                        $time = 0;
                }

                //-----------------------------------------
                // Bye....
                //-----------------------------------------

                $this->ipsclass->admin->redirect( $url, $text, 0, $time );
        }

        /*-------------------------------------------------------------------------*/
        // Clean out awards
        /*-------------------------------------------------------------------------*/

        function clean_awards()
        {
                require_once( KERNEL_PATH.'class_upload.php' );

                $upload = new class_upload();

                //-----------------------------------------
                // Set up
                //-----------------------------------------

                $done   = 0;
                $start  = intval( $this->ipsclass->input['st'] );
                $end    = intval( $this->ipsclass->input['pergo'] ) ? intval( $this->ipsclass->input['pergo'] ) : 10;
                $dis    = $end + $start;
                $output = array();

                //-----------------------------------------
                // save forum file if uploards dir not exists
                //-----------------------------------------

                if( !is_dir(ROOT_PATH.$this->ipsclass->vars['awrads_upload']) )
                {
                        $text = "<b>     </b>";
                        $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                        $time = 5;

                        //-----------------------------------------
                        // Bye....
                        //-----------------------------------------

                        $this->ipsclass->admin->redirect( $url, $text, 0, $time );
                }


                //-----------------------------------------
                // Pop open the directory and
                // peek inside...
                //-----------------------------------------

                $i = 0;

                $dh = opendir( ROOT_PATH.$this->ipsclass->vars['awrads_upload'] );

                while ( $file = readdir( $dh ) )
                {
                        if( strstr($file, 'aw-' ) )
                        {
                                $fullfile = ROOT_PATH.$this->ipsclass->vars['awrads_upload'].'/'.$file;

                                $i++;

                                //-----------------------------------------
                                // Already started?
                                //-----------------------------------------

                                if ( $start > $i )
                                {
                                        continue;
                                }

                                //-----------------------------------------
                                // Done for this iteration?
                                //-----------------------------------------

                                if ( $i > $end )
                                {
                                        break;
                                }

                                //-----------------------------------------
                                // Try and get attach row
                                //-----------------------------------------

                                $found = $this->ipsclass->DB->simple_exec_query( array( 'select' => 'id', 'from' => 'awards_info', 'where' => "img='$file' or img_thumbnail='$file'" ) );

                                if ( ! $found['id'] )
                                {
                                        @unlink( $fullfile );
                                        $output[] = "<span style='color:red'>   : $file</span>";
                                }
                                else
                                {
                                        $output[] = "<span style='color:gray'>  : $file</span>";
                                }
                        }

                 }

                 closedir( $dh );

                //-----------------------------------------
                // Finish - or more?...
                //-----------------------------------------

                if ( $i < $dis)
                {
                        //-----------------------------------------
                        // Done..
                        //-----------------------------------------

                        $text = "<b> </b><br />".implode( "<br />", $output );
                        $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                        $time = 2;
                }
                else
                {
                        //-----------------------------------------
                        // More..
                        //-----------------------------------------

                        $text = "<b> : $dis, ...</b><br />".implode( "<br />", $output );
                        $url  = "{$this->ipsclass->form_code}&navi=".$this->ipsclass->input['navi'].'&code='.$this->ipsclass->input['code'].'&pergo='.$this->ipsclass->input['pergo'].'&st='.$end;
                        $time = 0;
                }

                //-----------------------------------------
                // Bye....
                //-----------------------------------------

                $this->ipsclass->admin->redirect( $url, $text, 0, $time );
        }


        /*-------------------------------------------------------------------------*/
        // Rebuild Awards Images Cache
        /*-------------------------------------------------------------------------*/

        function rebuild_awards_cache()
        {
                //-------------------------
                // update cache
                //-------------------------

                $this->awards_lib->update_awards_cache();

                $text = "<b>  </b>";
                $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                $time = 2;

                //-----------------------------------------
                // Bye....
                //-----------------------------------------

                $this->ipsclass->admin->redirect( $url, $text, 0, $time );
        }


        /*-------------------------------------------------------------------------*/
        // RECOUNT MEMBER'S AWARDS
        /*-------------------------------------------------------------------------*/

        function recount_awards()
        {

                //-----------------------------------------
                // Set up
                //-----------------------------------------

                $done   = 0;
                $start  = intval( $this->ipsclass->input['st'] );
                $end    = intval( $this->ipsclass->input['pergo'] ) ? intval( $this->ipsclass->input['pergo'] ) : 500;
                $end   += $start;
                $output = array();

                //-----------------------------------------
                // zeroing count members awards
                //-----------------------------------------

                if( $start == 0)
                {
                        $this->ipsclass->DB->do_update( 'members', array( 'awards_dig' => 0) );
                }

                //-----------------------------------------
                // Avoid limit...
                //-----------------------------------------

                $this->ipsclass->DB->cache_add_query( 'recount_awards' , array( 'limit_a' => $start,
                                                                                'limit_b' => $end ), 'awards_admin_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                //-----------------------------------------
                // Process...
                //-----------------------------------------

                $members_awards_count = array();

                while( $r = $this->ipsclass->DB->fetch_row( $outer ) )
                {
                	    $members_awards_count[ $r['mid']  ] = $r['count'];
                        $members_cache[ $r['mid'] ] = $this->ipsclass->unpack_member_cache($r['members_cache']);
                        if( !is_array($members_cache[ $r['mid'] ]) )
                        {
                        	$members_cache[ $r['mid'] ] = array();
                        }

                        $done++;
                }

                if( count($members_awards_count) )
                {
                        //------------------------------------------
                        // update members awards count
                        //------------------------------------------

                        foreach( $members_awards_count as $mid => $count_awards)
                        {
                                $this->ipsclass->DB->do_update( 'members', array( 'awards_dig' => $count_awards ), 'id='.$mid );
                                /*
                                $this->ipsclass->pack_and_update_member_cache( $mid,
                                											   array( 'awards_dig' => $count_awards ),
                                											   $members_cache[ $mid ] );
                                */
                        }
                }


                //-----------------------------------------
                // Finish - or more?...
                //-----------------------------------------

                if ( ! $done  )
                {
                         //-----------------------------------------
                        // Done..
                        //-----------------------------------------

                        $text = "<b> </b><br />".implode( "<br />", $output );
                        $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                        $time = 2;
                }
                else
                {
                        //-----------------------------------------
                        // More..
                        //-----------------------------------------

                        $text = "<b> : $end, ...</b><br />".implode( "<br />", $output );
                        $url  = "{$this->ipsclass->form_code}&navi=".$this->ipsclass->input['navi'].'&code='.$this->ipsclass->input['code'].'&pergo='.$this->ipsclass->input['pergo'].'&st='.$end;
                        $time = 0;
                }

                //-----------------------------------------
                // Bye....
                //-----------------------------------------

                $this->ipsclass->admin->redirect( $url, $text, 0, $time );
        }
        /*-------------------------------------------------------------------------*/
        // REBUILD MEMBER'S AWARDS
        /*-------------------------------------------------------------------------*/

        function rebuild_awards()
        {

                //-----------------------------------------
                // Set up
                //-----------------------------------------

                $done   = 0;
                $start  = intval( $this->ipsclass->input['st'] );
                $end    = intval( $this->ipsclass->input['pergo'] ) ? intval( $this->ipsclass->input['pergo'] ) : 100;
                $end   += $start;
                $mids_array = array();

                //-----------------------------------------
                // clean cache
                //-----------------------------------------

                if( $start == 0)
                {
                        $this->ipsclass->DB->do_update( 'members', array( 'awards_cache' => '') );
                }

                //-----------------------------------------
                // Avoid limit...
                //-----------------------------------------

                $this->ipsclass->DB->cache_add_query( 'rebuild_awards_get_members' , array( 'limit_a' => $start,
                                                                                            'limit_b' => $end ), 'awards_admin_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                while( $r = $this->ipsclass->DB->fetch_row( ) )
                {
                        $mids_array[]    = $r['mid'];
                        $members_cache[ $r['mid'] ] = $this->ipsclass->unpack_member_cache($r['members_cache']);

						if( !is_array( $members_cache[ $r['mid'] ] ) )
						{
							$members_cache[ $r['mid'] ] = array();
						}

                        $done++;
                }

                //-----------------------------------------
                // Process...
                //-----------------------------------------
                if( $done )
                {
                        $this->ipsclass->DB->simple_construct( array( 'select' => 'aid,awards_id,mid', 'from' => 'awards', 'where' => "mid IN(".implode(',', $mids_array).")", 'order' => 'aid ASC' ) );
                        $this->ipsclass->DB->simple_exec();

                        while( $meminfo = $this->ipsclass->DB->fetch_row( ) )
                        {
                                $members_awards[ $meminfo['mid'] ][ $meminfo['aid'] ] = array( $meminfo['aid'], $meminfo['awards_id'] );
                        }
                }

                //-----------------------------------------
                // update members cache...
                //-----------------------------------------

                if( count($members_awards) )
                {
                        //------------------------------------------
                        // update members awards count
                        //------------------------------------------

                        foreach( $members_awards as $mid => $count_awards)
                        {
                                $this->ipsclass->DB->do_update( 'members', array( 'awards_cache' => serialize($count_awards) ), 'id='.$mid );
                                /*
                                $this->ipsclass->pack_and_update_member_cache( $mid,
                                											   array( 'awards_cache' => $count_awards ),
                                											   $members_cache[ $mid ] );
                                */
                        }
                }
                else
                {
                	/*
                        foreach( $mids_array as $id => $mid)
                        {
                                $this->ipsclass->pack_and_update_member_cache( $mid,
                                											   array( 'awards_cache' => array() ),
                                											   $members_cache[ $mid ] );
                        }
                 	*/
                }

                //-----------------------------------------
                // Finish - or more?...
                //-----------------------------------------

                if ( ! $done )
                {
                         //-----------------------------------------
                        // Done..
                        //-----------------------------------------

                        $text = "<b> </b>";
                        $url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'];
                        $time = 2;
                }
                else
                {
                        //-----------------------------------------
                        // More..
                        //-----------------------------------------

                        $text = "<b> : $end, ...</b>";
                        $url  = "{$this->ipsclass->form_code}&navi=".$this->ipsclass->input['navi']."&code=".$this->ipsclass->input['code'].'&pergo='.$this->ipsclass->input['pergo'].'&st='.$end;
                        $time = 0;
                }

                //-----------------------------------------
                // Bye....
                //-----------------------------------------

                $this->ipsclass->admin->redirect( $url, $text, 0, $time );
        }

}
?>
