<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/


/**
* Admin/Group Permission Manager
*
* Manages group permissions
*
* @package          Awards System
* @subpackage       Admin
* @author           SAT
* @since            1.0.0
*/



//---------------------------------------
// Security check
//---------------------------------------

if ( ! defined( 'IN_ACP' ) )
{
        print "<h1> </h1>        .    , ,     'admin.php'.";
        exit();

}

//---------------------------------------
// Carry on!
//---------------------------------------

class ad_groups {

        var $ipsclass;
        var $awards_lib;


        /*-------------------------------------------------------------------------*/
        // Default run
        /*-------------------------------------------------------------------------*/

        function auto_run()
        {
                //--------------------------------------------
                // Get the sync module
                //--------------------------------------------

                if ( USE_MODULES == 1 )
                {
                        require ROOT_PATH."modules/ipb_member_sync.php";

                        $this->modules = new ipb_member_sync();
                }

                switch($this->ipsclass->input['navi'])
                {
                        case 'editgroup':
                             $this->edit_group();
                             break;
                        case 'doeditgroup':
                             $this->do_edit_group();
                             break;

                        default:
                             $this->groups_overview();
                             break;
                }

        }

        /*-------------------------------------------------------------------------*/
        // Group Permission Stuff
        /*-------------------------------------------------------------------------*/

        function groups_overview()
        {
                // Page Information
                //$this->ipsclass->admin->page_title   = "Groups Overview";
                $this->ipsclass->admin->page_title   = " ";
                //$this->ipsclass->admin->page_detail  = "Here you will find a quick overview of your current group settings";
                $this->ipsclass->admin->page_detail  = "     ";

                // Table headers
                /*
                $this->ipsclass->adskin->td_header[] = array( "Group"     , "20%" );
                $this->ipsclass->adskin->td_header[] = array( "Members"   , "20%" );
                $this->ipsclass->adskin->td_header[] = array( "Overview"  , "20%" );
                $this->ipsclass->adskin->td_header[] = array( "Report"    , "20%" );
                $this->ipsclass->adskin->td_header[] = array( "Edit"      , "20%" );
                */

                $this->ipsclass->adskin->td_header[] = array( ""                         , "20%" );
                $this->ipsclass->adskin->td_header[] = array( ""                  , "10%" );
                $this->ipsclass->adskin->td_header[] = array( "  AwardsCP"              , "9%" );
                $this->ipsclass->adskin->td_header[] = array( " "          , "9%" );
                $this->ipsclass->adskin->td_header[] = array( " "                , "9%" );
                $this->ipsclass->adskin->td_header[] = array( " ."                , "9%" );
                $this->ipsclass->adskin->td_header[] = array( " ."                   , "9%" );
                $this->ipsclass->adskin->td_header[] = array( " ."             , "9%" );
                $this->ipsclass->adskin->td_header[] = array( "  ." , "9%" );
                $this->ipsclass->adskin->td_header[] = array( ""                          , "7%" );


                //$this->ipsclass->html .= $this->ipsclass->adskin->start_table( "Group Overview" );
                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( " " );

                $this->ipsclass->DB->cache_add_query( 'get_groups', array(), 'awards_admin_sql_queries' );
                $this->ipsclass->DB->simple_exec();

                while( $i = $this->ipsclass->DB->fetch_row() )
                {
                        if ( $this->ipsclass->vars['admin_group'] == $i['g_id'] )
                        {
                                $i['suffix'] .= " ( ROOT )";
                        }

                        //-------------------------------------
                        // can't edit guest group
                        //-------------------------------------

                        if( $this->ipsclass->vars['guest_group'] != $i['g_id'] )
                        {
                                $i['_title'] = "<a href='{$this->ipsclass->vars['board_url']}/index.{$this->ipsclass->vars['php_ext']}?act=Members&max_results=30&showall=1&filter={$i['g_id']}&sort_order=asc&sort_key=members_display_name&st=0' target='_blank' title='List Users'><b>{$i['prefix']}{$i['g_title']}{$i['suffix']}</b></a>";
                                $edit_option = "img_edit   + \" <a href='{$this->ipsclass->base_url}&section=components&act=awards&code=groups&navi=editgroup&group={$i['g_id']}'></a>\"";
                        }
                        else
                        {
                                $i['_title'] = "<b>{$i['prefix']}{$i['g_title']}{$i['suffix']}</b>";
                                $edit_option = "img_edit   + \" <i></i>\"";
                        }

                        // render access images
                        $awards_access_keys = array( 'can_access_awcp', 'g_awards_edit', 'g_awards_delete', 'g_awards_add_comments',
                                                     'g_awards_has_comments', 'g_awards_mod_comments', 'g_awards_mod_own_comments' );


                        foreach( $awards_access_keys as $k )
                        {
                                if( $i[ $k ] )
                                {
                                        $i[ $k."_img" ] = "<center><img src='{$this->ipsclass->skin_acp_url}/images/aff_tick.png' border='0' alt='-' class='ipd' /></center>";
                                }
                                else
                                {
                                        $i[ $k."_img" ] = "<center><img src='{$this->ipsclass->skin_acp_url}/images/aff_cross.png' border='0' alt='-' class='ipd' /></center>";
                                }
                        }


                        // --- comments ---
                        // g_awards_add_comments
                        // g_awards_mod_comments
                        // g_awards_mod_own_comments
                        // g_awards_has_comments

                        $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( $i['_title'],
                                                      "<center>{$i['count']}</center>",
                                                      $i['can_access_awcp_img'],
                                                      $i['g_awards_edit_img'],
                                                      $i['g_awards_delete_img'],
                                                      $i['g_awards_add_comments_img'],
                                                      $i['g_awards_has_comments_img'],
                                                      $i['g_awards_mod_comments_img'],
                                                      $i['g_awards_mod_own_comments_img'],
                                                      "<img id=\"menu{$i['g_id']}\" src='{$this->ipsclass->skin_acp_url}/images/filebrowser_action.gif' border='0' alt='Options' class='ipd' />",
                                              )     );


                        // build edit button
                        $this->ipsclass->html .= "<script type=\"text/javascript\">
                                                   menu_build_menu(
                                                   \"menu{$i['g_id']}\",
                                                   new Array(
                                                   {$edit_option}
                                                   ) );
                                                   </script>";

                }

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                $this->ipsclass->admin->output();
        }


        /*-------------------------------------------------------------------------*/
        // Displays the edit group form
        /*-------------------------------------------------------------------------*/

        function edit_group()
        {
                $this->ipsclass->input['group'] = intval($this->ipsclass->input['group']);


                // ---------------------------------------------------------------------
                // Get Group Info
                // ---------------------------------------------------------------------
                $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'groups', 'where' => "g_id={$this->ipsclass->input['group']}" ) );
                $this->ipsclass->DB->simple_exec();

                $group = $this->ipsclass->DB->fetch_row();

                if(!$group['g_id'])
                {
                        //$this->ipsclass->admin->error( "Don't find group by this ID" );
                        $this->ipsclass->admin->error( "     ." );
                }

                if($this->ipsclass->vars['guest_group'] == $group['g_id'])
                {
                        //$this->ipsclass->admin->error( "Guest not affected changes." );
                        $this->ipsclass->admin->error( "      ." );
                }


                // ----------------------------------------------------------------------
                // Group Settings Page Top
                // ----------------------------------------------------------------------

                $this->ipsclass->admin->page_detail = "  ";
                $this->ipsclass->admin->page_title  = " : {$group['g_title']}";


                $this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'navi'  , 'doeditgroup' ),
                                                                                     4 => array( 'code'  , 'groups' ),
                                                                                     2 => array( 'act'   , 'awards'  ),
                                                                                     3 => array( 'group' , $group['g_id'] ),
                                                                                     5 => array( 'section', 'components' ),
                                                                                      )      );

                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "40%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "60%" );

                // ----------------------------------------------------------------------
                // Access AwardsCP Settings
                // ----------------------------------------------------------------------
                //$this->ipsclass->html .= $this->ipsclass->adskin->start_table( 'Access' );
                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( '' );

                //$this->ipsclass->html .= $this->ipsclass->adskin->add_td_basic( 'Impotent settings! Have or not this group members access to awards control panel on board', 'left', 'tablerow4' );
                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_basic( ' !        .', 'left', 'tablerow4' );
                /*
                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>This group members can access to awards control panel?</b>" ,
                                                                                       $this->ipsclass->adskin->form_yes_no( "can_access_awcp", $group['can_access_awcp']  )
                                                                                     )      );
                */
                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>        ?</b>" ,
                                                                                       $this->ipsclass->adskin->form_yes_no( "can_access_awcp", $group['can_access_awcp']  )
                                                                                     )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();

                // ----------------------------------------------------------------------
                // AwardsCP DO Settings
                // ----------------------------------------------------------------------
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "40%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "60%" );

                //$this->ipsclass->html .= $this->ipsclass->adskin->start_table( 'Edit/delete awards' );
                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( '/ ' );
                /*
                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>Can edit others members awards?</b>" ,
                                          $this->ipsclass->adskin->form_yes_no( "g_awards_edit", $group['g_awards_edit']  )
                                 )      );
                */
                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>      ?</b>" ,
                                          $this->ipsclass->adskin->form_yes_no( "g_awards_edit", $group['g_awards_edit']  )
                                 )      );
                /*
                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>Can delete others members awards?</b>" ,
                                          $this->ipsclass->adskin->form_yes_no( "g_awards_delete", $group['g_awards_delete']  )
                                 )      );
                */
                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>      ?</b>" ,
                                          $this->ipsclass->adskin->form_yes_no( "g_awards_delete", $group['g_awards_delete']  )
                                 )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();


                // ----------------------------------------------------------------------
                // Comments Settings
                // ----------------------------------------------------------------------
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "40%" );
                $this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "60%" );

                $this->ipsclass->html .= $this->ipsclass->adskin->start_table( '' );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>     ?</b>" ,
                                          $this->ipsclass->adskin->form_yes_no( "g_awards_add_comments", $group['g_awards_add_comments']  )
                                 )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>        ?</b>" ,
                                          $this->ipsclass->adskin->form_yes_no( "g_awards_has_comments", $group['g_awards_has_comments']  )
                                 )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>     ?</b>" ,
                                          $this->ipsclass->adskin->form_yes_no( "g_awards_mod_comments", $group['g_awards_mod_comments']  )
                                 )      );

                $this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>       ?</b>" ,
                                          $this->ipsclass->adskin->form_yes_no( "g_awards_mod_own_comments", $group['g_awards_mod_own_comments']  )
                                 )      );

                // ----------------------------------------------------------------------
                // Settings Page Bottom
                // ----------------------------------------------------------------------
                //$this->ipsclass->html .= $this->ipsclass->adskin->end_form( 'Save Settings' );
                $this->ipsclass->html .= $this->ipsclass->adskin->end_form( ' ' );
                $this->ipsclass->html .= $this->ipsclass->adskin->end_table();
                $this->ipsclass->admin->output();
                // ----------------------------------------------------------------------
        }

        /*-------------------------------------------------------------------------*/
        // Displays the edit group form
        /*-------------------------------------------------------------------------*/

        function do_edit_group()
        {
                $this->ipsclass->input['group'] = intval($this->ipsclass->input['group']);
                $this->ipsclass->DB->simple_construct( array( 'select' => 'g_title', 'from' => 'groups', 'where' => "g_id={$this->ipsclass->input['group']}" ) );
                $this->ipsclass->DB->simple_exec();

                if( $this->ipsclass->DB->get_num_rows() )
                {
                        $group = $this->ipsclass->DB->fetch_row();
                }
                else
                {
                        //$this->ipsclass->admin->error( "Invalid Group" );
                        $this->ipsclass->admin->error( "     " );
                }

                if($this->ipsclass->vars['guest_group'] != $this->ipsclass->input['group'])
                {
                        $update = array (
                                                            'can_access_awcp'           => $this->ipsclass->input['can_access_awcp'] ? 1 : 0,
                                                            'g_awards_edit'             => $this->ipsclass->input['g_awards_edit'] ? 1 : 0,
                                                            'g_awards_delete'           => $this->ipsclass->input['g_awards_delete'] ? 1 : 0,
                                                            'g_awards_add_comments'     => $this->ipsclass->input['g_awards_add_comments'] ? 1 : 0,
                                                            'g_awards_has_comments'     => $this->ipsclass->input['g_awards_has_comments'] ? 1 : 0,
                                                            'g_awards_mod_comments'     => $this->ipsclass->input['g_awards_mod_comments'] ? 1 : 0,
                                                            'g_awards_mod_own_comments' => $this->ipsclass->input['g_awards_mod_own_comments'] ? 1 : 0,
                                );
                }
                else
                {
                        $update = array();
                }


                $this->ipsclass->DB->do_update( 'groups', $update, "g_id={$this->ipsclass->input['group']}");

                $this->rebuild_group_cache();

                //$this->ipsclass->admin->save_log( "Edited Modules Settings for group '{$group['g_title']}'" );
                $this->ipsclass->admin->save_log( "   Awards System  : '{$group['g_title']}'" );

                //$this->ipsclass->admin->redirect( "{$this->ipsclass->base_url}&section=components&act=awards&code=groups", "Group Settings for '<b>{$group['g_title']}</b>' was modified" );
                //$this->ipsclass->admin->redirect( "{$this->ipsclass->base_url}&section=components&act=awards&code=groups", "   '<b>{$group['g_title']}</b>'  ." );
                $this->ipsclass->main_msg = "    '{$group['g_title']}'";
                $this->groups_overview();
        }

        /*-------------------------------------------------------------------------*/
        // Displays the edit group form
        /*-------------------------------------------------------------------------*/

        function rebuild_group_cache()
        {
                $this->ipsclass->cache['group_cache'] = array();

                $this->ipsclass->DB->simple_construct( array( 'select' => "*",
                                                                          'from'   => 'groups'
                                                         )      );

                $this->ipsclass->DB->simple_exec();

                while ( $i = $this->ipsclass->DB->fetch_row() )
                {
                        $this->ipsclass->cache['group_cache'][ $i['g_id'] ] = $i;
                }

                $this->ipsclass->update_cache( array( 'name' => 'group_cache', 'array' => 1, 'deletefirst' => 1 ) );
        }
}
?>
