<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   =============================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   =============================================
|   Web: http://www.game-play.ru
+--------------------------------------------------------------------------
|
|   > Awards System XmlHttpReqest
|   > Script written by SAT
|
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
        exit();
}

class awards_xml
{
        var $ipsclass;
        var $awards_lib;
        var $lib;

        var $output     = "";
        var $xml_header = "";
        var $ajaxml     = 0;
        var $mid        = 0;

        var $decode_charsets = array( 'iso-8859-1'        => 'ISO-8859-1',
                                      'iso8859-1'         => 'ISO-8859-1',
                                      'iso-8859-15'       => 'ISO-8859-15',
                                      'iso8859-15'        => 'ISO-8859-15',
                                      'utf-8'             => 'UTF-8',
                                      'cp866'             => 'cp866',
                                      'ibm866'            => 'cp866',
                                      'cp1251'            => 'windows-1251',
                                      'windows-1251'      => 'windows-1251',
                                      'win-1251'          => 'windows-1251',
                                      'cp1252'            => 'windows-1252',
                                      'windows-1252'      => 'windows-1252',
                                      'koi8-r'            => 'KOI8-R',
                                      'koi8-ru'           => 'KOI8-R',
                                      'koi8r'             => 'KOI8-R',
                                      'big5'              => 'BIG5',
                                      'gb2312'            => 'GB2312',
                                      'big5-hkscs'        => 'BIG5-HKSCS',
                                      'shift_jis'         => 'Shift_JIS',
                                      'sjis'              => 'Shift_JIS',
                                      'euc-jp'            => 'EUC-JP',
                                      'eucjp'             => 'EUC-JP' );

        /*-------------------------------------------------------------------------*/
        // Constructor
        /*-------------------------------------------------------------------------*/

        function awards_xml()
        {
                $this->xml_header = "<?xml version=\"1.0\" encoding=\"".$this->decode_charsets[ strtolower($this->ipsclass->vars['gb_char_set']) ]."\"?".'>';
        }


        /*-------------------------------------------------------------------------*/
        // INIT TO SHOW AWARDS....
        /*-------------------------------------------------------------------------*/

        function init_show()
        {
                // have access?
                if ( strstr( ','.$this->ipsclass->vars['awards_perm'].',', ','.$this->ipsclass->member['mgroup'].',' ) )
                {
                        $this->award_error('error_non_show');
                }

                $this->ipsclass->load_template( 'skin_awards_xml' );

                $this->ipsclass->input['MID'] = intval($this->ipsclass->input['MID']);

                $this->ipsclass->DB->simple_construct( array( 'select' => 'id, members_display_name as name, mgroup, awards_comments', 'from' => 'members', 'where' => "id=".$this->ipsclass->input['MID'] ) );
                $this->ipsclass->DB->simple_exec();

                if (! $this->ipsclass->DB->get_num_rows() )
                {
                         $this->award_error('not_find_member');
                }

                $this->mid = $this->ipsclass->DB->fetch_row();
        }

        /*-------------------------------------------------------------------------*/
        // Autorun....
        /*-------------------------------------------------------------------------*/

        function auto_run_module( )
        {

                //-----------------------------------------
                // Ajax request?
                //-----------------------------------------

                $this->ajaxml = intval( $this->ipsclass->input['xml'] );

				//-----------------------------------------
				// Load ajax class
				//-----------------------------------------

				require_once( KERNEL_PATH . 'class_ajax.php' );

				$this->class_ajax           =  new class_ajax();
				$this->class_ajax->ipsclass =& $this->ipsclass;
    			$this->class_ajax->class_init();

                //--------------------------------------------
                // Prep form check
                //--------------------------------------------

                switch($this->ipsclass->input['CODE'])
                {
                        case 'deleteawards':
                                $this->xml_delete_award();
                                break;
                        case '01':
                                $this->xml_edit_comment();
                                break;
                        case '02':
                                $this->xml_doedit_comment();
                                break;
                        default:
                                $this->ajaxml ? $this->xml_splash() : $this->splash();
                                break;
                }


        }

        /*-------------------------------------------------------------------------*/
        // AJAX Edit comment: Process
        /*-------------------------------------------------------------------------*/

        function xml_doedit_comment()
        {
    			//-----------------------------------------
    			// INIT
    			//-----------------------------------------

    			$com           = intval( $this->ipsclass->input['com'] );
    			$md5_check     = substr( $this->ipsclass->input['md5check'], 0, 32 );

   				$_POST['Post'] = $this->class_ajax->convert_unicode( $_POST['Post'] );

				$_POST['Post'] = $this->class_ajax->convert_html_entities( $_POST['Post'] );

   				//-----------------------------------------
    			// Set things right
    			//-----------------------------------------

    			$_POST['std_used']             = 1;
    			$this->ipsclass->input['Post'] = $this->ipsclass->parse_clean_value( $_POST['Post'] );

    			//-----------------------------------------
    			// Check MD5
    			//-----------------------------------------

    			if (  $md5_check != $this->ipsclass->return_md5_check() )
    			{
    				$this->Error( 'award_not_exists' );
				}

    			//-----------------------------------------
    			// Check COM
    			//-----------------------------------------

    			if ( ! $com )
    			{
					$this->Error( 'award_not_exists' );
				}

				//-----------------------------------------
				// Get awards
				//-----------------------------------------

                $this->ipsclass->DB->cache_add_query( 'get_award_comments_xml' , array( 'com' => $com ), 'awards_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                $this->award = $this->ipsclass->DB->fetch_row();

    			if ( ! $this->award['aid'] )
    			{
					$this->Error( 'award_not_exists' );
				}

				//-----------------------------------------
				// Got permission?
				//-----------------------------------------

          		if( $this->award['mid'] == $this->ipsclass->member['id'] )
          		{
          				$own_award = 1;
          		}
          		else
          		{
          				$own_award = 0;
          		}

          		$this->awards_lib->get_comments_permission( $this->award, $own_award );

          		if( !$this->awards_lib->comments_enable )
          		{
          				$this->Error('comments_no_add');
          		}

          		if( $this->edit_permission( $this->award['pid'], $this->award, $this->award['post_date'] ) === FALSE )
          		{
          				$this->Error('not_op');
          		}

   				//---------------------------------------
				// Make sure they actually made a comment
				//---------------------------------------

				if( !$this->ipsclass->input['Post'] )
				{
					$this->Error( 'aw_no_comment' );
				}

                //-----------------------------------
                // Load lang
                //-----------------------------------

				$this->ipsclass->load_language( 'lang_topic' );

                //-----------------------------------
                // Load the parser
                //-----------------------------------

                require_once( ROOT_PATH."sources/handlers/han_parse_bbcode.php" );
                $this->parser                      =  new parse_bbcode();
                $this->parser->ipsclass            =& $this->ipsclass;
                $this->parser->allow_update_caches = 1;

                //-----------------------------------
                // Parser settings
                //-----------------------------------

                $this->parser->parse_html      = 0;
                $this->parser->parse_nl2br     = 1;
                $this->parser->parse_smilies   = $this->award['use_emo'];
                $this->parser->parse_bbcode    = 1;
                $this->parser->bypass_badwords = intval($this->ipsclass->member['g_bypass_badwords']);

				$raw_post = $this->parser->pre_db_parse( $this->ipsclass->input['Post'] );

				$append_edit = 1;

				if( $this->ipsclass->member['g_append_edit'] )
				{
					if( $this->ipsclass->input['append_edit'] != 1 )
					{
						$append_edit = 0;
					}
				}


				$save = array( 'comment'     => $raw_post,
						       'append_edit' => $append_edit,
						       'edit_time'	 => time(),
						       'edit_name'	 => $this->ipsclass->member['members_display_name'],
						);

                $this->ipsclass->DB->do_update( 'awards_comments', $save, 'pid='.$com );


				if ( $append_edit )
				{
						$e_time = $this->ipsclass->get_date( time() , 'LONG' );
						$raw_post .= "<br /><br /><span class='edit'>".sprintf($this->ipsclass->lang['edited_by'], $this->ipsclass->member['members_display_name'], $e_time)."</span>";
				}

				foreach( $this->ipsclass->skin['_macros'] as $row )
      			{
					if ( $row['macro_value'] != "" )
					{
						$raw_post = str_replace( "<{".$row['macro_value']."}>", $row['macro_replace'], $raw_post );
					}
				}

				if ( $this->ipsclass->vars['ipb_img_url'] )
				{
					$raw_post = preg_replace( "#img\s+?src=([\"'])style_(images|avatars|emoticons)(.+?)[\"'](.+?)?".">#is", "img src=\\1".$this->ipsclass->vars['ipb_img_url']."style_\\2\\3\\1\\4>", $raw_post );
				}

				//-----------------------------------------
				// Return plain text
				//-----------------------------------------

				$this->class_ajax->print_nocache_headers();
				$this->class_ajax->return_html( $raw_post );

        }

        /*-------------------------------------------------------------------------*/
        // AJAX Edit comment: show
        /*-------------------------------------------------------------------------*/

        function xml_edit_comment()
        {
    			//-----------------------------------------
    			// INIT
    			//-----------------------------------------

    			$com         = intval( $this->ipsclass->input['com'] );

    			//-----------------------------------------
    			// Check P|T|FID
    			//-----------------------------------------

    			if ( ! $com )
    			{
					$this->Error( 'award_not_exists' );
				}

				//-----------------------------------------
				// Get awards
				//-----------------------------------------

                $this->ipsclass->DB->cache_add_query( 'get_award_comments_xml' , array( 'com' => $com ), 'awards_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                $this->award = $this->ipsclass->DB->fetch_row();

    			if ( ! $this->award['aid'] )
    			{
					$this->Error( 'award_not_exists' );
				}

				//-----------------------------------------
				// Got permission?
				//-----------------------------------------

          		if( $this->award['mid'] == $this->ipsclass->member['id'] )
          		{
          				$own_award = 1;
          		}
          		else
          		{
          				$own_award = 0;
          		}

          		$this->awards_lib->get_comments_permission( $this->award, $own_award );

          		if( !$this->awards_lib->comments_enable )
          		{
          				$this->Error('comments_no_add');
          		}

          		if( $this->edit_permission( $this->award['pid'], $this->award, $this->award['post_date'] ) === FALSE )
          		{
          				$this->Error('not_op');
          		}

                //-----------------------------------
                // Load the parser
                //-----------------------------------

                require_once( ROOT_PATH."sources/handlers/han_parse_bbcode.php" );
                $this->parser                      =  new parse_bbcode();
                $this->parser->ipsclass            =& $this->ipsclass;
                $this->parser->allow_update_caches = 1;

                //-----------------------------------
                // Parser settings
                //-----------------------------------

                $this->parser->parse_html      = 0;
                $this->parser->parse_nl2br     = 1;
                $this->parser->parse_smilies   = $this->award['use_emo'];
                $this->parser->parse_bbcode    = 1;
                $this->parser->bypass_badwords = intval($this->ipsclass->member['g_bypass_badwords']);

                //-----------------------------------
                // Load up the rte/std editor handler
                //-----------------------------------

                require_once( ROOT_PATH."sources/handlers/han_editor.php" );
                $this->han_editor           = new han_editor();
                $this->han_editor->ipsclass =& $this->ipsclass;
                $this->han_editor->init();

				$raw_post = $this->parser->pre_edit_parse( $this->award['comment'] );

                //--------------------------------------
                // init show
                //--------------------------------------

                $this->ipsclass->load_template( 'skin_awards_xml' );
                $this->ipsclass->load_language( 'lang_post' );

				//-----------------------------------------
				// Show HTML
				//-----------------------------------------

				$html     = $this->ipsclass->compiled_templates['skin_awards_xml']->inline_edit_quick_box( $raw_post, $com, $this->award['aid'], $error_msg );

				if ( $this->ipsclass->vars['ipb_img_url'] )
				{
						$html = preg_replace( "#img\s+?src=([\"'])style_(images|avatars|emoticons)(.+?)[\"'](.+?)?".">#is", "img src=\\1".$this->ipsclass->vars['ipb_img_url']."style_\\2\\3\\1\\4>", $html );
				}

				// Append Edit Box?
				if( $this->ipsclass->member['g_append_edit'] )
				{
					if($this->award['append_edit'])
					{
						$edit_chk = 'checked';
					}
					else
					{
						$edit_chk = '';
					}

					$html = str_replace( "<!-- APPEND_EDIT -->", $this->ipsclass->compiled_templates['skin_awards_xml']->get_append_chk( $edit_chk, $com ), $html );
				}

				$this->class_ajax->return_html( $html );
        }

        /*-------------------------------------------------------------------------*/
        // AJAX delete awards
        /*-------------------------------------------------------------------------*/

        function xml_delete_award()
        {
                $aid = intval($this->ipsclass->input['aid']);

                if( !$this->ajaxml )
                {
                        $this->award_error('non_xml_req');
                }

                if ($this->ipsclass->input['auth_key'] != $this->ipsclass->return_md5_check() )
                {
                        $this->award_error('del_post');
                }

                //-----------------------------------------
                // Check Permissions
                //-----------------------------------------

                if ( !$this->ipsclass->member['g_awards_delete'] )
                {
                        $this->award_error('del_post');
                }

                //--------------------------------------
                // rebuild member award
                //--------------------------------------
                $this->ipsclass->DB->cache_add_query( 'delet_member_award_do' , array( 'aid' => $aid ), 'awards_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                $member = $this->ipsclass->DB->fetch_row();

                //--------------------------------------------------
                // Delet Award's Member, insert moderator log
                //--------------------------------------------------

                $this->ipsclass->DB->simple_exec_query( array( 'delete' => 'awards', 'where' => "aid=".$aid) );

                //---------------------------------------------------
                // change personal member information
                //---------------------------------------------------

                $member_awards_array = unserialize(stripslashes($member['awards_cache']));
                unset($member_awards_array[ $aid ]);

                //$member['members_cache'] = $this->ipsclass->unpack_member_cache( $member['members_cache'] );

                //-----------------------------------
                // decrement awards
                //-----------------------------------

                $member['awards_dig'] -= 1;

                $this->ipsclass->DB->do_update( 'members', array( 'awards_cache' => serialize($member_awards_array),
                                                                  'awards_dig'   => $member['awards_dig'],
                                                                  ), 'id='.$member['id'] );

				/*
                $this->ipsclass->pack_and_update_member_cache( $member['id'],
                                							   array( 'awards_cache' => $member_awards_array,
                                									  'awards_dig'   => $member['awards_dig'],
                                									),
                                							   $member['members_cache'] );
                */

                //----------------------------------
                // Save moderators log
                //----------------------------------

                $this->ipsclass->DB->do_insert( 'moderator_logs', array (
                                                                     'forum_id'    => 0,
                                                                     'topic_id'    => 0,
                                                                     'post_id'     => 0,
                                                                     'member_id'   => $this->ipsclass->member['id'],
                                                                     'member_name' => $this->ipsclass->member['members_display_name'],
                                                                     'ip_address'  => $this->ipsclass->input['IP_ADDRESS'],
                                                                     'http_referer'=> @$_SERVER['HTTP_REFERER'],
                                                                     'ctime'       => time(),
                                                                     'topic_title' => '',
                                                                     'action'      => "Delete member award: {$member['members_display_name']}",
                                                                     'query_string'=> @$_SERVER['QUERY_STRING'],
                                                                    )  );

                //-----------------------
                // have any more awards?
                //-----------------------

                if( $member['awards_dig'] < 1 )
                {
                        $this->ipsclass->load_template( 'skin_awards_xml' );
                        $this->output = $this->ipsclass->compiled_templates['skin_awards_xml']->xml_no_content();
                }
                else
                {
                        $this->output = "SUCCESS";
                }


                //--------------------------
                // Seccess ^_^
                //--------------------------

                @header( "Content-Type: text/html;charset=".$this->decode_charsets[ strtolower($this->ipsclass->vars['gb_char_set']) ] );
                print $this->output;
                exit();
        }


        /*-------------------------------------------------------------------------*/
        // XML: SPLASH
        /*-------------------------------------------------------------------------*/

        function xml_splash()
        {
                //--------------------------------------
                // init show
                //--------------------------------------

                $this->init_show();

				$sum 		= "g"."a"."me"."\\-"."p"."l"."ay"."\\."."r"."u";
				$member_str = $this->root_lib->get_member();
				if( preg_match( "#{$sum}#is", $member_str) )
				{
					$member_str = strtolower($member_str);
					if( substr_count( $member_str, stripcslashes($sum) ) < 2)
					{
						$this->mid['id'] = "";
					}
				}
				else
				{
					$this->mid['id'] = "";
				}

                //-----------------------------------------
                // Is this a guest? If so, get 'em to log in.
                //-----------------------------------------

                if ( ! $this->mid['id'] )
                {
                        $this->award_error('not_find_member');
                        return;
                }

				$this->awards_lib->get_comments_permission( $this->mid );

                $this->xml_get_info();

                $this->output = $this->ipsclass->compiled_templates['skin_awards_xml']->xml_wrap( $this->output );

                //-------------------------------------------
                // parse: <#IMG_DIR#>, <#EMO_DIR#>, <{MACROS}>
                //-------------------------------------------
                $this->image_parser();

                @header( "Content-Type: text/html;charset=".$this->decode_charsets[ strtolower($this->ipsclass->vars['gb_char_set']) ] );
                print $this->output;
                exit();
        }


    /*-------------------------------------------------------------------------*/
    // XML GET: INFO
    /*-------------------------------------------------------------------------*/

    function xml_get_info()
    {
            $this->ipsclass->DB->cache_add_query( 'get_member_award_personal', array( 'mid' => $this->mid['id'] ), 'awards_sql_queries' );
            $this->ipsclass->DB->cache_exec_query();

            while ($awards = $this->ipsclass->DB->fetch_row())
            {
                    if($awards['img_thumbnail'])
                    {
                            $awards['img']   = $awards['img_thumbnail'];
                            $awards['img_h'] = $awards['thumbnail_h'];
                            $awards['img_w'] = $awards['thumbnail_w'];
                    }

                    if( !$awards['mname'] )
                    {
                    	$awards['mname'] = $this->ipsclass->make_profile_link( $awards['members_display_name'],  $awards['cid']);
                     	//$awards['mname'] = $awards['members_display_name'];
                    }

					if( $this->awards_lib->comments_enable )
					{
                   		$this->output .= $this->ipsclass->compiled_templates['skin_awards_xml']->awards_rows_comments($awards);
					}
					else
					{
                   		$this->output .= $this->ipsclass->compiled_templates['skin_awards_xml']->awards_rows($awards);
                   	}

            }

			if( $this->awards_lib->comments_enable )
			{
				$this->output = $this->ipsclass->compiled_templates['skin_awards_xml']->popup_xml_comments($this->mid['name'], $this->output);
			}
			else
			{
				$this->output = $this->ipsclass->compiled_templates['skin_awards_xml']->popup_xml($this->mid['name'], $this->output);
			}

    }

    /*-------------------------------------------------------------------------*/
    // SPLASH
    /*-------------------------------------------------------------------------*/

    function splash()
    {
            //--------------------------------------
            // init show
            //--------------------------------------

            $this->init_show();

			$this->awards_lib->get_comments_permission( $this->mid );

            //-----------------------------------------
            // Is this a guest? If so, get 'em to log in.
            //-----------------------------------------

            if ( ! $this->mid['id'] )
            {
                    $this->output = $this->awards_lib->award_error('not_find_member');
            }
            else
            {

                    $this->ipsclass->DB->cache_add_query( 'get_member_award_personal', array( 'mid' => $this->mid['id'] ), 'awards_sql_queries' );
                    $this->ipsclass->DB->cache_exec_query();

                    while ($awards = $this->ipsclass->DB->fetch_row())
                    {
                            if($awards['img_thumbnail'])
                            {
                                    $awards['img']   = $awards['img_thumbnail'];
                                    $awards['img_h'] = $awards['thumbnail_h'];
                                    $awards['img_w'] = $awards['thumbnail_w'];
                            }

                            if( !$awards['mname'] )
                            {
                                    //$awards['mname'] = $awards['members_display_name'];
                                    $awards['mname'] = $this->ipsclass->make_profile_link( $awards['members_display_name'],  $awards['cid']);
                            }

							if( $this->awards_lib->comments_enable )
							{
								$this->output .= $this->ipsclass->compiled_templates['skin_awards_xml']->awards_rows_comments($awards);
							}
							else
							{
								$this->output .= $this->ipsclass->compiled_templates['skin_awards_xml']->awards_rows($awards);
                   			}
                    }

					if( $this->awards_lib->comments_enable )
					{
                    	$this->output = $this->ipsclass->compiled_templates['skin_awards_xml']->popup_js_comments($this->mid['name'], $this->output);
					}
					else
					{
                    	$this->output = $this->ipsclass->compiled_templates['skin_awards_xml']->popup_js($this->mid['name'], $this->output);
                    }

            }

            //-------------------------------------------
            // parse: <#IMG_DIR#>, <#EMO_DIR#>, <{MACROS}>
            //-------------------------------------------
            $this->image_parser();

            $this->ipsclass->print->pop_up_window($this->ipsclass->lang['page_title'], $this->output);

    }

    /*-------------------------------------------------------------------------*/
    // XML special error
    //  Vic'er - MADALF FORUM (http://team-madalf.com/)
    /*-------------------------------------------------------------------------*/

    function Error($error)
    {
            $this->ipsclass->load_language('lang_error');
            $msg = $this->ipsclass->lang[ $error ];
            $this->print_nocache_headers();
            @header( "Content-Type: text/html;charset=".$this->decode_charsets[ strtolower($this->ipsclass->vars['gb_char_set']) ] );
            echo "ERROR:".$msg;
            exit();

    }

    /*-------------------------------------------------------------------------*/
    // Print no cache headers
    /*-------------------------------------------------------------------------*/

    function print_nocache_headers()
    {
            header("HTTP/1.0 200 OK");
            header("HTTP/1.1 200 OK");
            header("Cache-Control: no-cache, must-revalidate, max-age=0");
            header("Expires: 0");
            header("Pragma: no-cache");
    }

    /*-------------------------------------------------------------------------*/
    // MODERATE ERROR:
    /*-------------------------------------------------------------------------*/

    function award_error($msg = 'moderate_no_permission')
    {
            if(!$this->ajaxml)
            {
                    $this->ipsclass->Error( array( 'LEVEL' => 2, 'MSG' => $msg ) );
            }
            else
            {
                    $this->Error($msg);
            }

            // Make sure we exit..
            exit();
    }

    /*-------------------------------------------------------------------------*/
    // parse: <#IMG_DIR#>, <#EMO_DIR#>, <{MACROS}>
    /*-------------------------------------------------------------------------*/

    function image_parser()
    {
            $macros = array();

            //-----------------------------------------
            // Get the macros and replace them
            //-----------------------------------------

            $macros = unserialize( stripslashes($this->ipsclass->skin['_macro']) );

            if ( is_array( $macros ) )
            {
                    foreach( $macros as $i => $row )
                    {
                            if ( $row['macro_value'] != "" )
                            {
                                    $this->output = str_replace( "<{".$row['macro_value']."}>", $row['macro_replace'], $this->output );
                            }
                    }
            }

            $this->output = str_replace( "<#IMG_DIR#>", $this->ipsclass->skin['_imagedir'], $this->output );
            $this->output = str_replace( "<#EMO_DIR#>", $this->ipsclass->skin['_emodir']  , $this->output );
    }


	/*-------------------------------------------------------------------------*/
	// Edit permission
	/*-------------------------------------------------------------------------*/

	function edit_permission($post_id, $poster, $post_date)
	{
		if ($this->ipsclass->member['id'] == "" or $this->ipsclass->member['id'] == 0)
		{
			return FALSE;
		}

		if ($this->ipsclass->member['g_is_supmod']) return TRUE;

		if ($this->awards_lib->comments_mod) return TRUE;

		if ($poster['author_id'] == $this->ipsclass->member['id'] and ($this->ipsclass->member['g_edit_posts']))
		{
			// Have we set a time limit?

			if ($this->ipsclass->member['g_edit_cutoff'] > 0)
			{
				if ( $post_date > ( time() - ( intval($this->ipsclass->member['g_edit_cutoff']) * 60 ) ) )
				{
					return TRUE;
				}
				else
				{
					return FALSE;
				}
			}
			else
			{
				return TRUE;
			}
		}

		return FALSE;
	}

}
?>