<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   =============================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   =============================================
|   Web: http://www.game-play.ru
+--------------------------------------------------------------------------
|
|   > UCP: LIBRARY
|   > Module written by SAT
|
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
        exit();
}

//-----------------------------------------
// Must be "components_ucp_{component name}
//-----------------------------------------

class components_ucp_awards
{
        /*-------------------------------------------------------------------------*/
        // Build menu
        // Use: $content .= menu_bar_new_link( $url, $name ) for the links
        // Use: menu_bar_new_category( 'Awards', $content ) for the content
        /*-------------------------------------------------------------------------*/

        function ucp_build_menu()
        {
                //-----------------------------------------
                // INIT
                //-----------------------------------------

                $content = "";
				$this->ipsclass->load_template( 'skin_ucp' );

                if(!$this->ipsclass->lang['m_awards'])
                {
                        $this->ipsclass->load_language('lang_awards_ucp');
                }

                //-----------------------------------------
                // Get links
                //-----------------------------------------

                /*
                  [awards_dig][awards_cache][awards_tracker][can_access_awcp][g_awards_edit][g_awards_delete]
                */

                if ( $this->ipsclass->vars['awards_onoff'] )
                {
                        if(!$this->ipsclass->member['members_disable_pm'] and $this->ipsclass->vars['awards_notice'])
                        {
                                $content .= $this->ipsclass->compiled_templates['skin_ucp']->menu_bar_new_link( "{$this->ipsclass->base_url}automodule=awards&amp;inc=ucp_main", $this->ipsclass->lang['m_awards_personal_settings'] );
                        }

                        if ( $this->ipsclass->member['can_access_awcp'] == 1 )
                        {
                                $content .= $this->ipsclass->compiled_templates['skin_ucp']->menu_bar_new_link( "{$this->ipsclass->base_url}automodule=awards&amp;inc=awardscp", $this->ipsclass->lang['m_awards_add'] );
                        }
                }

                if ( $content )
                {
                        return $this->ipsclass->compiled_templates['skin_ucp']->menu_bar_new_category( $this->ipsclass->lang['m_awards'], $content );
                }
                else
                {
                        return '';
                }
        }
}

?>