<?php


/*
+--------------------------------------------------------------------------
|   Awards System v3.0.2
|   =============================================
|   by SAT
|   (c) 2005 - 2006 Game-Play.ru Team
|   =============================================
|   Forum: http://www.game-play.ru/forum
|   Email: sat@game-play.ru
+--------------------------------------------------------------------------
|
|   > Setup script
|   > Script written by SAT
|   > Awards additions by SAT
|   > Module version: 4.0.0
|
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
        exit();
}

class version_install
{
        var $ipsclass;
        var $std;
        var $this_version = '30010';
        var $upgrade_from = '00000';
        var $first_step   = 'create the necessary tables, indexes and updates your database to include the new schematic modifications.';
        var $md5_check    = '';
        var $base_url     = '';
        var $mod_to_run   = '';
        var $mod_name     = '';

        /*-------------------------------------------------------------------------*/
        // CONSTRUCTOR
        /*-------------------------------------------------------------------------*/

        function version_install( &$ipsclass, &$std )
        {
                $this->ipsclass = &$ipsclass;
                $this->std = &$std;
                $this->md5_check = $this->ipsclass->return_md5_check();

                $this->base_url  = "act=work&workact=sql&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}";
        }

        /*-------------------------------------------------------------------------*/
        // Auto run..
        /*-------------------------------------------------------------------------*/

        function auto_run()
        {
                //--------------------------------
                // What are we doing?
                //--------------------------------

                switch( $this->ipsclass->input['workact'] )
                {
                        case 'sql':
                                $this->upgrade_sql();
                                break;
                        default:
                                $this->upgrade_intro();
                                break;
                }
        }


        /*-------------------------------------------------------------------------*/
        // SQL
        /*-------------------------------------------------------------------------*/

        function upgrade_sql()
        {
                $cnt = 0;

                // Create/Alter tables
                $SQL = array();


                if ( file_exists( THIS_PATH.'install/'.strtolower($this->ipsclass->vars['sql_driver']).'_tables.php' ) )
                {
                        require_once( THIS_PATH.'install/'.strtolower($this->ipsclass->vars['sql_driver']).'_tables.php' );

                        foreach( $SQL as $q )
                        {
                                $this->ipsclass->DB->query( $q );

                                $cnt++;
                        }
                }


                // Inserts
                $SQL = array();
                if ( file_exists( THIS_PATH.'install/'.strtolower($this->ipsclass->vars['sql_driver']).'_inserts.php' ) )
                {
                        require_once( THIS_PATH.'install/'.strtolower($this->ipsclass->vars['sql_driver']).'_inserts.php' );

                        foreach( $SQL as $q )
                        {
                                $this->ipsclass->DB->query( $q );

                                $cnt++;
                        }
                }

                //--------------------------------
                // Next page...
                //--------------------------------

                $this->std->redirect( "act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}", "$cnt queries run...." );

        }

        /*-------------------------------------------------------------------------*/
        // INTRO
        /*-------------------------------------------------------------------------*/

        function upgrade_intro()
        {
                $this->ipsclass->template->script_act = $this->base_url;
                $this->ipsclass->template->inf .= "
                         <div class='maintitle'>Welcome to {$this->mod_name}!</div>
                         <div class='text-row' style='padding:6px'>This module will install {$this->mod_name} <b>{$this->core->versions[$this->this_version]}</b>
                         <br /><br />This first step will {$this->first_step}
                         </div>
                        ";

                $this->ipsclass->template->output("First Step Processed...");

        }

}


?>