<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   =============================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   =============================================
|   Web: http://www.game-play.ru
+--------------------------------------------------------------------------
|
|   > Awards System (Award Control Panel script)
|   > Script written by SAT
|
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
        exit();
}

class awardscp
{
        var $ipsclass;
        var $awards_lib;
        var $lib;

        var $output="";
        var $nav = "";
        var $page_title = "";
        var $md5_check  = "";

        var $mem_info = array();
        var $class_post = '';
        var $parser     = '';
        var $han_editor = '';

        /*-------------------------------------------------------------------------*/
        // Autorun....
        /*-------------------------------------------------------------------------*/

        function auto_run_module( )
        {
                // Guests don't have access here
                if ( !$this->ipsclass->member['id'] )
                {
                        $this->awards_lib->award_error('no_guests');
                }

                //-----------------------------------------
                // Check Permissions
                //-----------------------------------------

                if ( ! $this->ipsclass->cache['group_cache'][ $this->ipsclass->member['mgroup'] ]['can_access_awcp'] )
                {
                    $this->awards_lib->award_error('not_have_access');
                }

                //-----------------------------------------
                // Prep form check
                //-----------------------------------------

                $this->md5_check = $this->ipsclass->return_md5_check();

                $this->ipsclass->load_language( 'lang_ucp' );
                $this->ipsclass->load_template( 'skin_awards_cp' );

                //-----------------------------------
                // Load posting languege
                //-----------------------------------

                $this->ipsclass->load_language( 'lang_post' );

                //-----------------------------------
                // Load the parser
                //-----------------------------------

                require_once( ROOT_PATH."sources/handlers/han_parse_bbcode.php" );
                $this->parser                      =  new parse_bbcode();
                $this->parser->ipsclass            =& $this->ipsclass;
                $this->parser->allow_update_caches = 1;

                //-----------------------------------
                // Parser settings
                //-----------------------------------

                $this->parser->parse_html      = 0;
                $this->parser->parse_nl2br     = 1;
                $this->parser->parse_smilies   = 1;
                $this->parser->parse_bbcode    = 1;
                $this->parser->bypass_badwords = intval($this->ipsclass->member['g_bypass_badwords']);

                //-----------------------------------
                // Load up the rte/std editor handler
                //-----------------------------------

                require_once( ROOT_PATH."sources/handlers/han_editor.php" );
                $this->han_editor           = new han_editor();
                $this->han_editor->ipsclass =& $this->ipsclass;
                $this->han_editor->init();


                $this->nav[] = "<a href='".$this->ipsclass->base_url."act=UserCP&amp;CODE=00'>".$this->ipsclass->lang['t_title']."</a>";
                $this->nav[] = "<a href='".$this->ipsclass->base_url."automodule=awards&inc=awardscp'>".$this->ipsclass->lang['cp_aw_title']."</a>";

                //--------------------------------------------
                // Prep form check
                //--------------------------------------------

                switch($this->ipsclass->input['CODE'])
                {
                        //-------------------------------------
                        // Find member
                        //-------------------------------------
                        case 'findmember':
                                $this->find_form();
                                break;
                        case 'do_findmember':
                                $this->do_findmember();
                                break;

                        //-------------------------------------
                        // Show form
                        //-------------------------------------
                        case 'go_to_awardscp':
                                $this->award_control_panel('add');
                                break;
                        case 'edit':
                                $this->award_control_panel('edit');
                                break;

                        //-------------------------------------
                        // Processes..
                        //-------------------------------------
                        case 'do_add_award':
                                $this->do_awards('add');
                                break;
                        case 'do_edit_award':
                                $this->do_awards('edit');
                                break;
                        case 'delet':
                                $this->award_member_delet();
                                break;


                        default:
                                $this->find_form();
                                break;
                }

                //--------------------------------------------
                // UserCP functions
                //--------------------------------------------

                require_once( ROOT_PATH."sources/lib/func_usercp.php" );
                $this->lib   = new func_usercp(&$this);
                $this->lib->ipsclass =& $this->ipsclass;

                $this->ipsclass->load_template( 'skin_ucp' );

                $this->output = $this->lib->ucp_generate_menu().$this->output;

                //-----------------------------------------
                // Let's finish it up and print the output
                //-----------------------------------------
                $fj = $this->ipsclass->build_forum_jump();
                $fj = preg_replace( "!#Forum Jump#!", $this->ipsclass->lang['forum_jump'], $fj);

                $this->output .= $this->ipsclass->compiled_templates['skin_ucp']->CP_end();
                $this->output .= $this->ipsclass->compiled_templates['skin_ucp']->forum_jump($fj, $links);

                $this->ipsclass->print->add_output("$this->output");

                $this->page_title = $this->ipsclass->lang['aw_welcome'] . $this->page_title;

                $this->ipsclass->print->do_output( array( 'TITLE' => $this->page_title, 'JS' => 1, NAV => $this->nav ) );

        }

        /*-------------------------------------------------------------------------*/
        // Find Member form
        /*-------------------------------------------------------------------------*/

        function find_form()
        {


                 //-----------------------------------------
                 // get form header
                 //-----------------------------------------
                 $this->output .= $this->awards_lib->html_start_form( array( 1 => array( 'inc'   , 'awardscp'),
                                                                             2 => array( 'CODE'  , 'do_findmember'),
                                                                    )      );


                 //-----------------------------------------
                 // Need notification or not?
                 //-----------------------------------------

                 $this->output .= $this->ipsclass->compiled_templates['skin_awards_cp']->find_member_form(   );


        }

        /*-------------------------------------------------------------------------*/
        // Do find member
        /*-------------------------------------------------------------------------*/

        function do_findmember()
        {

                //-----------------------------------------
                // Nawty, Nawty!
                //-----------------------------------------

                if ($this->ipsclass->input['auth_key'] != $this->md5_check )
                {
                        $this->awards_lib->award_error('del_post');
                }

                 $this->ipsclass->input['entered_name'] = trim($this->ipsclass->input['entered_name']);

                 if($this->ipsclass->input['entered_name'] == '')
                 {
                         $this->awards_lib->award_error('not_enter_name');
                 }

                 $this->ipsclass->DB->simple_construct( array( 'select' => 'id, members_display_name as name', 'from' => 'members', 'where' => "name LIKE '".$this->ipsclass->input['entered_name']."%' OR members_display_name LIKE '".$this->ipsclass->input['entered_name']."%'" ) );
                 $this->ipsclass->DB->simple_exec();

                 if (! $this->ipsclass->DB->get_num_rows() )
                 {
                         $this->awards_lib->award_error('not_find_member');
                 }

                 //-----------------------------------------
                 // Show possible matches
                 //-----------------------------------------

                 $select_html = '';

                 while ( $r = $this->ipsclass->DB->fetch_row() )
                 {
                         $select_html .= "<option value='{$r['id']}'>{$r['name']}</option>";
                 }

                 //-----------------------------------------
                 // get form header
                 //-----------------------------------------
                 $this->output .= $this->awards_lib->html_start_form( array( 1 => array( 'inc'   , 'awardscp'),
                                                                             2 => array( 'CODE'  , 'go_to_awardscp'),
                                                                    )      );

                 //-----------------------------------------
                 // Need notification or not?
                 //-----------------------------------------

                 $this->output .= $this->ipsclass->compiled_templates['skin_awards_cp']->find_resault(  $select_html  );



        }


        /*-------------------------------------------------------------------------*/
        // Awards Control Panel
        /*-------------------------------------------------------------------------*/

        function award_control_panel($type='add')
        {

                //-----------------------------------------
                // Nawty, Nawty!
                //-----------------------------------------

                if ($this->ipsclass->input['auth_key'] != $this->md5_check )
                {
                        $this->awards_lib->award_error('del_post');
                }

                if( !$this->ipsclass->member['g_awards_edit'] and $type == 'edit')
                {
                        $this->awards_lib->award_error('del_post');
                }

                if($type == 'add')
                {
                        $this->ipsclass->input['namesearch'] = intval($this->ipsclass->input['namesearch']);

                        if( !$this->ipsclass->input['namesearch'] )
                        {
                                $this->awards_lib->award_error('not_find_member');
                        }

                        $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'members', 'where' => "id=".$this->ipsclass->input['namesearch'] ) );
                        $this->ipsclass->DB->simple_exec();

                        if (! $this->ipsclass->DB->get_num_rows() )
                        {
                                $this->awards_lib->award_error('not_find_member');
                        }

                        $this->mem_info = $this->ipsclass->DB->fetch_row();
                }
                else
                {
                        $this->ipsclass->input['aid'] = intval($this->ipsclass->input['aid']);

                        $this->ipsclass->DB->cache_add_query( 'get_member_award_to_edit' , array( 'aid' => $this->ipsclass->input['aid']), 'awards_sql_queries' );
                        $this->ipsclass->DB->cache_exec_query();

                        if (! $this->ipsclass->DB->get_num_rows() )
                        {
                                $this->awards_lib->award_error('award_not_exists');
                        }

                        $awards_info = $this->ipsclass->DB->fetch_row();

                        $this->mem_info['members_display_name'] = $awards_info['members_display_name'];
                        $this->mem_info['id'] = $awards_info['id'];
                        $this->mem_info['awards_cache'] =  $awards_info['awards_cache'];

                }

                //-----------------------------------------
                // get header
                //-----------------------------------------

                if($type == 'add')
                {
                        $this->output .= $this->awards_lib->html_start_form( array( 1 => array( 'inc'   , 'awardscp'),
                                                                                    2 => array( 'CODE'  , 'do_add_award'),
                                                                                    4 => array( 'mid'   , $this->mem_info['id']  ),
                                                                                    ), " onsubmit='return ValidateForm()'"      );
                }
                else
                {
                        $this->output .= $this->awards_lib->html_start_form( array( 1 => array( 'inc'   , 'awardscp'),
                                                                                    2 => array( 'CODE'  , 'do_edit_award'),
                                                                                    4 => array( 'aid'   , $awards_info['aid']  ),
                                                                                    ), " onsubmit='return ValidateForm()'"      );
                }

                $this->output .= $this->ipsclass->compiled_templates['skin_awards_cp']->acp_header();

                //-----------------------------------------
                // Show member name
                //-----------------------------------------

                $name_html = $this->ipsclass->compiled_templates['skin_awards_cp']->member_name_row($this->mem_info['members_display_name']);

                $this->output .= $this->ipsclass->compiled_templates['skin_awards_cp']->acp_rows( $name_html );

                unset($name_html);

                //-----------------------------------------
                // Get member awards
                //-----------------------------------------

                $this->ipsclass->DB->cache_add_query( 'get_member_award' , array( 'mid' => $this->mem_info['id']), 'awards_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                if($this->ipsclass->DB->get_num_rows())
                {
                        //----------------------------
                        // need rebuild
                        //----------------------------

                        $need_rebuild        = 0;
                        $member_awards_array = unserialize(stripslashes($this->mem_info['awards_cache']));
                        if(!is_array($member_awards_array) or empty($member_awards_array))
                        {
                                $need_rebuild = 1;
                        }

                        while($mem_aw = $this->ipsclass->DB->fetch_row())
                        {

                                if( !$mem_aw['awards_status'] )
                                {
                                        continue;
                                }

                                //-----------------------------------
                                // member can edit awards?
                                //-----------------------------------

                                if( $this->ipsclass->member['g_awards_edit'] )
                                {
                                        $mem_aw['edit_button'] = $this->ipsclass->compiled_templates['skin_awards_cp']->member_awards_edit( $this->md5_check,  $mem_aw['aid'] );
                                }

                                //-----------------------------------
                                // member can delet?
                                //-----------------------------------

                                if( $this->ipsclass->member['g_awards_delete'] )
                                {
                                        $mem_aw['delete_button'] = $this->ipsclass->compiled_templates['skin_awards_cp']->member_awards_delet( $mem_aw['aid'] );
                                }


                                if( $need_rebuild )
                                {
                                        $member_awards_array[ $mem_aw['aid'] ] = array($mem_aw['aid'], $mem_aw['id']);
                                }

                                //----------------------------------
                                // Show mini image
                                //----------------------------------

                                if($mem_aw['img_thumbnail'])
                                {
                                        $mem_aw['img']   = $mem_aw['img_thumbnail'];
                                        $mem_aw['img_w'] = $mem_aw['thumbnail_w'];
                                        $mem_aw['img_h'] = $mem_aw['thumbnail_h'];
                                }

                                $awards_m .= $this->ipsclass->compiled_templates['skin_awards_cp']->member_awards_rows( $mem_aw );
                        }

                        $awards_m = $this->ipsclass->compiled_templates['skin_awards_cp']->member_awards_rows_final( $awards_m );

                        //-------------------------
                        // rebuld members cache
                        //-------------------------

                        if($need_rebuild)
                        {
                                $this->ipsclass->DB->do_update( 'members', array( 'awards_cache' => serialize($member_awards_array), ), 'id='.$this->mem_info['id'] );
                        }
                }
                else
                {
                    $awards_m = $this->ipsclass->compiled_templates['skin_awards_cp']->award_nocontent();
                }

                $this->output .= $this->ipsclass->compiled_templates['skin_awards_cp']->acp_rows( $awards_m );

                unset($awards_m);

                //-----------------------------------------
                // Author row
                //-----------------------------------------

                $author_html = $this->ipsclass->compiled_templates['skin_awards_cp']->author_row( $awards_info['mname'] );
                $this->output .= $this->ipsclass->compiled_templates['skin_awards_cp']->acp_rows( $author_html );

                //-----------------------------------------
                // awards chose rows
                //-----------------------------------------

                $content_img_array = array();

                $this->ipsclass->DB->simple_construct( array( 'select' => 'id, title, img_thumbnail, img', 'from' => 'awards_info', 'where' => 'awards_status=1', 'order' => 'title' ) );
                $this->ipsclass->DB->simple_exec();

                while ($awards = $this->ipsclass->DB->fetch_row())
                {
                        $s = '';
                        if($type == 'edit')
                        {
                                if( $awards['id'] == $awards_info['awards_id'])
                                {
                                        $s = ' selected="selected " ';
                                }
                        }

                        $content .= "<option value='".$awards['id']."'".$s.">".$awards['title']."</option>\n";

                        $awards['img'] = $awards['img_thumbnail'] ? $awards['img_thumbnail'] : $awards['img'];
                        $content_img_array[] = $awards['id'] . ": '".$awards['img']."'" ;
                }

                $awards_js_array_string = implode(',', $content_img_array);

                $awards_list_html = $this->ipsclass->compiled_templates['skin_awards_cp']->awards_list($awards_js_array_string, $content);

                $this->output .= $this->ipsclass->compiled_templates['skin_awards_cp']->acp_rows( $awards_list_html );

                unset($awards_list_html);
                unset($awards_js_array_string);
                unset($content_img_array);

                //-----------------------------------------
                // Show reason form
                //-----------------------------------------

                $this->han_editor->ed_width  = $this->ipsclass->vars['rte_pm_width'] ? $this->ipsclass->vars['rte_pm_width'] : $this->ipsclass->vars['rte_width'];

                if($this->han_editor->method != 'rte')
                {
                        $awards_info['reason'] = $this->parser->pre_edit_parse( $awards_info['reason'] );
                }

                $editor_html  = $this->han_editor->show_editor( $awards_info['reason'], 'Post' );
                $editor_html  = $this->ipsclass->compiled_templates['skin_awards_cp']->reson_form( $editor_html );

                $this->output .= $this->ipsclass->compiled_templates['skin_awards_cp']->acp_rows( $editor_html );

                unset($editor_html);

                //-----------------------------------------
                // get footer
                //-----------------------------------------

                if($type=='add')
                {
                        $button = $this->ipsclass->lang['cp_aw_addnew'];
                        $init_awards = -1;
                }
                else
                {
                        $button = $this->ipsclass->lang['cp_aw_change'];
                        $init_awards = $awards_info['awards_id'];
                }

                $this->output .= $this->ipsclass->compiled_templates['skin_awards_cp']->acp_footer( $button,  $init_awards);

                $this->nav[] = $this->ipsclass->lang['mem_name_acp']." : <b>". $this->mem_info['members_display_name'] . "</b>";

        }

        /*-------------------------------------------------------------------------*/
        // Process add/edit awards
        /*-------------------------------------------------------------------------*/

        function do_awards($type='add')
        {
                //-----------------------------------------
                // Nawty, Nawty!
                //-----------------------------------------

                if ($this->ipsclass->input['auth_key'] != $this->md5_check )
                {
                        $this->awards_lib->award_error('del_post');
                }

                if( !$this->ipsclass->member['g_awards_edit'] and $type == 'edit')
                {
                        $this->awards_lib->award_error('del_post');
                }

                //---------------------------------------
                // Awards System error if not enter reson
                //---------------------------------------

                if(strlen($_POST['Post']) < 2)
                {
                        $this->awards_lib->award_error('error_reson');
                }

                //---------------------------------------
                // Awards System error if not chose award
                //---------------------------------------
                if($this->ipsclass->input['newaward'] == -1 or !intval($this->ipsclass->input['newaward']))
                {
                        $this->awards_lib->award_error('empty_aw');
                }

                $this->ipsclass->input['newaward'] = intval($this->ipsclass->input['newaward']);

                if( !isset($this->ipsclass->cache['awards_img_cache'][ $this->ipsclass->input['newaward'] ]) )
                {
                        $this->awards_lib->award_error('award_not_exists');
                }

                //---------------------------------------
                // Correct member id?
                //---------------------------------------

                if( $type == 'add' )
                {
                        $this->ipsclass->input['mid'] = intval($this->ipsclass->input['mid']);

                        $this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'members', 'where' => "id=".$this->ipsclass->input['mid'] ) );
                        $this->ipsclass->DB->simple_exec();

                        if (! $this->ipsclass->DB->get_num_rows() )
                        {
                                $this->awards_lib->award_error('not_find_member');
                        }

                        $this->mem_info = $this->ipsclass->DB->fetch_row();

                        //----------------------------------
                        // Can add awards him self?
                        //----------------------------------

                        if ( $this->ipsclass->member['id']  == $this->mem_info['id'])
                        {
                                if( !$this->ipsclass->vars['awards_add_self'] )
                                {
                                        $this->awards_lib->award_error('error_rearding_self');
                                        exit();
                                }
                        }

                }
                //---------------------------------------
                // Correct awards id?
                //---------------------------------------
                else
                {
                        $this->ipsclass->input['aid'] = intval($this->ipsclass->input['aid']);

                        $this->ipsclass->DB->cache_add_query( 'get_member_award_to_edit_do' , array( 'aid' => $this->ipsclass->input['aid']), 'awards_sql_queries' );
                        $this->ipsclass->DB->cache_exec_query();

                        if (! $this->ipsclass->DB->get_num_rows() )
                        {
                                $this->awards_lib->award_error('award_not_exists');
                        }

                        $this->mem_info = $this->ipsclass->DB->fetch_row();
                }

                //-----------------------------------------
                // Post process the editor
                // Now we have safe HTML and bbcode
                //-----------------------------------------

                $this->ipsclass->input['Post'] = $this->han_editor->process_raw_post( 'Post' );

                $this->ipsclass->input['Post'] = $this->parser->pre_db_parse($this->ipsclass->input['Post']);


                $this->ipsclass->input['entered_name'] = trim($this->ipsclass->input['entered_name']);

                //-----------------------------------------
                // Save or edit award
                //-----------------------------------------
                if($type == 'add')
                {
                        //--------------------------------------------------
                        // if all parameters enter, insert award,
                        // update member award+1 and insert moderators logs
                        //--------------------------------------------------

                        $this->ipsclass->DB->do_insert( 'awards', array(
                                                                        'mid'                => $this->mem_info['id'],
                                                                        'cid'                => $this->ipsclass->member['id'],
                                                                        'awards_id'          => $this->ipsclass->input['newaward'],
                                                                        'reason'             => $this->ipsclass->input['Post'],
                                                                        'mname'              => $this->ipsclass->input['entered_name'],
                                                                        'add_mem_award_time' => time(),
                                                                        ) );

                        $this_award_id = $this->ipsclass->DB->get_insert_id();

                        //---------------------------------------------------
                        // change personal member information
                        //---------------------------------------------------

                        $member_awards_array = unserialize(stripslashes($this->mem_info['awards_cache']));
                        $member_awards_array[ $this_award_id ] = array( $this_award_id, $this->ipsclass->input['newaward'] );

                        $this->ipsclass->DB->do_update( 'members', array(
                                                                         'awards_dig'   => ($this->mem_info['awards_dig'] + 1),
                                                                         'awards_cache' => serialize($member_awards_array),
                                                                         ), 'id='.$this->mem_info['id'] );
                        /*
                        $this->ipsclass->pack_and_update_member_cache( $this->mem_info['id'],
                                											   array( 'awards_cache' => $member_awards_array,
                                											   		  'awards_dig'   => ($this->mem_info['awards_dig'] + 1),
                                											   		   ),
                                											   $this->mem_info['members_cache'] );
                        */
                        $this->moderate_log("Add award to member: {$this->mem_info['members_display_name']}");
                }
                else
                {

                        //--------------------------------------------------
                        // if all parameters enter update award and insert moderators logs
                        //--------------------------------------------------

                        $this->ipsclass->DB->do_update( 'awards', array( 'awards_id' => $this->ipsclass->input['newaward'],
                                                                         'reason'    => $this->ipsclass->input['Post'],
                                                                         'mname'     => $this->ipsclass->input['entered_name'],
                                                                         'edit_time' => time(),
                                                                         'edit_mid'  => $this->ipsclass->member['id'],
                                                                        ), 'aid='.$this->mem_info['aid'] );



                        //---------------------------------------------------
                        // change personal member information
                        //---------------------------------------------------

                        $member_awards_array = unserialize(stripslashes($this->mem_info['awards_cache']));
                        $member_awards_array[ $this->mem_info['aid'] ] = array( $this->mem_info['aid'], $this->ipsclass->input['newaward'] );

                        $this->ipsclass->DB->do_update( 'members', array( 'awards_cache' => serialize($member_awards_array), ), 'id='.$this->mem_info['id'] );
                        /*
                        $this->ipsclass->pack_and_update_member_cache( $this->mem_info['id'],
                                											   array( 'awards_cache' => $member_awards_array ),
                                											   $this->mem_info['members_cache'] );
                        */
                        $this->moderate_log("Edit member awards: {$this->mem_info['members_display_name']}");

                }


                //-----------------------------
                // send notice
                //-----------------------------

                if($type == 'add')
                {
                        $this->send_notification();
                }

                //-----------------------------------------
                // Redirect..
                //-----------------------------------------

                if($type == 'add')
                {
                        $lang_redirect = $this->ipsclass->lang['awards_secsessful_add'];
                }
                else
                {
                        $lang_redirect = $this->ipsclass->lang['awards_secsessful_edit'];
                }

                $this->ipsclass->print->redirect_screen( $lang_redirect, 'automodule=awards&inc=awardscp&CODE=go_to_awardscp&namesearch='.$this->mem_info['id'].'&auth_key='.$this->ipsclass->return_md5_check() );

        }

        /*-------------------------------------------------------------------------*/
        // Delete Award
        /*-------------------------------------------------------------------------*/

        function award_member_delet()
        {
                $aid = intval($this->ipsclass->input['aid']);

                if ($this->ipsclass->input['auth_key'] != $this->ipsclass->return_md5_check() )
                {
                        $this->awards_lib->award_error('del_post');
                }

                //-----------------------------------------
                // Check Permissions
                //-----------------------------------------

                if ( !$this->ipsclass->member['g_awards_delete'] )
                {
                        $this->awards_lib->award_error('del_post');
                }

                //--------------------------------------
                // rebuild member award
                //--------------------------------------
                $this->ipsclass->DB->cache_add_query( 'delet_member_award_do' , array( 'aid' => $aid ), 'awards_sql_queries' );

                $this->ipsclass->DB->cache_exec_query();

                $member = $this->ipsclass->DB->fetch_row();

                $member['members_cache'] = $this->ipsclass->unpack_member_cache( $member['members_cache'] );

                //--------------------------------------------------
                // Delet Award's Member, insert moderator log
                //--------------------------------------------------

                $this->ipsclass->DB->simple_exec_query( array( 'delete' => 'awards', 'where' => "aid=".$aid) );

                //---------------------------------------------------
                // change personal member information
                //---------------------------------------------------

                $member_awards_array = unserialize(stripslashes($member['awards_cache']));
                unset($member_awards_array[ $aid ]);

                $this->ipsclass->DB->do_update( 'members', array( 'awards_cache' => serialize($member_awards_array),
                                                                  'awards_dig'   => ($member['awards_dig'] - 1),
                                                                  ), 'id='.$member['id'] );
                /*
                $this->ipsclass->pack_and_update_member_cache( $member['id'],
                                							   array( 'awards_cache' => $member_awards_array,
                                									  'awards_dig'   => ($member['awards_dig'] - 1),
                                									),
                                							   $member['members_cache'] );
                */
                $this->moderate_log("Delete member award: {$member['members_display_name']}");

                $this->ipsclass->print->redirect_screen( $this->ipsclass->lang['awards_secsessful_del'], 'automodule=awards&inc=awardscp&CODE=go_to_awardscp&namesearch='.$member['id'].'&auth_key='.$this->ipsclass->return_md5_check() );

        }

        //-----------------------------------------
        // @add_moderate_log: Adds entry to mod log
        // -----------
        // Accepts: (content)
        //-----------------------------------------

        function moderate_log($doing='Unknown')
        {
                $this->ipsclass->DB->do_insert( 'moderator_logs', array (
                                                                     'forum_id'    => 0,
                                                                     'topic_id'    => 0,
                                                                     'post_id'     => 0,
                                                                     'member_id'   => $this->ipsclass->member['id'],
                                                                     'member_name' => $this->ipsclass->member['members_display_name'],
                                                                     'ip_address'  => $this->ipsclass->input['IP_ADDRESS'],
                                                                     'http_referer'=> @$_SERVER['HTTP_REFERER'],
                                                                     'ctime'       => time(),
                                                                     'topic_title' => '',
                                                                     'action'      => $doing,
                                                                     'query_string'=> @$_SERVER['QUERY_STRING'],
                                                                    )  );

        }



        /*-------------------------------------------------------------------------*/
        // function send notification
        /*-------------------------------------------------------------------------*/

        function send_notification()
        {
                require_once( ROOT_PATH."modules/awards/lib/notice.php" );
                $notificator   = new notice_lib( &$this );
                $notificator->ipsclass =& $this->ipsclass;
                $notificator->member_to = $this->mem_info;
                $notificator->send_message();

        }

        /*-------------------------------------------------------------------------*/
        // Parse some errors form Awards System v2.x.x
        /*-------------------------------------------------------------------------*/

        function award_error( $msg )
        {
                $this->awards_lib->award_error( $msg );
        }



}
?>