<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   =============================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   =============================================
|   Web: http://www.game-play.ru
+--------------------------------------------------------------------------
|
|   > Awards System (Award Comments find module)
|   > Script written by SAT
|
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

class findcomment
{
	# Classes
	var $ipsclass;
 	var $awards_lib;

	# Others
	var $post;

    function auto_run_module()
    {
		//-----------------------------------------
		// Find a comment
		//-----------------------------------------

		$com = intval($this->ipsclass->input['com']);

		if ( ! $com )
		{
			$this->awards_lib->award_error( array( LEVEL => 1, MSG => 'missing_files') );
		}

		//-----------------------------------------
		// Get award...
		//-----------------------------------------

  		$this->ipsclass->DB->cache_add_query( 'get_award_comments_xml' , array( 'com' => $com ), 'awards_sql_queries' );

    	$this->ipsclass->DB->cache_exec_query();

     	$award = $this->ipsclass->DB->fetch_row();

		if ( ! $award['aid'] )
		{
			$this->awards_lib->award_error( array( LEVEL => 1, MSG => 'missing_files') );
		}

		//------------------------------------------
		// init comments lib
		//------------------------------------------

		require( ROOT_PATH."modules/awards/lib/comment_view.php" );
		$comments 				= new comment_view();
		$comments->ipsclass 	= &$this->ipsclass;
		$comments->awards_lib   = &$this->awards_lib;

		//-----------------------------------------
		// Got permission?
		//-----------------------------------------

  		if( $award['mid'] == $this->ipsclass->member['id'] )
    	{
          		$own_award = 1;
     	}
      	else
       	{
          		$own_award = 0;
        }

        $this->awards_lib->get_comments_permission( $award, $own_award );

		//-----------------------------------------
		// Moderator?
		//-----------------------------------------

		if ( !$this->awards_lib->comments_mod )
		{
			$queued_query_bit = ' AND approved=1';
		}

		$this->ipsclass->DB->simple_construct( array( 'select' => 'COUNT(*) as comments',
									 				  'from'   => 'awards_comments',
													  'where'  => "award_id=".$award['aid']." AND pid <= ".$com.$queued_query_bit,
											)      );

		$this->ipsclass->DB->simple_exec();

		$ccomments = $this->ipsclass->DB->fetch_row();

		if ( (($ccomments['comments']) % $comments->limit) == 0 )
		{
			$pages = ($ccomments['comments']) / $comments->limit;
		}
		else
		{
			$number = ( ($ccomments['comments']) / $comments->limit );
			$pages = ceil( $number);
		}

		$st = ($pages - 1) * $comments->limit;

		$this->ipsclass->boink_it($this->ipsclass->base_url."automodule=awards&amp;inc=comments&amp;aid={$award['aid']}&st={$st}#com".$com);
 	}
}

?>