<?php
/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/


/**
* Library/Awards System Notification builder
*
*
* @package          Awards System
* @subpackage       Library
* @author           SAT
* @version          2.0.0
* @since            2.0.0 betta1
*/


class notice_lib
{

        var $ipsclass;


        var $member_to = array();
        var $msglib;
        var $class;
        var $email_lib;

        /*-------------------------------------------------------------------------*/
        // Constructor...
        /*-------------------------------------------------------------------------*/

        function notice_lib( &$class )
        {
                //------------------------------
                // Register class...
                //------------------------------

                $this->class = &$class;
        }

        /*-------------------------------------------------------------------------*/
        // function send notification
        /*-------------------------------------------------------------------------*/

        function send_message()
        {
                if(!$this->member_to['id'])
                {
                        return;
                }

                if(!$this->ipsclass->vars['awards_notice'])
                {
                        return;
                }

                //----------------------------------------
                // Member won't notice? .o
                //----------------------------------------

                if($this->member_to['awards_tracker'] != 1)
                {
                        return;
                }

                if( !$this->ipsclass->vars['awards_notice_member_type'] or $this->ipsclass->vars['awards_notice_member_type'] == 0)
                {
                        if( $this->member_to['awards_notice_type'] == 'pm' )
                        {
                                $this->send_pm();
                        }
                        else
                        {
                                $this->send_email();
                        }
                }
                elseif($this->ipsclass->vars['awards_notice_member_type'] == 1)
                {
                        $this->send_pm();
                }
                elseif($this->ipsclass->vars['awards_notice_member_type'] == 2)
                {
                        $this->send_email();
                }
        }


        /*-------------------------------------------------------------------------*/
        // function PM sender
        /*-------------------------------------------------------------------------*/

        function send_pm()
        {

                if( !is_object($this->msglib) )
                {
                        require_once( ROOT_PATH.'sources/lib/func_msg.php' );
                        $this->msglib = new func_msg();
                        $this->msglib->ipsclass =& $this->ipsclass;
                        $this->msglib->init();
                        $this->msglib->register_class( &$this );
                }

                if(trim($this->ipsclass->vars['awards_notice_title']) == '' or trim($this->ipsclass->vars['awards_notice_text']) == '')
                {
                        return;
                }
                else
                {
                        $this->pm_title = $this->ipsclass->vars['awards_notice_title'];
                        $this->pm_text  = $this->ipsclass->vars['awards_notice_text'];
                }

                //to member ID
                $this->msglib->to_by_id = $this->member_to['id'];


                //----------------------------------------
                // replase Member TO name
                //----------------------------------------
                $this->pm_text = preg_replace ( "/%name%/is", $this->member_to['members_display_name'], $this->pm_text );


                //----------------------------------------
                // replase Award name
                //----------------------------------------
                $this->pm_text = preg_replace ( "/%awardtitle%/is",
                                                $this->ipsclass->cache['awards_img_cache'][ $this->ipsclass->input['newaward'] ]['title'],
                                                $this->pm_text );


                $this->pm_text = $this->ipsclass->remove_tags($this->pm_text);
                $this->ipsclass->vars['awards_notice_id'] = intval($this->ipsclass->vars['awards_notice_id']);

                if( !$this->ipsclass->vars['awards_notice_id'] )
                {
                        $this->msglib->from_member = $this->ipsclass->member;
                }
                else
                {
                        $this->ipsclass->DB->cache_add_query( 'get_member_notice' , array( 'mid' => $this->ipsclass->vars['awards_notice_id']), 'awards_sql_queries' );

                        $this->ipsclass->DB->cache_exec_query();

                        $sender = $this->ipsclass->DB->fetch_row();

                        //----------------------------
                        // fix
                        // ~~~~~~~~~~~~~~~~~~
                        // We are have member?
                        //----------------------------

                        if( $sender['id'] )
                        {
                                $this->msglib->from_member = $sender;
                        }
                        else
                        {
                                $this->msglib->from_member = $this->ipsclass->member;
                        }
                }

                $this->msglib->msg_title   = $this->pm_title;
                $this->msglib->msg_post    = $this->pm_text;

                $this->msglib->send_pm( array(  'save_only' => "",
                                                'orig_id'   => "",
                                                'preview'   => 0,
                                                'track'     => 0,
                                                'add_sent'  => 0,
                                                'hide_cc'   => 0
                                           )     );
                /*
                // non show errors...
                if ( $this->msglib->error != "" )
                {
                        $this->msglib->send_form( 0,$this->msglib->error );
                        $this->class->output .= $this->msglib->output;
                        return;
                }
                */

        }


        /*-------------------------------------------------------------------------*/
        // function EMAIL sender
        /*-------------------------------------------------------------------------*/

        function send_email()
        {
                //-----------------------------------------
                // Load the email lib
                //-----------------------------------------

                require_once( ROOT_PATH."sources/classes/class_email.php" );
                $this->email_lib = new emailer();
                $this->email_lib->ipsclass =& $this->ipsclass;
                $this->email_lib->email_init();

                $this->get_email_template( "new_award", $this->member_to['language'] );

                $this->ipsclass->input['entered_name'] = $this->ipsclass->input['entered_name'] ? $this->ipsclass->input['entered_name'] :
                                                                                                  $this->ipsclass->member['members_display_name'];

                $this->email_lib->build_message( array(
                                                       'MEMBER_NAME_TO'  => $this->member_to['members_display_name'],
                                                       'AWARD_NAME'      => $this->ipsclass->cache['awards_img_cache'][ $this->ipsclass->input['newaward'] ]['title'],
                                                       'AUTHOR'          => $this->ipsclass->input['entered_name'],
                                                       'MEMVER_ID_TO'    => $this->member_to['id'],
                                                       ) );

                $this->email_lib->to      = $this->member_to['email'];
                $this->email_lib->send_mail();
        }

        /*-------------------------------------------------------------------------*/
        // function EMAIL sender(comments)
        /*-------------------------------------------------------------------------*/

        function send_comments_notice(  )
        {
                //-----------------------------------------
                // Load the email lib
                //-----------------------------------------

                require_once( ROOT_PATH."sources/classes/class_email.php" );
                $this->email_lib = new emailer();
                $this->email_lib->ipsclass =& $this->ipsclass;
                $this->email_lib->email_init();

                $this->get_email_template( "new_comment", $this->member_to['language'] );

                $this->email_lib->build_message( array(
                                                       'MEMBER_NAME_TO'  => $this->member_to['members_display_name'],
                                                       'AWARD_NAME'      => $this->member_to['title'],
                                                       'AWARD_ID'        => $this->member_to['aid'],
                                                       'POSTER'          => $this->ipsclass->member['members_display_name'],
                                                       'MEMVER_ID_TO'    => $this->member_to['id'],
                                                       ) );

                $this->email_lib->to      = $this->member_to['email'];
                /*
				$this->ipsclass->DB->do_insert( 'mail_queue', array( 'mail_to'      => $this->member_to['email'],
																	 'mail_date'    => time(),
																	 'mail_subject' => $this->ipsclass->lang['aw_subject'],
																	 'mail_content' => $this->email_lib->message ) );
				*/
				$this->ipsclass->DB->do_update( 'awards', array( 'comments_mail_last_send' => time() ), 'aid='.$this->member_to['aid'] );
                $this->email_lib->send_mail();
        }


        /*-------------------------------------------------------------------------*/
        // get_template:
        // Queries the database, and stores the template we wish to use in memory
        /*-------------------------------------------------------------------------*/

        function get_email_template($name="", $language="")
        {
                //-----------------------------------------
                // Check..
                //-----------------------------------------

                if ($name == "")
                {
                        $this->email_lib->error++;
                        $this->email_lib->fatal_error("A valid email template ID was not passed to the email library during template parsing", "");
                }

                //-----------------------------------------
                // Default?
                //-----------------------------------------

                if ( $this->ipsclass->vars['default_language'] == "")
                {
                        $this->ipsclass->vars['default_language'] = 'en';
                }

                if ($language == "")
                {
                        $language = $this->ipsclass->vars['default_language'];
                }

                //-----------------------------------------
                // Check and get
                //-----------------------------------------

                if ( ! file_exists($this->root_path."cache/lang_cache/$language/lang_awards_emails.php") )
                {
                        require_once( $this->root_path."cache/lang_cache/".$this->ipsclass->vars['default_language']."/lang_awards_emails.php" );
                }
                else
                {
                        require_once( $this->root_path."cache/lang_cache/$language/lang_awards_emails.php" );
                }

                //-----------------------------------------
                // Stored KEY?
                //-----------------------------------------

                if ( ! isset($lang[ $name ]) )
                {
                        if ( $language == $this->ipsclass->vars['default_language'] )
                        {
                                $this->email_lib->fatal_error("Could not find an email template with an ID of '$name'", "");
                        }
                        else
                        {
                                require_once( $this->root_path."cache/lang_cache/".$this->ipsclass->vars['default_language']."/lang_awards_emails.php" );

                                if ( ! isset($lang[ $name ]) )
                                {
                                        $this->email_lib->fatal_error("Could not find an email template with an ID of '$name'", "");
                                }
                        }
                }

                //-----------------------------------------
                // Subject?
                //-----------------------------------------

                if ( isset( $lang[ 'subject__'. $name ] ) )
                {
                        $this->email_lib->lang_subject = stripslashes($lang[ 'subject__'. $name ]);
                }

                //-----------------------------------------
                // Return
                //-----------------------------------------

                $this->email_lib->template = stripslashes($lang['header']) . stripslashes($lang[ $name ]) . stripslashes($lang['footer']);
        }

}
?>
