<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   =============================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   =============================================
|   Web: http://www.game-play.ru
+--------------------------------------------------------------------------
|
|   > Awards System Statistics script
|   > Script written by SAT
|
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
        exit();
}

class awards_statistics
{
        var $ipsclass;
        var $awards_lib;
        var $lib;

        var $output         = "";
        var $nav            = "";
        var $page_title     = "";
        var $mid            = array();

        var $limit_end      = 10;
        var $mem_limit      = 25;
        var $first          = 0;
        var $awards_in_line = 5;
        var $sort_key_value = 'title';

        /*-------------------------------------------------------------------------*/
        // Autorun....
        /*-------------------------------------------------------------------------*/

        function auto_run_module( )
        {
                // Have access to stats

                if ( strstr( ','.$this->ipsclass->vars['awards_perm'].',', ','.$this->ipsclass->member['mgroup'].',' ) )
                {
                        $this->award_error('error_non_show');
                }

                //-----------------------------------------
                // Load HTML
                //-----------------------------------------

                $this->ipsclass->load_template( 'skin_awards_list' );


                //--------------------------------------------
                // Prep form check
                //--------------------------------------------

                switch($this->ipsclass->input['CODE'])
                {
                        case 'list':
                                $this->list_awards();
                                break;
                        case 'memname':
                                $this->list_members();
                                break;
                        case 'personal':
                                $this->list_personal();
                                break;
                        default:
                                ($this->ipsclass->vars['awards_default_sort'] == 'name') ? $this->list_members() :
                                                                                           $this->list_awards();
                                break;
                }


                $this->ipsclass->print->add_output("$this->output");

                $this->ipsclass->print->do_output( array( 'TITLE' => $this->page_title, 'JS' => 1, NAV => $this->nav ) );

        }

        /*-------------------------------------------------------------------------*/
        // List member Statistics
        /*-------------------------------------------------------------------------*/

        function list_personal()
        {

                $this->ipsclass->input['MID'] = intval($this->ipsclass->input['MID']);

                $this->ipsclass->DB->simple_construct( array( 'select' => 'id, members_display_name as name, mgroup, awards_comments',
                											  'from' => 'members',
                											  'where' => "id=".$this->ipsclass->input['MID'] ) );
                $this->ipsclass->DB->simple_exec();

                if (! $this->ipsclass->DB->get_num_rows() )
                {
                         $this->awards_lib->award_error('not_find_member');
                }

                $this->mid = $this->ipsclass->DB->fetch_row();

                $this->awards_lib->get_comments_permission( $this->mid );

                $this->ipsclass->DB->cache_add_query( 'get_member_award_personal', array( 'mid' => $this->mid['id'] ), 'awards_sql_queries' );
                $this->ipsclass->DB->cache_exec_query();

                while ($awards = $this->ipsclass->DB->fetch_row())
                {
                        if( !$awards['mname'] )
                        {
                        	    $awards['mname'] = $this->ipsclass->make_profile_link( $awards['members_display_name'],  $awards['cid']);
                                //$awards['mname'] = $awards['members_display_name'];
                        }
                        if( $this->awards_lib->comments_enable )
                        {
                        	$this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->personal_row_comments($awards);
                        }
                        else
                        {
                        	$this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->personal_row($awards);
                        }
                }


                if( !$this->awards_lib->comments_enable )
                {
                	$this->output = $this->ipsclass->compiled_templates['skin_awards_list']->personal_list( $this->mid['name'], $this->output );
                }
                else
                {
                	$this->output = $this->ipsclass->compiled_templates['skin_awards_list']->personal_list_comments( $this->mid['name'], $this->output );
                }


                $this->page_title = $this->ipsclass->lang['stats_forums_awards']." -> ".$this->ipsclass->lang['stats_forums_awards'];
                $this->nav[] = "<a href='".$this->ipsclass->base_url."automodule=awards&amp;inc=idx&amp;CODE=memname'>".$this->ipsclass->lang['stats_forums_awards']."</a>";
                $this->nav[] = "<a href='".$this->ipsclass->base_url."automodule=awards&amp;inc=idx&amp;CODE=personal&amp;MID={$this->ipsclass->input['MID']}'>".$this->ipsclass->lang['members_awards_stat']." : ".$this->mid['name']."</a>";
        }

        /*-------------------------------------------------------------------------*/
        // List awards Statistics
        /*-------------------------------------------------------------------------*/

        function list_awards()
        {

                //---------------------------
                // INIT
                //---------------------------

                $this->first         = intval($this->ipsclass->input['st']);
                $this->first         = ($this->first > 0) ? $this->first : 0;

                $awards_ids          = array();
                $members             = array();
                $awards_reawardings  = array();

                $sort_order       = array( 'desc', 'asc' );
                $show_aw          = array( 'reawards', 'all' );

                $show_aw_value    = $this->ipsclass->select_var( array( 1 => $this->ipsclass->input['show_awards'],
                                                                        2 => $this->ipsclass->vars['awards_sort_img'],
                                                                        3 => 'all'
                                                                        ) );

                $sort_order_value = $this->ipsclass->input['sort_order']  ? $this->ipsclass->input['sort_order']  : 'desc';

                //-----------------------------------------
                // Build lists
                //-----------------------------------------

                $oo = "<option ";
                $oc = "</option>\n";

                foreach( $show_aw as $k )
                {
                        $s = "";

                        if ( $show_aw_value == $k )
                        {
                                $s = ' selected="selected" ';
                        }

                        $show_aw_html .= $oo.'value="'.$k.'"'.$s.'>'.$this->ipsclass->lang['show_awards_'.$k].$oc;
                }

                foreach( $sort_order as $k )
                {
                        $s = "";

                        if ( $sort_order_value == $k )
                        {
                                $s = ' selected="selected" ';
                        }

                        $sort_order_html .= $oo.'value="'.$k.'"'.$s.'>'.$this->ipsclass->lang['awards_order_'.$k].$oc;
                }


                //---------------------------
                // count all awards
                //---------------------------

                if($show_aw_value == 'all')
                {
                        $count_all = count( $this->ipsclass->cache['awards_img_cache'] );
                }
                else
                {
                        $this->ipsclass->DB->cache_add_query( 'get_awards_stats_count' , array( ), 'awards_sql_queries' );
                        $this->ipsclass->DB->cache_exec_query();
                        while( $max = $this->ipsclass->DB->fetch_row() )
                        {
                                $count_all += 1;
                        }
                }

                $links = $this->ipsclass->build_pagelinks(  array( 'TOTAL_POSS'  => $count_all,
                                                                   'PER_PAGE'    => $this->limit_end,
                                                                   'CUR_ST_VAL'  => $this->first,
                                                                   'L_SINGLE'     => "",
                                                                   'L_MULTI'      => $this->ipsclass->lang['pages'],
                                                                   'BASE_URL'     => $this->ipsclass->base_url."automodule=awards&amp;inc=idx&amp;CODE=list&amp;sort_order=$sort_order_value&amp;show_awards=$show_aw_value"
                                                                                                                 )
                                                                                                  );

                $this->ipsclass->lang['sort_key_title'] = $this->ipsclass->compiled_templates['skin_awards_list']->select_menu( $this->ipsclass->lang['sort_key_title'] );
                $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->awards_header( $links );
                $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->table_img_header();

                if( $show_aw_value == 'all' )
                {
                        $this->ipsclass->DB->simple_construct( array( 'select' => 'id',
                                                                      'from'   => 'awards_info',
                                                                      'where'  => 'awards_status=1',
                                                                      'order'  => "title ".$sort_order_value,
                                                                      "limit"  => array($this->first, $this->limit_end)) );

                        $this->ipsclass->DB->simple_exec();
                }
                else
                {
                        $this->ipsclass->DB->cache_add_query( 'get_awards_stats' , array( 'limit_a'    => $this->first,
                                                                                          'limit_b'    => $this->limit_end,
                                                                                          'sort_order' => $sort_order_value),
                                                                                   'awards_sql_queries' );

                        $this->ipsclass->DB->cache_exec_query();

                }


                while( $row = $this->ipsclass->DB->fetch_row() )
                {
                        $awards_ids[] = $row['id'];
                }

                if( count($awards_ids) < 1 )
                {
                        $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->no_content( );
                }
                else
                {
                        $this->ipsclass->DB->cache_add_query( 'get_awards_list' , array( 'ids' => $awards_ids ), 'awards_sql_queries' );
                        $this->ipsclass->DB->cache_exec_query();

                        while( $row = $this->ipsclass->DB->fetch_row() )
                        {
                                if( !$members_name[ $row['mid'] ]['name'] )
                                {
                                        $row['prefix'] = $this->ipsclass->cache['group_cache'][ $row['mgroup'] ]['prefix'];
                                        $row['suffix'] = $this->ipsclass->cache['group_cache'][ $row['mgroup'] ]['suffix'];
                                        $members[ $row['mid'] ]['name'] = $this->ipsclass->make_profile_link($row['prefix'].$row['members_display_name'].$row['suffix'],$row['mid']);
                                }

                                $members[ $row['mid'] ]['awards'][ $row['awards_id'] ] += 1;

                                if( !$awards_reawardings[ $row['awards_id'] ][ $row['mid'] ] )
                                {
                                        $awards_reawardings[ $row['awards_id'] ][ $row['mid'] ]  = $row['mid'];
                                }
                        }

                        foreach($awards_ids as $ids => $data )
                        {
                                $award = $this->ipsclass->cache['awards_img_cache'][ $data ];

                                if( count( $awards_reawardings[ $data ] ) )
                                {
                                        foreach( $awards_reawardings[ $data ] as $_id => $mem )
                                        {
                                                $award['members'] .= $members[ $mem ]['name'];

                                                if( $members[ $mem ]['awards'][ $data ] > 1)
                                                {
                                                        $award['members'] .= " (x".$members[ $mem ]['awards'][ $data ].")";
                                                }

                                                $award['members'] .= ", ";
                                        }

                                        $award['members'] = preg_replace("#, $#", "", $award['members']);
                                }
                                else
                                {
                                        $award['members'] = $this->ipsclass->lang['no_reawards'];
                                }

                                $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->awards_rows( $award );

                        }
                }


                $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->Page_end( $links, $sort_order_html, $show_aw_html );

                $this->page_title = $this->ipsclass->lang['stats_forums_awards'];
                $this->nav[] = "<a href='".$this->ipsclass->base_url."automodule=awards&amp;inc=idx&amp;CODE=list'>".$this->ipsclass->lang['stats_forums_awards']."</a>";

        }

        /*-------------------------------------------------------------------------*/
        // List all members Statistics
        /*-------------------------------------------------------------------------*/

        function list_members()
        {
                //---------------------------
                // INIT
                //---------------------------

                $this->first         = intval($this->ipsclass->input['st']);
                $this->first         = ($this->first > 0) ? $this->first : 0;

                $this->ipsclass->load_template( 'skin_awards_personal' );

                $sort_order       = array( 'desc', 'asc' );
                $sort_key         = array( 'count', 'name' );

                $sort_order_value = $this->ipsclass->input['sort_order']  ? $this->ipsclass->input['sort_order']  : 'desc';

                $sort_key_value = $this->ipsclass->select_var( array(  1 => $this->ipsclass->input['sort_key'],
                                                                       2 => $this->ipsclass->vars['awards_sort_mem'],
                                                                       3 => 'count'
                                                                       ) );

                //-----------------------------------------
                // Build lists
                //-----------------------------------------

                $oo = "<option ";
                $oc = "</option>\n";


                foreach( $sort_order as $k )
                {
                        $s = "";

                        if ( $sort_order_value == $k )
                        {
                                $s = ' selected="selected" ';
                        }

                        $sort_order_html .= $oo.'value="'.$k.'"'.$s.'>'.$this->ipsclass->lang['awards_order_'.$k].$oc;
                }

                foreach( $sort_key as $k )
                {
                        $s = "";

                        if ( $sort_key_value == $k )
                        {
                                $s = ' selected="selected" ';
                        }

                        $sort_key_html .= $oo.'value="'.$k.'"'.$s.'>'.$this->ipsclass->lang['sort_key_'.$k].$oc;
                }

                switch ($sort_key_value)
                {
                        case 'count':
                                $db_key = "count";
                                break;
                        case 'name':
                                $db_key = "m.members_display_name";
                                break;
                        default:
                                $db_key = "count";
                                break;
                }

                $this->ipsclass->DB->cache_add_query( 'get_mem_stats_count' , array( ), 'awards_sql_queries' );
                $this->ipsclass->DB->cache_exec_query();

                while($r = $this->ipsclass->DB->fetch_row())
                {
                        $max['total_members'] += 1;
                }


                $links = $this->ipsclass->build_pagelinks(  array( 'TOTAL_POSS'  => $max['total_members'],
                                                                   'PER_PAGE'    => $this->mem_limit,
                                                                   'CUR_ST_VAL'  => $this->first,
                                                                   'L_SINGLE'     => "",
                                                                   'L_MULTI'      => $this->ipsclass->lang['pages'],
                                                                   'BASE_URL'     => $this->ipsclass->base_url."automodule=awards&amp;inc=idx&amp;CODE=memname&amp;sort_order=$sort_order_value&amp;show_mem=$show_mem_value"
                                                                                                                 )
                                                                                                  );


                $this->ipsclass->lang['sort_key_name'] = $this->ipsclass->compiled_templates['skin_awards_list']->select_menu( $this->ipsclass->lang['sort_key_name'] );
                $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->awards_header( $links );
                $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->table_mem_header();


                if( $max['total_members'] < 1)
                {
                        $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->no_content( 4 );
                }
                else
                {

                        $this->ipsclass->DB->cache_add_query( 'get_mem_stats' , array( 's_order' => $sort_order_value,
                                                                                       's_key'   => $db_key,
                                                                                       'limit_a' => $this->first,
                                                                                       'limit_b' => $this->mem_limit,
                                                                                       ), 'awards_sql_queries' );
                        $this->ipsclass->DB->cache_exec_query();


                        while( $mem = $this->ipsclass->DB->fetch_row() )
                        {
                                $mem['prefix'] = $this->ipsclass->cache['group_cache'][ $mem['mgroup'] ]['prefix'];
                                $mem['suffix'] = $this->ipsclass->cache['group_cache'][ $mem['mgroup'] ]['suffix'];

                                $mem['members_display_name'] = $this->ipsclass->make_profile_link($mem['prefix'].$mem['members_display_name'].$mem['suffix'],$mem['member_id']);

                                $mem['awards_digital'] = $this->member_digital($mem['member_id'], $mem['awards_cache']);

								$this->awards_lib->get_comments_permission( $mem );

								if( $this->awards_lib->comments_enable )
								{
									$get_comments_link = 1;
								}
								else
								{
									$get_comments_link = 0;
								}

                                $mem['awards_img']     = $this->member_image($mem['member_id'], $mem['awards_cache'], $this->awards_in_line, 1, $get_comments_link);

                                $mem['awards_icon']    = "<a href='{$this->ipsclass->base_url}automodule=awards&amp;inc=idx&amp;CODE=personal&amp;MID={$mem['member_id']}'><{MEMBER_AWARDS}></a>";

                                $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->members_row( $mem );
                        }
                }

                $this->output .= $this->ipsclass->compiled_templates['skin_awards_list']->Page_end_Mem( $links, $sort_order_html, $sort_key_html );

                $this->page_title = $this->ipsclass->lang['stats_forums_awards'];
                $this->nav[] = "<a href='".$this->ipsclass->base_url."automodule=awards&amp;inc=idx&amp;CODE=memname'>".$this->ipsclass->lang['stats_forums_awards']."</a>";
        }


    /*-------------------------------------------------------------------------*/
    // Render digital member awards
    /*-------------------------------------------------------------------------*/

    function member_digital($mid = 0, $count = "" )
    {
            $no_awards = 0;

            //------------------------------------
            // Have member?
            //------------------------------------

            if( !$mid )
            {
                    return;
            }


            $images = unserialize(stripslashes($count));
            $count  = 0;

            if( is_array($images) )
            {
                    foreach($images as $id => $data)
                    {
                            $awards = $this->ipsclass->cache['awards_img_cache'][ $data[1] ];

                            if(!$awards['id'])
                            {
                                    continue;
                            }

                            $count ++;
                    }
            }

            if( !$count )
            {
                    $count = $this->ipsclass->lang['awards_no_member'];

                    $no_awards = 1;
            }


            if( ! $this->ipsclass->can_use_fancy_js and !$no_awards)
            {
                    return $this->ipsclass->compiled_templates['skin_awards_personal']->js_link( $mid, $count );
            }
            elseif(!$no_awards)
            {
                    return $this->ipsclass->compiled_templates['skin_awards_personal']->xml_link( $mid, $count );
            }
            else
            {
                    return $count;
            }

    }

    /*-------------------------------------------------------------------------*/
    // Render images member awards
    /*-------------------------------------------------------------------------*/

    function member_image($mid = 0, $images = '', $count_in_line = 5, $need_thumb = 1, $need_link = 1)
    {

            //------------------------------------
            // Have member?
            //------------------------------------

            if( !$mid )
            {
                    return;
            }

            //------------------------------------
            // Have awards?
            //------------------------------------

            if($images == '')
            {
                    return;
            }

            $images = unserialize(stripslashes($images));

            if( ! count($images) )
            {
                    return;
            }

            $content = '';
            $count_in_row = 1;

            foreach($images as $id => $data)
            {
                    $awards = $this->ipsclass->cache['awards_img_cache'][ $data[1] ];

                    if(!$awards['id'])
                    {
                            continue;
                    }

                    if($awards['img_thumbnail'] and $need_thumb)
                    {
                            $awards['img']   = $awards['img_thumbnail'];
                            $awards['img_h'] = $awards['thumbnail_h'];
                            $awards['img_w'] = $awards['thumbnail_w'];
                    }

                    $awards['aid'] = $id;

					if( $need_link )
					{
                    	$content .= $this->ipsclass->compiled_templates['skin_awards_personal']->awards_image_link( $awards );
					}
					else
					{
                    	$content .= $this->ipsclass->compiled_templates['skin_awards_personal']->awards_image( $awards );
                    }

                    if(($count_in_row % $count_in_line) == 0)
                    {
                            $content .= $this->ipsclass->compiled_templates['skin_awards_personal']->break_line( );
                    }

                    $count_in_row ++;
            }


            //-----------------------------------------------
            // remove break line
            //-----------------------------------------------

            $format_br = $this->ipsclass->compiled_templates['skin_awards_personal']->break_line( );
            $content   = preg_replace( "#$format_br$#is", "",  $content );


            return $content;


    }

}
?>