<?php

/*
+--------------------------------------------------------------------------
|   Awards System Module v3.1.0
|   ========================================
|   by SAT
|   (c) 2005 - 2008 Game-Play.ru TEAM
|   http://www.game-play.ru
|   ========================================
|   Email: sat@game-play.ru
+---------------------------------------------------------------------------
*/


/**
* Main content
*
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
        exit();
}

class profile_awards
{
        /**
        * Global IPSCLASS
        * @var        object
        */
        var $ipsclass;

        var $awards_lib;

        /*-------------------------------------------------------------------------*/
        // Return data
        /*-------------------------------------------------------------------------*/

        /**
        * Returns a block of HTML back to the ajax handler
        * which then replaces the inline content with the HTML
        * returned.
        *
        */
        function return_html_block( $member=array() )
        {
                if( !$this->ipsclass->DB->field_exists( "aid", "awards" ) )
                {
                        return $this->ipsclass->lang['err_no_posts_to_show'];
                }

                define( 'AWARDS_PATH', ROOT_PATH.'modules/awards/' );

                $this->ipsclass->load_language( 'lang_awards' );
                $this->ipsclass->load_template( 'skin_awards_xml' );

                //-----------------------------------------
                // Get gallery library and API
                //-----------------------------------------

                require_once( ROOT_PATH.'sources/api/api_core.php' );
                require_once( ROOT_PATH . 'sources/api/awards/api_awards.php' );

                require_once( ROOT_PATH . 'modules/awards/lib/awards_library.php' );
                $this->awards_lib = new awards_lib();
                $this->awards_lib->ipsclass =& $this->ipsclass;

                //-----------------------------------------
                // Create API Object
                //-----------------------------------------

                $awards_api = new api_awards;
                $awards_api->ipsclass = $this->ipsclass;
                $awards_api->awards_lib = & $this->awards_lib;

                //-----------------------------------------
                // Get images
                //-----------------------------------------

                $awards_array = $awards_api->return_awards_data( $member['id'], 0 );

                //-----------------------------------------
                // Get images
                //-----------------------------------------

				if( $member['id'] == $this->ipsclass->member['id'] )
				{
					$own_awards = 1;
				}
				else
				{
					$own_awards = 0;
				}


                $this->awards_lib->get_comments_permission( $member, $own_awards );

                //-----------------------------------------
                // Print pull
                //-----------------------------------------

				$output .= $this->ipsclass->compiled_templates['skin_awards_xml']->xml_profile_top();

                if( is_array( $awards_array ) and count($awards_array) )
                {
                	foreach ($awards_array as $_id => $awards )
            		{
            			if( !$awards['mname'] )
                    	{
                    		$awards['mname'] = $this->ipsclass->make_profile_link( $awards['members_display_name'],  $awards['cid']);
                    	}

                    	$awards['date'] = $this->ipsclass->get_date( $awards['add_mem_award_time'], 'LONG' );

						if( $this->awards_lib->comments_enable )
						{
							$awards['comments'] = $this->ipsclass->compiled_templates['skin_awards_xml']->comments_row( $awards['comments'], $awards['aid'] );
						}
						else
						{
							$awards['comments'] = "";
						}

                   		$output .= $this->ipsclass->compiled_templates['skin_awards_xml']->xml_profile_awards_row( $awards );
            		}

            		$admin_colspan = "colspan='2'";
                }
                else
                {
                	$output       .= $this->ipsclass->compiled_templates['skin_awards_xml']->basic_row( 'awards_mem_none_found' );
                	$admin_colspan = '';
                }

				if ( $this->ipsclass->member['can_access_awcp'] == 1 )
				{
					$output .= $this->ipsclass->compiled_templates['skin_awards_xml']->xml_profile_awards_add( $member['id'], $admin_colspan, $this->ipsclass->return_md5_check() );
				}

				$output .= $this->ipsclass->compiled_templates['skin_awards_xml']->xml_profile_footer();


                //-----------------------------------------
                // Macros...
                //-----------------------------------------

                if ( ! is_array( $this->ipsclass->skin['_macros'] ) OR ! count( $this->ipsclass->skin['_macros'] ) )
            	{
                    $this->ipsclass->skin['_macros'] = unserialize( stripslashes($this->ipsclass->skin['_macro']) );
            	}

                if ( is_array( $this->ipsclass->skin['_macros'] ) )
              	{
                        foreach( $this->ipsclass->skin['_macros'] as $row )
                        {
                                if ( $row['macro_value'] != "" )
                                {
                                        $output = str_replace( "<{".$row['macro_value']."}>", $row['macro_replace'], $output );
                                }
                        }
                }

                $output = str_replace( "<#IMG_DIR#>", $this->ipsclass->skin['_imagedir'], $output );
                $output = str_replace( "<#EMO_DIR#>", $this->ipsclass->skin['_emodir']  , $output );


                return $output;
        }

}


?>
